/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for GLR parsing with Bison,
   Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* This is the parser code for GLR (Generalized LR) parser. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <setjmp.h>

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     prec_lower_than_error = 258,
     prec_if = 259,
     p_else = 260,
     p_and = 261,
     p_array = 262,
     p_begin = 263,
     p_case = 264,
     p_div = 265,
     p_do = 266,
     p_downto = 267,
     p_end = 268,
     p_file = 269,
     p_for = 270,
     p_function = 271,
     p_goto = 272,
     p_if = 273,
     p_in = 274,
     p_label = 275,
     p_mod = 276,
     p_nil = 277,
     p_not = 278,
     p_of = 279,
     p_or = 280,
     p_packed = 281,
     p_procedure = 282,
     p_to = 283,
     p_program = 284,
     p_record = 285,
     p_repeat = 286,
     p_set = 287,
     p_then = 288,
     p_type = 289,
     p_until = 290,
     p_var = 291,
     p_while = 292,
     p_with = 293,
     p_absolute = 294,
     p_abstract = 295,
     p_and_then = 296,
     p_as = 297,
     p_asm = 298,
     p_attribute = 299,
     p_bindable = 300,
     p_const = 301,
     p_constructor = 302,
     p_destructor = 303,
     p_external = 304,
     p_far = 305,
     p_finalization = 306,
     p_forward = 307,
     p_implementation = 308,
     p_import = 309,
     p_inherited = 310,
     p_initialization = 311,
     p_is = 312,
     p_near = 313,
     p_object = 314,
     p_only = 315,
     p_operator = 316,
     p_otherwise = 317,
     p_or_else = 318,
     p_pow = 319,
     p_qualified = 320,
     p_restricted = 321,
     p_shl = 322,
     p_shr = 323,
     p_unit = 324,
     p_uses = 325,
     p_value = 326,
     p_virtual = 327,
     p_xor = 328,
     p_asmname = 329,
     p_c = 330,
     p_c_language = 331,
     p_class = 332,
     p_override = 333,
     p_Addr = 334,
     p_Assigned = 335,
     p_Dispose = 336,
     p_Exit = 337,
     p_FormatString = 338,
     p_New = 339,
     p_Return = 340,
     LEX_INTCONST = 341,
     LEX_INTCONST_BASE = 342,
     LEX_STRCONST = 343,
     LEX_REALCONST = 344,
     LEX_BUILTIN_PROCEDURE = 345,
     LEX_BUILTIN_PROCEDURE_WRITE = 346,
     LEX_BUILTIN_FUNCTION = 347,
     LEX_ID = 348,
     LEX_CARET_WHITE = 349,
     LEX_CARET_LETTER = 350,
     LEX_ASSIGN = 351,
     LEX_RENAME = 352,
     LEX_RANGE = 353,
     LEX_ELLIPSIS = 354,
     LEX_CONST_EQUAL = 355,
     LEX_SYMDIFF = 356,
     LEX_NE = 357,
     LEX_GE = 358,
     LEX_LE = 359,
     LEX_POWER = 360,
     LEX_BPPLUS = 361,
     LEX_BPMINUS = 362,
     LEX_CEIL_PLUS = 363,
     LEX_CEIL_MINUS = 364,
     LEX_FLOOR_PLUS = 365,
     LEX_FLOOR_MINUS = 366,
     LEX_CEIL_MULT = 367,
     LEX_CEIL_DIV = 368,
     LEX_FLOOR_MULT = 369,
     LEX_FLOOR_DIV = 370
   };
#endif
#define prec_lower_than_error 258
#define prec_if 259
#define p_else 260
#define p_and 261
#define p_array 262
#define p_begin 263
#define p_case 264
#define p_div 265
#define p_do 266
#define p_downto 267
#define p_end 268
#define p_file 269
#define p_for 270
#define p_function 271
#define p_goto 272
#define p_if 273
#define p_in 274
#define p_label 275
#define p_mod 276
#define p_nil 277
#define p_not 278
#define p_of 279
#define p_or 280
#define p_packed 281
#define p_procedure 282
#define p_to 283
#define p_program 284
#define p_record 285
#define p_repeat 286
#define p_set 287
#define p_then 288
#define p_type 289
#define p_until 290
#define p_var 291
#define p_while 292
#define p_with 293
#define p_absolute 294
#define p_abstract 295
#define p_and_then 296
#define p_as 297
#define p_asm 298
#define p_attribute 299
#define p_bindable 300
#define p_const 301
#define p_constructor 302
#define p_destructor 303
#define p_external 304
#define p_far 305
#define p_finalization 306
#define p_forward 307
#define p_implementation 308
#define p_import 309
#define p_inherited 310
#define p_initialization 311
#define p_is 312
#define p_near 313
#define p_object 314
#define p_only 315
#define p_operator 316
#define p_otherwise 317
#define p_or_else 318
#define p_pow 319
#define p_qualified 320
#define p_restricted 321
#define p_shl 322
#define p_shr 323
#define p_unit 324
#define p_uses 325
#define p_value 326
#define p_virtual 327
#define p_xor 328
#define p_asmname 329
#define p_c 330
#define p_c_language 331
#define p_class 332
#define p_override 333
#define p_Addr 334
#define p_Assigned 335
#define p_Dispose 336
#define p_Exit 337
#define p_FormatString 338
#define p_New 339
#define p_Return 340
#define LEX_INTCONST 341
#define LEX_INTCONST_BASE 342
#define LEX_STRCONST 343
#define LEX_REALCONST 344
#define LEX_BUILTIN_PROCEDURE 345
#define LEX_BUILTIN_PROCEDURE_WRITE 346
#define LEX_BUILTIN_FUNCTION 347
#define LEX_ID 348
#define LEX_CARET_WHITE 349
#define LEX_CARET_LETTER 350
#define LEX_ASSIGN 351
#define LEX_RENAME 352
#define LEX_RANGE 353
#define LEX_ELLIPSIS 354
#define LEX_CONST_EQUAL 355
#define LEX_SYMDIFF 356
#define LEX_NE 357
#define LEX_GE 358
#define LEX_LE 359
#define LEX_POWER 360
#define LEX_BPPLUS 361
#define LEX_BPMINUS 362
#define LEX_CEIL_PLUS 363
#define LEX_CEIL_MINUS 364
#define LEX_FLOOR_PLUS 365
#define LEX_FLOOR_MINUS 366
#define LEX_CEIL_MULT 367
#define LEX_CEIL_DIV 368
#define LEX_FLOOR_MULT 369
#define LEX_FLOOR_DIV 370




/* Copy the first part of user declarations.  */
#line 63 "parse.y"

#include "gpc.h"

/* A few keywords of some dialects can be parsed as regular identifiers
   and checked from the parser actions => fewer special tokens. */
#define ASSERT_ID(id, location, pseudo_keyword) \
  do if (!IDENTIFIER_IS_BUILT_IN (id, pseudo_keyword) || !PD_ACTIVE (IDENTIFIER_BUILT_IN_VALUE (id))) \
    { yyerror_id (id, &location); YYERROR; } while (0)

enum { od_none, od_uses, od_label, od_const, od_type, od_var, od_routine };
static int check_decl_order (int, int);

extern int main_yyparse (void);
#define yyparse main_yyparse

union yyGLRStackItem;
static void locations (YYLTYPE *, const union yyGLRStackItem *, int);
#define YYLLOC_DEFAULT(DEST, SRC, N) locations (&DEST, SRC, N)
#ifndef GCC_3_4
#define LOCATION_NOTE(LOC) if (current_function_decl) emit_line_note ((LOC).first_file, (LOC).first_line)
#else
#define LOCATION_NOTE(LOC) if (current_function_decl) \
  { \
    location_t loc_aux; \
    loc_aux.file = (LOC).first_file; \
    loc_aux.line = (LOC).first_line; \
    emit_line_note (loc_aux); \
  }
#endif
#define COPYLOC(D, S) /* @@ ? (* (YYLTYPE *) memcpy (&(D), &(S), sizeof (YYLTYPE))) */ (S)

#define YYASSERT gcc_assert
#define YYMALLOC (void *) xmalloc
#define YYREALLOC (void *) xrealloc


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 108 "parse.y"
typedef union YYSTYPE {
  enum tree_code code;
  long itype;
  tree ttype;
} YYSTYPE;
/* Line 186 of glr.c.  */
#line 341 "parse.c"
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{

  int first_line;
  int first_column;
  int last_line;
  int last_column;

} YYLTYPE;
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template,
   here we set the default value of $$ to a zeroed-out value.
   Since the default value is undefined, this behavior is
   technically correct. */
static YYSTYPE yyval_default;

/* Copy the second part of user declarations.  */


/* Line 217 of glr.c.  */
#line 371 "parse.c"

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

/*-----------------.
| GCC extensions.  |
`-----------------*/

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if !defined (__GNUC__) || __GNUC__ < 2 || \
(__GNUC__ == 2 && __GNUC_MINOR__ < 5) || __STRICT_ANSI__
#  define __attribute__(Spec) /* empty */
# endif
#endif

#ifndef YYASSERT
# define YYASSERT(condition) ((void) ((condition) || (abort (), 0)))
#endif

#ifndef ATTRIBUTE_UNUSED
# define ATTRIBUTE_UNUSED __attribute__ ((__unused__))
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8079

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  135
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  280
/* YYNRULES -- Number of rules. */
#define YYNRULES  776
/* YYNRULES -- Number of states. */
#define YYNSTATES  1295
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule. */
#define YYMAXRHS 12
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule. */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   370

#define YYTRANSLATE(YYX)						\
  ((YYX <= 0) ? YYEOF :							\
   (unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   134,     2,
     117,   118,   128,   126,   119,   127,   125,   129,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   120,   116,
     130,   131,   132,     2,   123,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   121,     2,   122,   124,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   133,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     6,     7,     8,    17,    19,    20,
      21,    34,    36,    38,    39,    43,    44,    45,    55,    56,
      63,    64,    65,    74,    75,    83,    84,    92,    93,    94,
     101,   102,   107,   108,   112,   114,   115,   120,   122,   123,
     127,   129,   130,   133,   135,   137,   138,   145,   146,   153,
     154,   159,   164,   168,   170,   174,   176,   179,   181,   185,
     187,   191,   195,   199,   203,   205,   210,   212,   214,   218,
     220,   224,   228,   231,   235,   239,   240,   243,   244,   248,
     250,   254,   258,   263,   265,   267,   269,   273,   278,   280,
     284,   286,   290,   294,   297,   299,   302,   303,   306,   308,
     310,   311,   314,   315,   318,   322,   324,   325,   328,   330,
     332,   334,   335,   338,   340,   341,   344,   346,   350,   352,
     356,   360,   363,   365,   368,   369,   372,   375,   376,   381,
     384,   386,   390,   392,   396,   400,   403,   405,   407,   409,
     412,   414,   419,   428,   430,   433,   434,   443,   445,   447,
     451,   453,   456,   457,   463,   465,   469,   472,   474,   476,
     477,   481,   484,   486,   490,   492,   496,   500,   503,   509,
     510,   517,   521,   522,   532,   533,   543,   549,   556,   563,
     567,   571,   573,   577,   581,   585,   588,   592,   594,   597,
     598,   601,   603,   606,   608,   611,   614,   616,   618,   620,
     622,   624,   627,   631,   635,   637,   641,   643,   647,   651,
     658,   660,   665,   669,   673,   677,   679,   681,   685,   687,
     691,   695,   698,   700,   702,   704,   705,   708,   716,   718,
     721,   723,   727,   731,   735,   738,   743,   744,   750,   754,
     758,   760,   762,   764,   768,   772,   774,   777,   783,   785,
     787,   789,   793,   797,   799,   803,   807,   811,   814,   818,
     823,   826,   829,   832,   836,   838,   840,   842,   845,   849,
     851,   855,   859,   861,   863,   865,   868,   870,   872,   875,
     879,   884,   888,   894,   898,   902,   904,   907,   909,   911,
     913,   915,   918,   921,   923,   925,   927,   931,   935,   936,
     937,   947,   949,   951,   955,   961,   967,   973,   981,   987,
     993,   995,   997,  1001,  1004,  1008,  1009,  1016,  1023,  1030,
    1034,  1037,  1040,  1042,  1046,  1050,  1055,  1057,  1061,  1063,
    1065,  1067,  1071,  1076,  1083,  1085,  1087,  1089,  1091,  1093,
    1096,  1098,  1100,  1103,  1107,  1111,  1117,  1121,  1123,  1127,
    1131,  1135,  1139,  1144,  1149,  1153,  1157,  1163,  1165,  1168,
    1170,  1172,  1175,  1177,  1178,  1180,  1182,  1183,  1186,  1188,
    1190,  1192,  1196,  1198,  1200,  1207,  1215,  1217,  1221,  1225,
    1229,  1235,  1239,  1241,  1243,  1249,  1251,  1255,  1256,  1258,
    1259,  1260,  1266,  1268,  1270,  1271,  1272,  1275,  1277,  1280,
    1282,  1284,  1286,  1287,  1292,  1294,  1297,  1299,  1304,  1309,
    1311,  1318,  1320,  1321,  1328,  1329,  1330,  1339,  1340,  1341,
    1342,  1352,  1353,  1354,  1363,  1364,  1376,  1377,  1387,  1390,
    1393,  1395,  1399,  1401,  1405,  1409,  1411,  1415,  1416,  1424,
    1425,  1430,  1432,  1434,  1435,  1438,  1440,  1444,  1446,  1450,
    1454,  1455,  1462,  1464,  1468,  1472,  1476,  1479,  1481,  1485,
    1489,  1493,  1495,  1497,  1499,  1501,  1504,  1506,  1508,  1511,
    1513,  1518,  1523,  1530,  1538,  1544,  1552,  1562,  1574,  1575,
    1577,  1579,  1581,  1583,  1587,  1592,  1594,  1598,  1600,  1602,
    1606,  1608,  1611,  1615,  1619,  1620,  1625,  1627,  1631,  1635,
    1636,  1641,  1643,  1647,  1651,  1655,  1659,  1663,  1666,  1669,
    1671,  1673,  1675,  1677,  1679,  1681,  1683,  1685,  1687,  1689,
    1691,  1693,  1696,  1698,  1700,  1703,  1705,  1707,  1709,  1711,
    1713,  1715,  1717,  1719,  1721,  1723,  1725,  1727,  1729,  1731,
    1733,  1735,  1737,  1739,  1741,  1743,  1745,  1749,  1752,  1754,
    1756,  1758,  1762,  1766,  1769,  1774,  1779,  1783,  1789,  1792,
    1797,  1803,  1808,  1813,  1820,  1828,  1830,  1835,  1840,  1841,
    1843,  1847,  1849,  1853,  1855,  1859,  1863,  1867,  1869,  1873,
    1879,  1881,  1884,  1888,  1892,  1894,  1896,  1898,  1902,  1906,
    1908,  1915,  1920,  1925,  1929,  1931,  1934,  1938,  1942,  1946,
    1948,  1952,  1956,  1958,  1960,  1964,  1966,  1968,  1972,  1974,
    1978,  1982,  1984,  1986,  1990,  1993,  1997,  1999,  2003,  2007,
    2011,  2013,  2017,  2019,  2021,  2023,  2025,  2027,  2029,  2031,
    2033,  2035,  2037,  2039,  2041,  2043,  2045,  2047,  2049,  2051,
    2053,  2055,  2057,  2059,  2061,  2063,  2065,  2067,  2070,  2072,
    2074,  2076,  2079,  2081,  2083,  2085,  2087,  2089,  2091,  2093,
    2095,  2097,  2099,  2101,  2103,  2105,  2107,  2109,  2111,  2113,
    2115,  2117,  2119,  2121,  2123,  2125,  2127,  2129,  2131,  2133,
    2135,  2137,  2139,  2141,  2143,  2145,  2147,  2149,  2151,  2153,
    2155,  2157,  2159,  2161,  2163,  2165,  2167,  2169,  2173,  2177,
    2181,  2184,  2186,  2190,  2192,  2196,  2198,  2200,  2202,  2204,
    2206,  2208,  2210,  2212,  2214,  2216,  2218,  2220,  2222,  2224,
    2226,  2228,  2230,  2232,  2234,  2236,  2238,  2240,  2242,  2244,
    2246,  2248,  2250,  2252,  2254,  2256,  2258,  2260,  2262,  2264,
    2266,  2268,  2270,  2272,  2274,  2276,  2278,  2280,  2282,  2284,
    2286,  2288,  2290,  2292,  2294,  2296,  2298,  2300,  2302,  2304,
    2306,  2307,  2308,  2309,  2311,  2313,  2315,  2316,  2318,  2320,
    2322,  2324,  2326,  2328,  2330,  2332,  2333
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     136,     0,    -1,    -1,   137,    -1,    -1,    -1,   169,   172,
     138,   179,   189,   139,   297,   412,    -1,   140,    -1,    -1,
      -1,    69,   398,   116,   172,    93,   141,   179,   194,   142,
     157,    13,   412,    -1,   147,    -1,   152,    -1,    -1,   147,
     143,   152,    -1,    -1,    -1,   408,   398,   170,   144,   150,
     116,   145,   154,   412,    -1,    -1,   408,   398,   170,   146,
     154,   412,    -1,    -1,    -1,   408,   398,    93,   148,   170,
     149,   150,   412,    -1,    -1,    93,   151,   173,   116,   179,
     194,    13,    -1,    -1,   408,   398,    53,   116,   153,   154,
     412,    -1,    -1,    -1,   155,   181,   196,   156,   164,    13,
      -1,    -1,    53,   181,   189,   158,    -1,    -1,     8,   159,
     163,    -1,   161,    -1,    -1,   161,    51,   160,   298,    -1,
     164,    -1,    -1,    56,   162,   163,    -1,   298,    -1,    -1,
     165,   167,    -1,   165,    -1,   167,    -1,    -1,    28,     8,
      11,   166,   302,   116,    -1,    -1,    28,    13,    11,   168,
     302,   116,    -1,    -1,    29,   398,   171,   116,    -1,    29,
       1,   171,   116,    -1,   171,   116,   172,    -1,   413,    -1,
     117,   394,   118,    -1,   413,    -1,   275,   116,    -1,   174,
      -1,   173,   116,   174,    -1,     1,    -1,   173,     1,   174,
      -1,   173,   116,     1,    -1,   398,   411,   175,    -1,   117,
     177,   118,    -1,   176,    -1,   176,   117,   177,   118,    -1,
      93,    -1,   178,    -1,   177,   119,   178,    -1,     1,    -1,
     177,     1,   178,    -1,   177,   119,     1,    -1,   397,   188,
      -1,   397,    98,   397,    -1,   407,   397,   188,    -1,    -1,
     180,   181,    -1,    -1,    54,   182,   116,    -1,   183,    -1,
     182,   116,   183,    -1,   182,     1,   183,    -1,   398,   184,
     185,   202,    -1,   413,    -1,    65,    -1,   413,    -1,   117,
     186,   118,    -1,    60,   117,   186,   118,    -1,   187,    -1,
     186,   119,   187,    -1,     1,    -1,   186,     1,   187,    -1,
     186,   119,     1,    -1,   398,   188,    -1,   413,    -1,    97,
     398,    -1,    -1,   189,   190,    -1,   199,    -1,   192,    -1,
      -1,   191,   192,    -1,    -1,   193,   203,    -1,    20,   207,
     116,    -1,   264,    -1,    -1,   194,   195,    -1,   199,    -1,
     203,    -1,   263,    -1,    -1,   196,   197,    -1,   199,    -1,
      -1,   198,   203,    -1,   264,    -1,    70,   200,   116,    -1,
     201,    -1,   200,   119,   201,    -1,   200,     1,   201,    -1,
     398,   202,    -1,   413,    -1,    19,   342,    -1,    -1,   204,
     205,    -1,    46,   209,    -1,    -1,    34,   206,   221,   116,
      -1,    36,   211,    -1,   208,    -1,   207,   119,   208,    -1,
       1,    -1,   207,     1,   208,    -1,   207,   119,     1,    -1,
     207,     1,    -1,   393,    -1,   398,    -1,   210,    -1,   209,
     210,    -1,     1,    -1,   398,   411,   341,   116,    -1,   398,
     405,   120,   229,   100,   372,   217,   116,    -1,   212,    -1,
     211,   212,    -1,    -1,   396,   405,   120,   229,   213,   219,
     214,   116,    -1,     1,    -1,   413,    -1,   214,   116,   215,
      -1,   218,    -1,    49,   350,    -1,    -1,    49,   350,    93,
     216,   342,    -1,   413,    -1,   217,   116,   218,    -1,    74,
     342,    -1,   275,    -1,   261,    -1,    -1,    39,   220,   342,
      -1,    39,     1,    -1,   222,    -1,   221,   116,   222,    -1,
       1,    -1,   221,     1,   222,    -1,   221,   116,     1,    -1,
     221,     1,    -1,   398,   405,   411,   229,   261,    -1,    -1,
     398,   226,   411,   223,   229,   261,    -1,   398,   226,     1,
      -1,    -1,   398,   405,   411,   224,   257,    59,   256,   258,
      13,    -1,    -1,   398,   405,   411,   225,   257,    77,   256,
     258,    13,    -1,   398,   405,   411,    77,   256,    -1,   398,
     405,   411,    77,    98,    13,    -1,   398,   405,   411,    59,
     116,    52,    -1,   117,   227,   118,    -1,   117,     1,   118,
      -1,   228,    -1,   227,   116,   228,    -1,   227,     1,   228,
      -1,   227,   116,     1,    -1,   227,     1,    -1,   394,   120,
     356,    -1,   230,    -1,   229,   275,    -1,    -1,   231,   232,
      -1,   233,    -1,    45,   233,    -1,   355,    -1,    66,   355,
      -1,   356,   234,    -1,   290,    -1,   249,    -1,   253,    -1,
     255,    -1,   236,    -1,   406,   236,    -1,   117,   235,   118,
      -1,   121,   342,   122,    -1,   342,    -1,   235,   119,   342,
      -1,     1,    -1,   235,     1,   342,    -1,   235,   119,     1,
      -1,     7,   121,   238,   122,    24,   230,    -1,   365,    -1,
      14,   237,    24,   230,    -1,    32,    24,   230,    -1,    30,
     240,    13,    -1,    30,     1,    13,    -1,   414,    -1,   413,
      -1,   121,   239,   122,    -1,   239,    -1,   238,   119,   239,
      -1,   238,     1,   239,    -1,   238,     1,    -1,     1,    -1,
     249,    -1,   356,    -1,    -1,   242,   409,    -1,   241,     9,
     245,    24,   246,   409,   244,    -1,   413,    -1,   242,   116,
      -1,   243,    -1,   242,   116,   243,    -1,   242,     1,   243,
      -1,   242,   116,     1,    -1,   242,     1,    -1,   394,   120,
     230,   261,    -1,    -1,   325,   117,   240,   118,   409,    -1,
     398,   120,   356,    -1,   398,   120,   248,    -1,   401,    -1,
     248,    -1,   247,    -1,   246,   116,   247,    -1,   246,     1,
     247,    -1,     1,    -1,   246,     1,    -1,   330,   120,   117,
     240,   118,    -1,   249,    -1,   250,    -1,   252,    -1,   117,
     251,   118,    -1,   117,     1,   118,    -1,   398,    -1,   251,
     119,   398,    -1,   251,     1,   398,    -1,   251,   119,     1,
      -1,   251,     1,    -1,   342,    98,   342,    -1,   406,   342,
      98,   342,    -1,   123,   254,    -1,   124,   254,    -1,    94,
     254,    -1,   410,    46,   254,    -1,   398,    -1,   255,    -1,
     365,    -1,    27,   281,    -1,    16,   281,   284,    -1,   413,
      -1,   117,   356,   118,    -1,   117,     1,   118,    -1,   413,
      -1,    40,    -1,   259,    -1,   259,   260,    -1,     1,    -1,
     413,    -1,   259,    93,    -1,   259,   260,   116,    -1,   394,
     120,   230,   261,    -1,    27,   398,   281,    -1,    16,   398,
     281,   285,   284,    -1,    47,   398,   281,    -1,    48,   398,
     281,    -1,    72,    -1,    72,   342,    -1,    78,    -1,    40,
      -1,   275,    -1,   413,    -1,   262,   372,    -1,   262,     1,
      -1,    71,    -1,    96,    -1,   100,    -1,   268,   116,   270,
      -1,   267,   116,   271,    -1,    -1,    -1,   267,   116,   274,
     265,   181,   191,   266,   297,   116,    -1,   268,    -1,   269,
      -1,    27,   398,   281,    -1,    16,   398,   281,   285,   284,
      -1,    61,   279,   281,   280,   284,    -1,    27,   398,   125,
     398,   281,    -1,    16,   398,   125,   398,   281,   285,   284,
      -1,    47,   398,   125,   398,   281,    -1,    48,   398,   125,
     398,   281,    -1,   274,    -1,   271,    -1,   274,   272,   274,
      -1,    52,   116,    -1,    49,   350,   116,    -1,    -1,    49,
     350,    93,   273,   342,   116,    -1,    49,   350,   116,    74,
     342,   116,    -1,    74,   342,   116,    49,   350,   116,    -1,
      74,   342,   116,    -1,    75,   116,    -1,    76,   116,    -1,
     413,    -1,   274,   275,   116,    -1,   274,   278,   116,    -1,
      44,   117,   276,   118,    -1,   277,    -1,   276,   119,   277,
      -1,   413,    -1,    46,    -1,   398,    -1,   398,   411,   342,
      -1,   398,   117,   342,   118,    -1,   398,   117,   401,   119,
     342,   118,    -1,    50,    -1,    58,    -1,   398,    -1,   389,
      -1,   398,    -1,   411,   398,    -1,   413,    -1,   413,    -1,
     117,   118,    -1,   117,   282,   118,    -1,   117,    99,   118,
      -1,   117,   282,   116,    99,   118,    -1,   117,     1,   118,
      -1,   283,    -1,   282,   116,   283,    -1,   282,     1,   283,
      -1,   282,   116,     1,    -1,   394,   120,   289,    -1,   407,
     394,   120,   289,    -1,   287,    36,   394,   288,    -1,    46,
     394,   288,    -1,    27,   398,   281,    -1,    16,   398,   281,
     285,   284,    -1,   303,    -1,   120,   355,    -1,   414,    -1,
     413,    -1,   286,   398,    -1,   411,    -1,    -1,   413,    -1,
     407,    -1,    -1,   120,   289,    -1,   291,    -1,   290,    -1,
     295,    -1,    34,    24,   342,    -1,   296,    -1,   292,    -1,
       7,   121,   293,   122,    24,   291,    -1,   406,     7,   121,
     294,   122,    24,   356,    -1,   294,    -1,   293,   116,   294,
      -1,   293,     1,   294,    -1,   293,   116,     1,    -1,   398,
      98,   398,   120,   356,    -1,     7,    24,   296,    -1,   356,
      -1,   365,    -1,     8,   403,   298,   404,    13,    -1,   299,
      -1,   298,   116,   299,    -1,    -1,   304,    -1,    -1,    -1,
      36,   300,   212,   301,   299,    -1,   303,    -1,   304,    -1,
      -1,    -1,   305,   306,    -1,   319,    -1,   319,   307,    -1,
     307,    -1,   297,    -1,   333,    -1,    -1,   333,   308,   334,
     342,    -1,    85,    -1,    85,   342,    -1,    82,    -1,    82,
     117,    29,   118,    -1,    82,   117,   401,   118,    -1,   335,
      -1,    38,   320,    11,   403,   302,   404,    -1,   322,    -1,
      -1,   322,     5,   309,   403,   302,   404,    -1,    -1,    -1,
       9,   342,    24,   310,   326,   311,   324,    13,    -1,    -1,
      -1,    -1,    31,   312,   403,   298,    35,   313,   342,   314,
     404,    -1,    -1,    -1,    37,   315,   403,   342,   316,    11,
     302,   404,    -1,    -1,    15,   358,   334,   342,   332,   342,
     317,    11,   403,   302,   404,    -1,    -1,    15,   358,    19,
     342,   318,    11,   403,   302,   404,    -1,    17,   392,    -1,
     392,   120,    -1,   321,    -1,   320,   119,   321,    -1,     1,
      -1,   320,     1,   321,    -1,   320,   119,     1,    -1,   342,
      -1,   342,   120,   398,    -1,    -1,    18,   342,    33,   323,
     403,   302,   404,    -1,    -1,   325,   403,   298,   404,    -1,
       5,    -1,    62,    -1,    -1,   327,   409,    -1,   328,    -1,
     327,   116,   328,    -1,     1,    -1,   327,     1,   328,    -1,
     327,   116,     1,    -1,    -1,   330,   120,   329,   403,   302,
     404,    -1,   331,    -1,   330,   119,   331,    -1,   330,   119,
       1,    -1,   330,     1,   331,    -1,   330,     1,    -1,   341,
      -1,   341,    98,   341,    -1,   341,     1,   341,    -1,   341,
      98,     1,    -1,    28,    -1,    12,    -1,     1,    -1,   358,
      -1,   123,   358,    -1,    96,    -1,   411,    -1,   388,   360,
      -1,    91,    -1,    91,   117,   363,   118,    -1,    81,   117,
     342,   118,    -1,    81,   117,   342,   119,   362,   118,    -1,
      81,   117,   342,   119,   398,   360,   118,    -1,    43,   336,
     117,   352,   118,    -1,    43,   336,   117,   352,   120,   337,
     118,    -1,    43,   336,   117,   352,   120,   337,   120,   337,
     118,    -1,    43,   336,   117,   352,   120,   337,   120,   337,
     120,   340,   118,    -1,    -1,    93,    -1,   413,    -1,   338,
      -1,   339,    -1,   338,   119,   339,    -1,   351,   117,   342,
     118,    -1,   351,    -1,   340,   119,   351,    -1,   342,    -1,
     343,    -1,   343,   383,   343,    -1,   345,    -1,   381,   345,
      -1,   343,   384,   345,    -1,   343,   390,   345,    -1,    -1,
     343,   386,   344,   345,    -1,   347,    -1,   345,   385,   347,
      -1,   345,   391,   347,    -1,    -1,   345,   387,   346,   347,
      -1,   348,    -1,   347,   401,   348,    -1,   348,    64,   348,
      -1,   348,   105,   348,    -1,   347,    57,   356,    -1,   347,
      42,   356,    -1,   382,   348,    -1,   123,   348,    -1,   351,
      -1,   349,    -1,    22,    -1,   378,    -1,   358,    -1,    86,
      -1,    87,    -1,    89,    -1,   413,    -1,   351,    -1,   352,
      -1,   353,    -1,   352,   353,    -1,    88,    -1,    94,    -1,
     124,   354,    -1,    95,    -1,   119,    -1,   125,    -1,   120,
      -1,   116,    -1,   117,    -1,   118,    -1,   121,    -1,   122,
      -1,   126,    -1,   127,    -1,   128,    -1,   129,    -1,   130,
      -1,   131,    -1,   132,    -1,   123,    -1,   124,    -1,   356,
      -1,   357,    -1,   401,    -1,   401,   125,   401,    -1,    92,
     360,    -1,   359,    -1,   400,    -1,   365,    -1,   117,   342,
     118,    -1,   358,   125,   398,    -1,   358,   410,    -1,   358,
     121,   376,   122,    -1,   358,   121,   366,   122,    -1,   359,
     117,   118,    -1,   359,   117,   361,   362,   118,    -1,    55,
     398,    -1,    83,   117,   363,   118,    -1,    80,   117,   361,
     342,   118,    -1,    79,   117,   358,   118,    -1,    84,   117,
     358,   118,    -1,    84,   117,   358,   119,   362,   118,    -1,
      84,   117,   358,   119,   398,   360,   118,    -1,   413,    -1,
     117,   361,   362,   118,    -1,   117,   361,   358,   118,    -1,
      -1,   342,    -1,   362,   119,   342,    -1,     1,    -1,   362,
     119,     1,    -1,   364,    -1,   363,   119,   364,    -1,   363,
       1,   364,    -1,   363,   119,     1,    -1,   342,    -1,   342,
     120,   342,    -1,   342,   120,   342,   120,   342,    -1,    14,
      -1,   367,   409,    -1,   367,   116,   369,    -1,   367,   409,
     371,    -1,   369,    -1,   371,    -1,   368,    -1,   367,   116,
     368,    -1,   376,   120,   372,    -1,   372,    -1,     9,   398,
     120,   342,    24,   370,    -1,     9,   342,    24,   370,    -1,
     121,   366,   122,   409,    -1,    62,   372,   409,    -1,   342,
      -1,   117,   118,    -1,   117,   373,   118,    -1,   121,   366,
     122,    -1,   121,     1,   122,    -1,   375,    -1,   373,   374,
     375,    -1,   373,     1,   375,    -1,   116,    -1,   119,    -1,
     377,   120,   372,    -1,   372,    -1,   377,    -1,   376,   119,
     377,    -1,     1,    -1,   376,     1,   377,    -1,   376,   119,
       1,    -1,   398,    -1,   342,    -1,   342,    98,   342,    -1,
     121,   122,    -1,   121,   379,   122,    -1,   380,    -1,   379,
     119,   380,    -1,   379,     1,   380,    -1,   379,   119,     1,
      -1,   342,    -1,   342,    98,   342,    -1,   126,    -1,   127,
      -1,   106,    -1,   107,    -1,    23,    -1,   102,    -1,   104,
      -1,   103,    -1,   131,    -1,   130,    -1,   132,    -1,    19,
      -1,   126,    -1,   106,    -1,   127,    -1,   107,    -1,    73,
      -1,   101,    -1,   128,    -1,   129,    -1,    10,    -1,    21,
      -1,    67,    -1,    68,    -1,    25,    -1,    25,     5,    -1,
      63,    -1,   133,    -1,     6,    -1,     6,    33,    -1,    41,
      -1,   134,    -1,    90,    -1,     6,    -1,    25,    -1,    23,
      -1,    73,    -1,    67,    -1,    68,    -1,   126,    -1,   106,
      -1,   127,    -1,   107,    -1,   128,    -1,   129,    -1,    10,
      -1,    21,    -1,   105,    -1,    19,    -1,   130,    -1,   411,
      -1,   132,    -1,   102,    -1,   103,    -1,   104,    -1,     6,
      -1,   134,    -1,    25,    -1,   133,    -1,   101,    -1,   391,
      -1,   390,    -1,   108,    -1,   109,    -1,   110,    -1,   111,
      -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,   393,
      -1,   401,    -1,    86,    -1,   395,    -1,   398,    -1,   395,
     119,   398,    -1,   395,     1,   398,    -1,   395,   119,     1,
      -1,   395,     1,    -1,   398,    -1,   396,   119,   398,    -1,
     398,    -1,   398,   125,   398,    -1,   399,    -1,   401,    -1,
      90,    -1,    91,    -1,    92,    -1,    85,    -1,    82,    -1,
      79,    -1,    80,    -1,    84,    -1,    81,    -1,    83,    -1,
      39,    -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,
      74,    -1,    44,    -1,    45,    -1,    75,    -1,    76,    -1,
      77,    -1,    47,    -1,    48,    -1,    49,    -1,    51,    -1,
      53,    -1,    54,    -1,    55,    -1,    56,    -1,    57,    -1,
      59,    -1,    60,    -1,    61,    -1,    63,    -1,    62,    -1,
      78,    -1,    64,    -1,    65,    -1,    66,    -1,    67,    -1,
      68,    -1,    69,    -1,    70,    -1,    71,    -1,    72,    -1,
      73,    -1,   401,    -1,    93,    -1,   402,    -1,    50,    -1,
      52,    -1,    58,    -1,    95,    -1,    -1,    -1,    -1,    26,
      -1,    93,    -1,    93,    -1,    -1,   116,    -1,   124,    -1,
      94,    -1,   123,    -1,   131,    -1,   100,    -1,   125,    -1,
       1,    -1,    -1,     1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   211,   211,   212,   224,   226,   223,   229,   235,   237,
     234,   240,   241,   243,   242,   251,   253,   250,   259,   258,
     265,   267,   264,   274,   273,   281,   280,   286,   288,   286,
     293,   294,   299,   298,   301,   303,   302,   306,   311,   310,
     316,   320,   322,   323,   324,   329,   328,   336,   335,   343,
     344,   346,   351,   356,   357,   362,   363,   367,   368,   370,
     372,   374,   379,   384,   386,   387,   392,   397,   398,   400,
     402,   404,   409,   411,   413,   418,   418,   422,   424,   428,
     429,   430,   435,   440,   441,   445,   446,   448,   453,   454,
     456,   458,   460,   465,   470,   471,   477,   478,   483,   484,
     489,   490,   495,   495,   498,   500,   506,   507,   512,   513,
     514,   520,   521,   526,   527,   527,   530,   535,   540,   541,
     542,   547,   552,   553,   558,   558,   574,   577,   576,   580,
     587,   589,   591,   593,   595,   597,   601,   602,   607,   608,
     609,   613,   615,   624,   625,   630,   629,   654,   659,   660,
     665,   666,   669,   668,   675,   676,   681,   683,   688,   690,
     689,   697,   702,   703,   705,   706,   708,   710,   714,   725,
     724,   736,   739,   738,   743,   742,   750,   757,   763,   772,
     774,   779,   780,   782,   784,   786,   790,   795,   796,   802,
     802,   818,   819,   824,   825,   827,   829,   830,   831,   832,
     834,   835,   840,   842,   850,   853,   855,   857,   859,   864,
     866,   867,   869,   871,   873,   875,   879,   880,   885,   886,
     888,   890,   892,   897,   899,   905,   906,   908,   913,   914,
     918,   919,   921,   923,   925,   929,   935,   936,   941,   943,
     945,   947,   952,   953,   955,   957,   959,   963,   968,   973,
     974,   978,   980,   985,   987,   989,   991,   993,   997,   999,
    1008,  1010,  1012,  1014,  1019,  1021,  1027,  1031,  1033,  1038,
    1039,  1041,  1046,  1047,  1051,  1052,  1054,  1059,  1060,  1062,
    1067,  1069,  1071,  1073,  1075,  1077,  1079,  1081,  1083,  1085,
    1089,  1090,  1092,  1097,  1098,  1100,  1107,  1118,  1121,  1123,
    1120,  1132,  1133,  1137,  1139,  1141,  1151,  1153,  1155,  1157,
    1162,  1163,  1167,  1172,  1174,  1177,  1176,  1180,  1182,  1184,
    1186,  1188,  1193,  1194,  1196,  1201,  1206,  1207,  1212,  1213,
    1215,  1217,  1219,  1221,  1226,  1227,  1231,  1232,  1236,  1237,
    1239,  1244,  1245,  1247,  1249,  1251,  1253,  1258,  1259,  1261,
    1263,  1267,  1269,  1271,  1273,  1275,  1277,  1282,  1284,  1286,
    1290,  1291,  1296,  1298,  1302,  1303,  1308,  1309,  1314,  1315,
    1316,  1320,  1325,  1326,  1330,  1332,  1341,  1342,  1344,  1346,
    1350,  1355,  1360,  1361,  1367,  1372,  1373,  1377,  1379,  1381,
    1383,  1380,  1388,  1390,  1395,  1399,  1399,  1405,  1406,  1407,
    1414,  1415,  1418,  1417,  1421,  1423,  1425,  1427,  1429,  1431,
    1432,  1434,  1437,  1436,  1445,  1447,  1444,  1466,  1468,  1470,
    1465,  1474,  1476,  1473,  1480,  1479,  1484,  1483,  1487,  1492,
    1497,  1498,  1500,  1502,  1504,  1509,  1511,  1517,  1516,  1527,
    1534,  1539,  1541,  1546,  1547,  1552,  1553,  1555,  1557,  1559,
    1565,  1564,  1571,  1572,  1574,  1576,  1578,  1582,  1584,  1586,
    1588,  1593,  1595,  1597,  1602,  1603,  1608,  1609,  1614,  1616,
    1618,  1620,  1622,  1624,  1626,  1628,  1630,  1632,  1638,  1639,
    1644,  1645,  1649,  1650,  1655,  1660,  1662,  1669,  1682,  1684,
    1689,  1690,  1692,  1694,  1697,  1696,  1703,  1704,  1706,  1709,
    1708,  1715,  1716,  1718,  1720,  1722,  1724,  1729,  1731,  1733,
    1734,  1735,  1737,  1738,  1743,  1744,  1745,  1749,  1750,  1754,
    1759,  1761,  1766,  1767,  1768,  1773,  1774,  1774,  1774,  1774,
    1774,  1774,  1774,  1774,  1775,  1775,  1775,  1775,  1775,  1775,
    1775,  1775,  1775,  1779,  1791,  1805,  1806,  1811,  1813,  1817,
    1818,  1820,  1822,  1824,  1826,  1828,  1830,  1832,  1834,  1836,
    1838,  1840,  1842,  1844,  1846,  1851,  1852,  1854,  1863,  1867,
    1869,  1871,  1873,  1878,  1879,  1881,  1883,  1889,  1891,  1893,
    1898,  1903,  1904,  1906,  1908,  1909,  1913,  1914,  1919,  1921,
    1926,  1928,  1933,  1938,  1943,  1945,  1947,  1949,  1951,  1956,
    1957,  1959,  1964,  1965,  1970,  1972,  1977,  1978,  1980,  1982,
    1984,  1989,  1991,  1993,  1998,  2000,  2005,  2006,  2008,  2010,
    2015,  2017,  2024,  2025,  2029,  2030,  2031,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2045,  2046,  2047,  2048,  2049,  2050,
    2054,  2055,  2056,  2057,  2058,  2059,  2063,  2064,  2065,  2066,
    2070,  2071,  2072,  2073,  2077,  2080,  2081,  2082,  2083,  2084,
    2085,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2117,  2118,  2119,  2120,  2124,  2125,
    2126,  2127,  2133,  2134,  2138,  2143,  2148,  2150,  2152,  2158,
    2160,  2164,  2166,  2171,  2172,  2177,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,  2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,
    2216,  2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,
    2226,  2227,  2228,  2232,  2237,  2238,  2239,  2240,  2241,  2245,
    2253,  2258,  2263,  2267,  2272,  2277,  2283,  2284,  2289,  2290,
    2291,  2295,  2296,  2300,  2301,  2307,  2311
};
#endif

#if (YYDEBUG) || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "prec_lower_than_error", "prec_if",
  "p_else", "p_and", "p_array", "p_begin", "p_case", "p_div", "p_do",
  "p_downto", "p_end", "p_file", "p_for", "p_function", "p_goto", "p_if",
  "p_in", "p_label", "p_mod", "p_nil", "p_not", "p_of", "p_or", "p_packed",
  "p_procedure", "p_to", "p_program", "p_record", "p_repeat", "p_set",
  "p_then", "p_type", "p_until", "p_var", "p_while", "p_with",
  "p_absolute", "p_abstract", "p_and_then", "p_as", "p_asm", "p_attribute",
  "p_bindable", "p_const", "p_constructor", "p_destructor", "p_external",
  "p_far", "p_finalization", "p_forward", "p_implementation", "p_import",
  "p_inherited", "p_initialization", "p_is", "p_near", "p_object",
  "p_only", "p_operator", "p_otherwise", "p_or_else", "p_pow",
  "p_qualified", "p_restricted", "p_shl", "p_shr", "p_unit", "p_uses",
  "p_value", "p_virtual", "p_xor", "p_asmname", "p_c", "p_c_language",
  "p_class", "p_override", "p_Addr", "p_Assigned", "p_Dispose", "p_Exit",
  "p_FormatString", "p_New", "p_Return", "LEX_INTCONST",
  "LEX_INTCONST_BASE", "LEX_STRCONST", "LEX_REALCONST",
  "LEX_BUILTIN_PROCEDURE", "LEX_BUILTIN_PROCEDURE_WRITE",
  "LEX_BUILTIN_FUNCTION", "LEX_ID", "LEX_CARET_WHITE", "LEX_CARET_LETTER",
  "LEX_ASSIGN", "LEX_RENAME", "LEX_RANGE", "LEX_ELLIPSIS",
  "LEX_CONST_EQUAL", "LEX_SYMDIFF", "LEX_NE", "LEX_GE", "LEX_LE",
  "LEX_POWER", "LEX_BPPLUS", "LEX_BPMINUS", "LEX_CEIL_PLUS",
  "LEX_CEIL_MINUS", "LEX_FLOOR_PLUS", "LEX_FLOOR_MINUS", "LEX_CEIL_MULT",
  "LEX_CEIL_DIV", "LEX_FLOOR_MULT", "LEX_FLOOR_DIV", "';'", "'('", "')'",
  "','", "':'", "'['", "']'", "'@'", "'^'", "'.'", "'+'", "'-'", "'*'",
  "'/'", "'<'", "'='", "'>'", "'|'", "'&'", "$accept", "program_component",
  "program_component_1", "@1", "@2", "module_declaration", "@3", "@4",
  "@5", "@6", "@7", "@8", "interface_module", "@9", "@10",
  "module_interface", "@11", "implementatation_module", "@12",
  "module_block", "@13", "@14", "optional_unit_implementation",
  "optional_unit_init_and_final_part", "@15", "@16", "unit_initialization",
  "@17", "rest_of_unit_constructor", "optional_init_and_final_part",
  "module_constructor", "@18", "module_destructor", "@19",
  "optional_program_heading", "optional_module_parameters",
  "optional_par_id_list", "optional_module_attributes", "export_part_list",
  "export_part", "export_list_or_all", "export_all", "export_list",
  "export_list_item", "optional_import_part", "@20",
  "optional_import_part1", "import_specification_list",
  "import_specification", "optional_qualified",
  "optional_import_qualifier", "import_clause_list", "import_clause",
  "optional_rename", "declarations_and_uses", "declaration_or_uses",
  "any_declaration_part", "any_decl", "@21", "interface_decl_part",
  "interface_decl", "implementation_decls", "implementation_decl", "@22",
  "uses_part", "uses_list", "uses_specification", "optional_unit_filename",
  "simple_decl", "@23", "simple_decl_1", "@24", "label_list", "new_label",
  "constant_definition_list", "constant_definition",
  "variable_declaration_list", "variable_declaration", "@25",
  "optional_variable_directive_list", "variable_directive", "@26",
  "optional_variable_directive_list_no_external",
  "variable_directive_no_external", "absolute_or_value_specification",
  "@27", "type_definition_list", "type_definition", "@28", "@29", "@30",
  "formal_schema_discriminants", "discriminant_specification_list",
  "discriminant_specification", "type_denoter_with_attributes",
  "type_denoter", "@31", "type_denoter_1", "type_denoter_0",
  "actual_schema_discriminants", "discriminant_expression_list",
  "unpacked_structured_type", "direct_access_index_type",
  "array_index_list", "ordinal_index_type", "record_field_list",
  "optional_fixed_part", "fixed_part", "record_section", "rest_of_variant",
  "variant_selector", "variant_list", "variant",
  "new_ordinal_type_non_iso", "new_ordinal_type", "enumerated_type",
  "enum_list", "subrange_type", "new_pointer_type", "pointer_domain_type",
  "new_procedural_type", "object_parent", "optional_abstract",
  "object_field_list", "object_field_list_1", "object_section",
  "optional_value_specification", "var_init", "routine_interface_decl",
  "routine_declaration", "@32", "@33", "routine_or_method_heading",
  "routine_heading", "method_heading",
  "optional_routine_interface_directive_list", "remote_directive_list",
  "remote_directive", "@34", "optional_routine_directive_list",
  "attributes", "attribute_list", "attrib", "bp_directive",
  "operator_identifier", "operator_result_def",
  "optional_formal_parameter_list", "formal_parameter_list",
  "formal_parameter", "resulttype", "optional_result_def",
  "optional_result_equals", "optional_protected",
  "optional_parameter_form", "parameter_form", "type_inquiry",
  "typename_or_conformant_array", "conformant_array",
  "index_type_specification_list", "index_type_specification",
  "open_array", "typename_or_untyped_file", "compound_statement",
  "statement_sequence", "optional_statement_vd", "@35", "@36",
  "optional_statement", "empty_lte", "statement", "@37", "statement_1",
  "unlabelled_statement", "@38", "@39", "@40", "@41", "@42", "@43", "@44",
  "@45", "@46", "@47", "@48", "set_label", "with_list", "with_variable",
  "if_then", "@49", "optional_case_completer", "otherwise",
  "optional_case_element_list", "case_element_list", "case_element", "@50",
  "case_constant_list", "one_case_constant", "for_direction",
  "start_of_assignment_or_call", "assign", "builtin_procedure_statement",
  "asm_qualifier", "asm_operands", "nonempty_asm_operands", "asm_operand",
  "asm_clobbers", "static_expression", "expression", "simple_expression",
  "@51", "term", "@52", "factor", "primary", "unsigned_number",
  "optional_combined_string", "combined_string", "string_constants",
  "string_constant", "caret_chars", "typename_or_string255", "typename",
  "typename_1", "variable_or_routine_access",
  "variable_or_routine_access_no_builtin_function",
  "builtin_actual_parameter_list", "disable_function_calls",
  "actual_parameter_list", "write_actual_parameter_list",
  "write_actual_parameter", "untyped_file", "structured_constructor_list",
  "field_value_list", "field_value", "variant_part_value",
  "variant_part_value0", "array_value_completer", "component_value",
  "bp_constructor_list", "initializer_separator", "bp_field_value",
  "index_expression_list", "index_expression_item", "set_constructor",
  "set_constructor_element_list", "member_designator", "sign",
  "unary_operator", "relational_operator", "adding_operator",
  "multiplying_operator", "or_operator", "and_operator", "builtin_proc",
  "operator_symbol", "pxsc_adding_operator", "pxsc_multiplying_operator",
  "label", "num_label", "id_list", "id_list1", "id_list_limited",
  "new_quid", "new_identifier", "new_identifier_1", "identifier", "id",
  "caret_letter", "pushlevel", "poplevel", "enable_lce", "packed",
  "i_protected", "module", "optional_semicolon", "pointer_char", "equals",
  "dot_or_error", "null", "err", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   135,   136,   136,   138,   139,   137,   137,   141,   142,
     140,   140,   140,   143,   140,   144,   145,   140,   146,   140,
     148,   149,   147,   151,   150,   153,   152,   155,   156,   154,
     157,   157,   159,   158,   158,   160,   158,   158,   162,   161,
     163,   164,   164,   164,   164,   166,   165,   168,   167,   169,
     169,   169,   170,   171,   171,   172,   172,   173,   173,   173,
     173,   173,   174,   175,   175,   175,   176,   177,   177,   177,
     177,   177,   178,   178,   178,   180,   179,   181,   181,   182,
     182,   182,   183,   184,   184,   185,   185,   185,   186,   186,
     186,   186,   186,   187,   188,   188,   189,   189,   190,   190,
     191,   191,   193,   192,   192,   192,   194,   194,   195,   195,
     195,   196,   196,   197,   198,   197,   197,   199,   200,   200,
     200,   201,   202,   202,   204,   203,   205,   206,   205,   205,
     207,   207,   207,   207,   207,   207,   208,   208,   209,   209,
     209,   210,   210,   211,   211,   213,   212,   212,   214,   214,
     215,   215,   216,   215,   217,   217,   218,   218,   219,   220,
     219,   219,   221,   221,   221,   221,   221,   221,   222,   223,
     222,   222,   224,   222,   225,   222,   222,   222,   222,   226,
     226,   227,   227,   227,   227,   227,   228,   229,   229,   231,
     230,   232,   232,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   234,   234,   235,   235,   235,   235,   235,   236,
     236,   236,   236,   236,   236,   236,   237,   237,   238,   238,
     238,   238,   238,   239,   239,   240,   240,   240,   241,   241,
     242,   242,   242,   242,   242,   243,   244,   244,   245,   245,
     245,   245,   246,   246,   246,   246,   246,   247,   248,   249,
     249,   250,   250,   251,   251,   251,   251,   251,   252,   252,
     253,   253,   253,   253,   254,   254,   254,   255,   255,   256,
     256,   256,   257,   257,   258,   258,   258,   259,   259,   259,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     261,   261,   261,   262,   262,   262,   263,   264,   265,   266,
     264,   267,   267,   268,   268,   268,   269,   269,   269,   269,
     270,   270,   271,   272,   272,   273,   272,   272,   272,   272,
     272,   272,   274,   274,   274,   275,   276,   276,   277,   277,
     277,   277,   277,   277,   278,   278,   279,   279,   280,   280,
     280,   281,   281,   281,   281,   281,   281,   282,   282,   282,
     282,   283,   283,   283,   283,   283,   283,   284,   284,   284,
     285,   285,   286,   286,   287,   287,   288,   288,   289,   289,
     289,   290,   291,   291,   292,   292,   293,   293,   293,   293,
     294,   295,   296,   296,   297,   298,   298,   299,   299,   300,
     301,   299,   302,   302,   303,   305,   304,   306,   306,   306,
     307,   307,   308,   307,   307,   307,   307,   307,   307,   307,
     307,   307,   309,   307,   310,   311,   307,   312,   313,   314,
     307,   315,   316,   307,   317,   307,   318,   307,   307,   319,
     320,   320,   320,   320,   320,   321,   321,   323,   322,   324,
     324,   325,   325,   326,   326,   327,   327,   327,   327,   327,
     329,   328,   330,   330,   330,   330,   330,   331,   331,   331,
     331,   332,   332,   332,   333,   333,   334,   334,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   336,   336,
     337,   337,   338,   338,   339,   340,   340,   341,   342,   342,
     343,   343,   343,   343,   344,   343,   345,   345,   345,   346,
     345,   347,   347,   347,   347,   347,   347,   348,   348,   348,
     348,   348,   348,   348,   349,   349,   349,   350,   350,   351,
     352,   352,   353,   353,   353,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   355,   356,   357,   357,   358,   358,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   360,   360,   360,   361,   362,
     362,   362,   362,   363,   363,   363,   363,   364,   364,   364,
     365,   366,   366,   366,   366,   366,   367,   367,   368,   368,
     369,   369,   370,   371,   372,   372,   372,   372,   372,   373,
     373,   373,   374,   374,   375,   375,   376,   376,   376,   376,
     376,   377,   377,   377,   378,   378,   379,   379,   379,   379,
     380,   380,   381,   381,   382,   382,   382,   383,   383,   383,
     383,   383,   383,   383,   384,   384,   384,   384,   384,   384,
     385,   385,   385,   385,   385,   385,   386,   386,   386,   386,
     387,   387,   387,   387,   388,   388,   388,   388,   388,   388,
     388,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   389,   389,   390,   390,   390,   390,   391,   391,
     391,   391,   392,   392,   393,   394,   395,   395,   395,   395,
     395,   396,   396,   397,   397,   398,   399,   399,   399,   399,
     399,   399,   399,   399,   399,   399,   399,   399,   399,   399,
     399,   399,   399,   399,   399,   399,   399,   399,   399,   399,
     399,   399,   399,   399,   399,   399,   399,   399,   399,   399,
     399,   399,   399,   399,   399,   399,   399,   399,   399,   399,
     399,   399,   399,   400,   401,   401,   401,   401,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   409,   410,   410,
     410,   411,   411,   412,   412,   413,   414
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     0,     0,     8,     1,     0,     0,
      12,     1,     1,     0,     3,     0,     0,     9,     0,     6,
       0,     0,     8,     0,     7,     0,     7,     0,     0,     6,
       0,     4,     0,     3,     1,     0,     4,     1,     0,     3,
       1,     0,     2,     1,     1,     0,     6,     0,     6,     0,
       4,     4,     3,     1,     3,     1,     2,     1,     3,     1,
       3,     3,     3,     3,     1,     4,     1,     1,     3,     1,
       3,     3,     2,     3,     3,     0,     2,     0,     3,     1,
       3,     3,     4,     1,     1,     1,     3,     4,     1,     3,
       1,     3,     3,     2,     1,     2,     0,     2,     1,     1,
       0,     2,     0,     2,     3,     1,     0,     2,     1,     1,
       1,     0,     2,     1,     0,     2,     1,     3,     1,     3,
       3,     2,     1,     2,     0,     2,     2,     0,     4,     2,
       1,     3,     1,     3,     3,     2,     1,     1,     1,     2,
       1,     4,     8,     1,     2,     0,     8,     1,     1,     3,
       1,     2,     0,     5,     1,     3,     2,     1,     1,     0,
       3,     2,     1,     3,     1,     3,     3,     2,     5,     0,
       6,     3,     0,     9,     0,     9,     5,     6,     6,     3,
       3,     1,     3,     3,     3,     2,     3,     1,     2,     0,
       2,     1,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     2,     3,     3,     1,     3,     1,     3,     3,     6,
       1,     4,     3,     3,     3,     1,     1,     3,     1,     3,
       3,     2,     1,     1,     1,     0,     2,     7,     1,     2,
       1,     3,     3,     3,     2,     4,     0,     5,     3,     3,
       1,     1,     1,     3,     3,     1,     2,     5,     1,     1,
       1,     3,     3,     1,     3,     3,     3,     2,     3,     4,
       2,     2,     2,     3,     1,     1,     1,     2,     3,     1,
       3,     3,     1,     1,     1,     2,     1,     1,     2,     3,
       4,     3,     5,     3,     3,     1,     2,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     3,     3,     0,     0,
       9,     1,     1,     3,     5,     5,     5,     7,     5,     5,
       1,     1,     3,     2,     3,     0,     6,     6,     6,     3,
       2,     2,     1,     3,     3,     4,     1,     3,     1,     1,
       1,     3,     4,     6,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     3,     3,     5,     3,     1,     3,     3,
       3,     3,     4,     4,     3,     3,     5,     1,     2,     1,
       1,     2,     1,     0,     1,     1,     0,     2,     1,     1,
       1,     3,     1,     1,     6,     7,     1,     3,     3,     3,
       5,     3,     1,     1,     5,     1,     3,     0,     1,     0,
       0,     5,     1,     1,     0,     0,     2,     1,     2,     1,
       1,     1,     0,     4,     1,     2,     1,     4,     4,     1,
       6,     1,     0,     6,     0,     0,     8,     0,     0,     0,
       9,     0,     0,     8,     0,    11,     0,     9,     2,     2,
       1,     3,     1,     3,     3,     1,     3,     0,     7,     0,
       4,     1,     1,     0,     2,     1,     3,     1,     3,     3,
       0,     6,     1,     3,     3,     3,     2,     1,     3,     3,
       3,     1,     1,     1,     1,     2,     1,     1,     2,     1,
       4,     4,     6,     7,     5,     7,     9,    11,     0,     1,
       1,     1,     1,     3,     4,     1,     3,     1,     1,     3,
       1,     2,     3,     3,     0,     4,     1,     3,     3,     0,
       4,     1,     3,     3,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     1,     1,
       1,     3,     3,     2,     4,     4,     3,     5,     2,     4,
       5,     4,     4,     6,     7,     1,     4,     4,     0,     1,
       3,     1,     3,     1,     3,     3,     3,     1,     3,     5,
       1,     2,     3,     3,     1,     1,     1,     3,     3,     1,
       6,     4,     4,     3,     1,     2,     3,     3,     3,     1,
       3,     3,     1,     1,     3,     1,     1,     3,     1,     3,
       3,     1,     1,     3,     2,     3,     1,     3,     3,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       2,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     0,     0,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1
};

/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none). */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     1,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     2,     0,     0,     0,     0,
       0,     0,     0,     1,     2,     0,     1,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     2,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM. */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
static const unsigned short int yydefact[] =
{
      49,     0,     0,   765,     0,     3,     7,    11,    12,   775,
       0,   775,   717,   718,   719,   720,   721,   723,   724,   728,
     729,   730,   756,   731,   757,   732,   733,   734,   735,   736,
     758,   737,   738,   739,   741,   740,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   722,   725,   726,   727,
     742,   712,   713,   715,   711,   716,   714,   710,   707,   708,
     709,   754,   759,   775,   705,   706,   755,     0,     1,     0,
       0,     4,     0,    55,   775,     0,     0,    53,     0,   775,
      14,     0,   775,    75,    56,     0,    20,    18,     0,     0,
       0,   696,    51,    50,     0,     0,   329,     0,   326,   330,
     328,    96,    77,    25,   775,     0,    27,   775,    54,   700,
       0,     8,   325,   775,   772,     0,   771,     0,   102,     0,
      76,    27,    21,    23,     0,     0,    77,    52,   698,   699,
     697,    75,   327,   580,   511,   626,     0,     0,     0,     0,
       0,   514,   515,   522,   516,   775,   523,   624,   625,     0,
       0,     0,     0,   622,   623,     0,   488,   490,   496,   501,
     510,   509,   519,   520,   513,   548,   550,   512,     0,     0,
     549,   753,   331,   753,     0,     0,     0,     0,     0,     0,
       0,     0,    97,    99,   124,    98,   105,     0,   301,   302,
       0,    79,   775,     0,     0,     0,    16,   774,   773,    19,
     111,   106,   558,     0,   568,     0,     0,   568,   547,   565,
       0,   614,   620,     0,   616,   508,   525,   529,   530,   531,
     526,   528,   532,   533,   541,   542,   527,   534,   535,   536,
     537,   538,   539,   540,   524,   332,   633,   646,   648,   638,
     639,   627,   629,   628,   635,   637,   684,   685,   686,   687,
     634,   636,   631,   630,   632,   649,     0,     0,   494,     0,
     650,   642,   643,   652,   644,   645,   688,   689,   690,   691,
     640,   641,   653,     0,   499,     0,     0,     0,     0,     0,
       0,   521,   769,     0,   770,   768,     0,   553,   568,   491,
     507,     0,   775,   132,   694,     0,   130,   136,   137,   775,
       0,     0,   677,   667,   670,   668,   679,   681,   674,   675,
     676,   669,   662,   664,   661,   663,   665,   666,   671,   673,
     680,   678,   775,   337,   683,   682,   336,   672,     0,   118,
     775,   760,     0,   103,     0,   775,     0,    78,    84,   775,
      83,    26,     0,    59,     0,    57,     0,    27,   114,   124,
       0,     0,   577,     0,   573,     0,     0,   551,     0,     0,
       0,   615,   647,   489,   492,     0,   493,   651,   497,     0,
     498,   506,   544,   545,   505,   502,   503,   504,   608,     0,
     734,   741,   712,   713,   716,   714,   775,     0,     0,   594,
       0,   766,   586,   584,   585,   589,     0,   606,   611,   753,
     552,   556,     0,     0,     0,     0,   363,   341,   135,   104,
       0,     0,   303,     0,     0,   775,     0,   117,     0,     0,
     121,   122,   395,     6,   127,     0,     0,   125,   297,   298,
     322,    81,    80,     0,     0,   775,    85,    22,     0,     0,
       0,     0,    41,   112,   124,   113,   116,     0,     0,    30,
     107,   108,   109,   110,     0,   561,     0,     0,     0,   559,
       0,   562,     0,   571,   569,   513,     0,   621,   618,   619,
     617,   495,   500,     0,     0,     0,   594,   766,   595,   594,
     605,     0,   599,     0,   608,   594,     0,     0,     0,   555,
       0,   581,     0,     0,     0,   554,     0,   333,     0,     0,
       0,     0,   764,     0,   342,     0,   347,     0,     0,   365,
     364,   775,     0,     0,   362,   360,   133,   134,   131,   775,
     775,   775,     0,   338,     0,   340,   120,   119,   123,   389,
     761,   385,   388,     0,     0,   147,     0,   143,   762,   701,
     140,   126,   138,   762,   775,   334,     0,   335,     0,     0,
       0,    77,   775,     0,     0,     0,    90,     0,    88,   775,
      82,    60,    61,    58,   106,    66,     0,    62,    64,    17,
       0,     0,    43,    44,   115,   775,   775,    77,     0,   775,
     560,   578,   575,   576,   574,     0,   775,   567,   566,     0,
     546,     0,     0,   767,   593,     0,   602,   596,   603,     0,
       0,   598,     0,   597,   613,   587,   582,     0,   583,   612,
     609,   610,   607,   588,   557,   346,   775,   775,   366,   344,
     775,     0,   343,     0,     0,     0,   363,   776,     0,   304,
     357,   359,   361,   306,   308,   309,   305,   339,     0,   395,
       0,   655,     0,     0,     0,     0,   657,   656,   417,   421,
       0,   478,   659,   660,   658,     0,   406,   404,   654,   469,
       0,   400,   396,   399,   397,   411,   401,   409,   464,   775,
       0,   692,   753,   164,     0,   162,   762,   144,     0,     0,
     139,     0,     0,     0,   518,   517,   313,     0,   320,   321,
     100,   312,   323,   324,     0,     0,    86,     0,     0,    93,
      94,   124,    69,     0,    67,   775,   703,     0,     0,     0,
       0,    29,     0,    42,    96,     0,   296,   311,   310,     0,
     563,     0,   572,   570,     0,   591,     0,   601,   600,   604,
     613,   363,   355,     0,   354,   349,   350,     0,   348,   366,
       0,   763,     0,   351,   369,   368,   373,   370,   372,   382,
     383,     0,     0,     0,   358,   543,   390,   386,   384,     0,
       0,   428,   693,     0,   760,   760,   432,     0,   430,   435,
     479,     0,     0,     0,   405,     0,   465,   398,   412,     0,
     468,   429,   167,     0,     0,     0,     0,   702,   189,   189,
       0,   487,   315,   314,   319,   102,    87,    91,    92,    89,
      95,    24,     0,    63,     0,     0,    72,     0,   775,     0,
      45,    47,   102,    10,   579,   564,     0,     0,     0,   367,
     345,   353,     0,     0,     0,     0,   352,   307,   395,   414,
       0,   466,     0,   467,   437,   395,     0,     0,   760,     0,
       0,     0,     0,     0,     0,     0,   760,     0,   165,   166,
     163,     0,     0,   181,     0,   171,   169,   189,   145,   187,
       0,     0,   141,     0,     0,   775,   101,     0,    70,    71,
      68,    73,   704,    74,    65,   395,   395,    32,    38,    31,
      34,    37,   766,   590,   356,   381,     0,   376,     0,   371,
       0,   391,     0,   426,     0,   760,     0,   422,   433,   395,
     434,   431,   436,     0,   471,     0,   407,   408,   470,   395,
     403,   180,   185,     0,   179,     0,   189,     0,   775,   775,
     775,   775,   775,   188,     0,   580,   775,   775,     0,     0,
       0,     0,   523,     0,   770,   768,   190,   191,   200,   197,
     249,   250,   198,   199,   196,     0,   193,   543,   550,   753,
       0,     0,   215,     0,     0,     0,     0,     0,     0,   392,
     393,     0,   395,   395,    35,   592,     0,     0,     0,     0,
       0,   447,   415,     0,   445,     0,   452,     0,     0,   463,
     462,   461,     0,   395,   418,     0,   761,   474,   775,     0,
     775,   761,   183,   184,   182,   186,   775,     0,     0,     0,
     176,   269,   273,     0,   272,     0,   293,   294,   295,   168,
       0,   290,     0,   775,   158,     0,     0,     0,   216,     0,
     267,     0,     0,     0,     0,   230,     0,   228,   189,   192,
     194,   262,   265,   266,   264,     0,     0,   253,   260,   550,
     525,   261,     0,     0,     0,   195,   201,     0,     0,   775,
     316,   317,   318,   300,    46,    48,    33,    40,    39,   395,
     378,   379,   377,     0,     0,     0,   439,     0,     0,   444,
     456,     0,   450,     0,     0,   760,   424,   761,     0,   395,
     410,     0,   481,   482,     0,   480,   472,     0,   413,   170,
     178,   177,     0,     0,   775,   775,   292,   291,   161,     0,
       0,   148,   222,     0,   218,   223,   224,     0,     0,   189,
     268,   214,   213,     0,   234,     0,   226,   189,   212,   252,
     257,   251,     0,   258,   206,     0,   204,     0,     0,   263,
       0,   154,    36,     0,   374,     0,     0,   441,   442,     0,
     760,   448,   449,   446,   455,   454,   453,   760,   459,   460,
     458,   395,     0,   438,   419,   761,   475,   775,     0,     0,
     473,   271,   270,     0,     0,   160,   146,   221,     0,     0,
     217,   211,     0,   241,   248,     0,   753,   232,   233,   231,
     775,   255,   256,   254,     0,   202,     0,   203,   259,   142,
     380,   375,   416,   395,   395,   761,   760,   761,   423,     0,
     483,     0,   276,     0,   274,   277,     0,   775,     0,   149,
     150,   157,   220,   219,   189,     0,     0,   235,   207,   208,
     205,   155,   761,   761,   427,   395,   420,   476,     0,   484,
     173,     0,     0,   718,   723,   728,   729,   751,   742,   278,
     275,   289,     0,   175,   151,   156,   209,   245,     0,   242,
       0,   239,   238,   440,   451,   761,     0,   485,   775,   775,
     775,   775,   286,   279,   189,   152,   246,   767,   236,     0,
     425,   477,     0,   363,   281,   283,   284,   775,     0,   244,
     243,   227,     0,   225,   486,     0,   280,   153,   225,     0,
     282,     0,   247,   766,   237
};

/* YYPDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     4,     5,    83,   181,     6,   131,   449,    69,   105,
     347,   106,     7,   104,   194,   124,   195,     8,   121,   125,
     126,   442,   578,   879,   962,  1059,   880,   963,  1056,   571,
     572,   875,   573,   876,     9,    87,    88,    71,   344,   345,
     567,   568,   703,   704,   101,   102,   120,   190,   191,   339,
     435,   557,   558,   699,   118,   182,   795,   183,   184,   349,
     450,   348,   443,   444,   185,   328,   329,   420,   452,   334,
     427,   534,   295,   296,   541,   542,   536,   537,   922,  1100,
    1209,  1278,  1130,  1210,  1013,  1099,   674,   675,   916,   919,
     920,   785,   852,   853,   858,   859,   860,   936,   937,  1045,
    1125,   938,  1017,  1103,  1104,  1022,  1023,  1024,  1025,  1281,
    1172,  1248,  1249,  1173,  1105,   940,  1036,   941,   942,  1031,
    1032,  1000,  1003,  1203,  1204,  1240,  1009,  1010,   453,   186,
     551,   867,   187,   188,   189,   716,   428,   552,   863,   429,
     923,    97,    98,   554,   322,   522,   406,   505,   506,   629,
     512,   513,   507,   734,   743,   744,   745,   746,   886,   887,
     747,   748,   661,  1057,   531,   638,   828,   958,   959,   960,
     533,   662,   663,   779,   846,   892,  1066,   764,  1078,  1197,
     765,   985,  1152,   978,   664,   767,   768,   665,   895,  1139,
    1140,   972,   973,   974,  1147,   975,   976,   982,   666,   832,
     667,   771,  1081,  1082,  1083,  1256,   977,   791,   156,   365,
     157,   369,   158,   159,   160,   683,   161,   162,   163,   234,
     946,   749,   372,   164,   165,   208,   351,   466,   353,   354,
     166,   390,   391,   392,   393,   725,   394,   395,   481,   599,
     482,   487,   397,   167,   213,   214,   168,   169,   256,   257,
     273,   258,   274,   669,   323,   259,   275,   670,   297,  1026,
      90,   538,   705,    91,    64,   170,    65,    66,   422,   640,
     679,  1107,   707,    10,   491,   287,   514,   199,   407,   631
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -986
static const short int yypact[] =
{
     463,  6054,  7756,  -986,    84,  -986,  -986,    -2,  -986,    53,
    7756,     9,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,     9,  -986,  -986,  -986,    19,  -986,    15,
     137,  -986,   159,  -986,   236,  7756,   202,  -986,   224,    53,
    -986,  7756,  7642,  -986,  -986,   227,  -986,   305,   238,   333,
     164,  -986,  -986,  -986,   375,   442,  -986,   441,  -986,   259,
    -986,  -986,   450,  -986,     9,   424,  -986,    53,  -986,  7756,
    6139,  -986,  -986,  7642,  -986,  5058,  -986,  5058,   870,  7756,
    -986,  -986,  -986,  -986,   411,    60,   450,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  7756,   456,   465,   481,
     484,  -986,  -986,  -986,  -986,   516,  -986,  -986,  -986,  5058,
    4926,  5279,  2393,  -986,  -986,   519,   942,   479,   808,    16,
    -986,  -986,   228,  -986,   970,   549,  -986,  -986,  5279,  5279,
    -986,   523,  -986,  -986,  7756,  5882,  7756,  7756,  7756,  2554,
    7756,   668,  -986,  -986,  -986,  -986,  -986,   555,  -986,  -986,
      65,  -986,   620,    60,   424,  6224,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  1152,  -986,  5058,  1152,  -986,  -986,  -986,
     584,  -986,   607,    82,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,   703,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  5058,  5279,  -986,  5279,
     680,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  5279,  -986,  5279,   637,   637,  5279,  5279,
    5279,  -986,  -986,  2880,  -986,  -986,  7756,  -986,   619,   479,
    -986,  5058,   548,  -986,  -986,   142,  -986,  -986,  -986,   561,
     624,   626,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,   643,  -986,  -986,  -986,  -986,  -986,   194,  -986,
     744,  -986,    60,  -986,   658,  -986,  7756,  7813,  -986,   208,
    -986,  -986,    60,  -986,   153,  -986,    11,  -986,   778,   854,
     895,  5058,   657,   273,  -986,   804,  3264,  -986,  5058,  5058,
    3314,  -986,  -986,  1113,   479,  5279,   479,  -986,   808,  5279,
     808,  -986,  -986,   644,  -986,  -986,  -986,  -986,  -986,  4755,
    7870,  5108,   670,   673,   675,   691,   601,  4577,  2688,   101,
     712,   681,  -986,  -986,  -986,  -986,    93,  -986,  -986,   702,
    -986,  -986,  3264,   719,  4319,  7756,    57,  -986,  7699,  -986,
    5968,  7756,  -986,  7756,  7756,  7216,  7756,  -986,  7756,  5058,
    -986,  -986,   283,  -986,  -986,  6309,  6394,  -986,  -986,   984,
    -986,  -986,  -986,   729,  6479,   744,  -986,  -986,  7756,  5627,
     408,    60,   821,  -986,  -986,  -986,  -986,  7756,  7756,   802,
    -986,  -986,  -986,  -986,   741,  -986,   750,  5058,  5058,  -986,
    3403,  -986,  2976,  -986,  -986,   914,   606,  -986,  -986,  -986,
    -986,   479,   808,   637,   853,   763,  -986,   769,  -986,   570,
    -986,   215,  -986,   767,   770,   121,   772,   130,  5058,  -986,
    2784,   840,  4755,  3072,  5108,  -986,   635,  -986,   787,  7756,
    7756,  7756,    73,   796,  -986,   264,  -986,   894,   812,  7756,
    -986,   643,   122,  7756,  -986,  -986,  -986,  -986,  -986,   643,
     643,   643,   122,  -986,  7756,  -986,  -986,  -986,  -986,  -986,
     818,  -986,  -986,  1552,  6564,  -986,  5456,  -986,   816,  -986,
    -986,  7927,  -986,    11,   228,  -986,   826,  -986,  5058,   827,
     831,   450,  -986,   832,   833,  6479,  -986,   285,  -986,   855,
    -986,  -986,  -986,  -986,  -986,  -986,  6649,  -986,   837,  -986,
     440,   937,   927,  -986,  -986,   643,   643,   450,   943,  -986,
    -986,   838,  -986,  -986,  -986,   649,   516,  -986,  -986,  3453,
    -986,   836,  5058,  -986,  -986,  4844,  -986,  -986,  -986,  4844,
    5108,  -986,  5058,  -986,  -986,  -986,  -986,  5108,  -986,   861,
    -986,  -986,  -986,  -986,  -986,  -986,   643,   643,   842,  -986,
    7515,  5368,  -986,  7756,   919,   848,    57,  -986,   637,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  6309,   446,
     947,  -986,  5058,  1152,   714,  5058,  -986,  -986,  -986,  -986,
    3542,   877,  -986,  -986,  -986,   859,   863,  5058,  -986,   871,
    1152,  -986,  -986,  -986,  4492,   967,   391,  -986,   970,   516,
     874,  -986,   875,  -986,   162,  -986,   873,  -986,  7756,   876,
    -986,   879,  5058,   393,  -986,  -986,  -986,   885,  -986,  -986,
    -986,   617,  -986,  -986,   289,  7756,  -986,  6734,  7756,  -986,
    -986,   568,  -986,   297,  -986,   678,   866,  7756,  6649,   991,
     995,  -986,   996,  -986,  -986,    60,  -986,  -986,   984,  5058,
    -986,   892,  -986,  -986,  2880,  -986,   987,  -986,  -986,  -986,
      95,    48,  -986,   919,  -986,  -986,  -986,   899,  -986,   842,
     279,  -986,   997,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  1015,   919,   122,  -986,  -986,  -986,  -986,  -986,  1000,
     751,  -986,  -986,   993,  -986,  -986,  -986,   108,  -986,   911,
    -986,   924,  5058,   444,  -986,  5058,   970,  -986,  -986,   489,
    -986,  -986,  7756,  5542,  6819,    56,    11,  -986,  -986,  -986,
     939,  -986,  -986,   982,  1008,  1062,  -986,  -986,  -986,  -986,
    -986,  -986,  7984,  -986,  6904,  7756,  -986,  7756,   855,   306,
    -986,  -986,  1109,  -986,  -986,  -986,   940,   836,   177,  -986,
    -986,  -986,   476,  7756,  5058,   944,  -986,  -986,   446,  -986,
    5058,  -986,  5058,  -986,  -986,   358,  5058,  5058,  -986,  3592,
    7756,   228,   663,   945,   949,   314,  -986,  5058,  -986,  -986,
    -986,   953,   322,  -986,   941,  -986,  -986,    28,    53,  -986,
    1276,   261,  -986,  5058,  5058,   228,  -986,   668,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,   960,   960,  -986,  -986,  -986,
    1026,  -986,   769,  -986,  -986,  -986,    78,  -986,   986,  -986,
    7756,  -986,  1992,  -986,   575,  -986,    29,  -986,  -986,   528,
    -986,  -986,  -986,   418,  -986,  2976,  -986,  -986,  -986,   528,
    -986,  -986,  7756,  6989,  -986,   637,  -986,   971,   249,  1048,
    1048,   509,   525,  -986,   975,   296,   643,   643,  5797,  1081,
    1428,   637,  7373,  3168,  5197,  4187,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  1010,  -986,   483,   539,   640,
    2113,  1060,  -986,  5108,   998,  1002,  1003,  1004,  1005,  -986,
    -986,  1011,   283,   392,  -986,  -986,  7756,  7074,  1087,  7756,
     990,  -986,  -986,   618,  -986,   229,  -986,   189,  1102,  -986,
    -986,  -986,  5058,   528,  -986,  1105,  -986,  -986,   228,   665,
     516,  -986,  -986,  -986,  -986,  -986,   509,  1072,  1115,   598,
    -986,  -986,  -986,  1067,  -986,  1053,  -986,  -986,  -986,  -986,
    3681,  -986,  3731,  -986,  -986,  2359,  4976,  1107,  -986,   773,
    -986,  1121,  1126,  1131,   359,  -986,  1021,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  1024,   336,  -986,  -986,   788,
     907,  -986,  5058,  3820,  5058,  -986,  -986,  1045,  7445,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,   818,  -986,   283,
    -986,  -986,  -986,  1040,  1025,  1122,   369,  5058,  2228,  -986,
    5058,  3870,  -986,  5058,  3959,  -986,  -986,  -986,  5058,   528,
    -986,   269,  1028,  -986,  1032,  -986,  -986,  1034,  -986,  -986,
    -986,  -986,  1041,  1042,  1033,  1033,  -986,  -986,  -986,  5058,
    1046,  -986,  -986,   106,  -986,  -986,  -986,  5058,  1039,  -986,
    -986,  -986,  -986,  4666,  7756,  4404,  -986,  -986,  -986,  -986,
    7756,  -986,  7159,  -986,  -986,   343,  -986,  1047,  5058,  -986,
    1051,  -986,   818,  1043,  -986,   637,   637,  -986,  -986,  1150,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,   528,  1157,  -986,  -986,  -986,  -986,   228,   228,  5058,
    -986,  -986,  -986,  5712,  5712,  -986,    44,  4976,  4976,  1148,
    -986,  -986,  1149,  -986,  -986,  1054,    39,  -986,  -986,  -986,
      10,  -986,  -986,  -986,  5058,  -986,  4009,  -986,  -986,   436,
    -986,  -986,  -986,   283,   669,  -986,  -986,  -986,  -986,   398,
    -986,  1059,  -986,  1165,  7585,  -986,  1172,   228,  5058,  -986,
    -986,  -986,  -986,  -986,  -986,  4098,  4976,  -986,  -986,  -986,
    -986,  -986,   818,  -986,  -986,   528,  -986,  -986,   228,  -986,
    -986,  7756,  7756,   139,   137,  7756,  7756,  1738,   293,   231,
    1071,  -986,  1068,  -986,  1097,  -986,  -986,  -986,   506,  -986,
     250,  -986,  -986,  -986,  -986,  -986,   677,  -986,   643,   643,
     643,   643,  -986,  -986,  -986,  -986,  5058,  5058,   369,  1074,
    -986,  -986,   228,   102,  -986,  -986,  -986,    10,  5058,  -986,
    -986,  -986,  1078,  7301,  -986,   115,  -986,  -986,  7301,  1079,
    -986,  1082,  -986,   769,  -986
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  1007,  -986,  1130,  -986,   -77,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,   243,   396,
    -986,  -986,   641,  -986,  -986,  1111,    71,    22,  -986,   365,
    -986,  -986,   501,  -186,   -93,  -986,  -101,  -986,   474,  -986,
    -986,   661,   -48,  -342,   503,  -986,  -986,   423,  -986,   664,
    -986,  -986,  -986,  -986,  -313,  -986,   298,   790,  -145,  -986,
    -986,  -986,  -986,   325,  -986,   686,  -986,  -469,  -986,  -986,
    -986,  -986,  -986,    40,  -986,  -986,  -986,    33,  -986,  -986,
    -986,  -986,  -986,   -84,  -730,  -985,  -986,  -986,   300,  -986,
    -986,   284,  -986,  -986,  -971,  -722,  -986,  -986,  -284,  -986,
    -986,  -986,  -424,    17,  -841,  -986,  -986,  -986,  -986,  -596,
    -775,  -242,   317,    74,  -986,  -986,  -904,  -986,  -986,   893,
    -986,  -986,  -986,  -323,  -986,  -986,   671,  -986,  -986,  -462,
      -8,  -986,  1129,  -986,  -986,  -986,  -275,  -986,   241,  -514,
    -611,  -986,  -986,   510,  -118,  -575,   185,  -986,  -986,  -392,
    -986,   429,  -168,  -413,  -591,  -986,  -986,  -823,  -506,  -405,
    -986,  -986,   588,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,   -92,  -986,  -986,  -986,
     -15,  -986,  -986,  -188,  -986,  -795,  -171,  -986,  -986,   475,
    -986,  -986,    98,  -986,    99,  -986,  -660,  1322,  1009,  -986,
    -106,  -986,    27,  -141,  -986,  -828,  -530,   415,  -151,  -986,
    -586,  -272,  -986,  -176,  -986,  -555,  -130,  -390,   485,   290,
    -549,  -359,  -986,   768,   771,   453,   780,  -347,  -986,  -986,
      37,   976,  -318,  -986,  -986,   578,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  1093,  1094,   631,  -483,   -72,
    -986,  -986,  -629,    31,  -986,  -986,   824,  -986,  -713,  -931,
    -487,  -603,  -358,  1207,  -470,  -572,   -79,  -170,    -9,  -566
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -776
static const short int yytable[] =
{
      73,    72,    77,    89,   371,   374,   630,   594,   636,   530,
     215,   281,   496,   332,   684,   753,   630,   532,  1014,   939,
     117,   751,   790,   341,   412,   200,   454,   350,   290,   486,
     355,   721,    63,    67,   477,   445,   451,   956,   201,   333,
     480,    74,   754,  1118,   193,  1108,   509,   415,   757,  -775,
     671,   835,   836,   961,    77,  1080,   681,   855,  -775,   861,
    1088,   197,   289,  -240,   984,    77,   336,   677,  -172,   483,
      73,    72,   585,   100,  -754,   750,   986,   356,   808,   966,
     279,  1006,    76,   359,    68,   943,   991,   917,    70,   939,
     691,   -13,  1089,  1207,   492,    77,  -613,    70,    73,    72,
     327,    94,  -594,  -775,   100,   918,  1007,  1167,     3,   837,
    1008,   114,    95,    99,   780,  -775,   627,   718,  1208,   838,
     818,   280,  -612,   627,  1171,   899,    75,   921,  -394,   127,
     751,   492,  1180,   909,    78,    79,   209,   375,   376,   377,
     128,   130,   116,   408,    99,   639,  1153,   613,   114,   751,
     192,   364,  -288,   366,   438,   943,   114,   114,   402,  -706,
    1077,   671,   423,   782,  -775,   109,  -775,   202,  -775,   756,
    -754,  -754,   437,  -775,   610,   612,   871,  -775,   627,   116,
     465,   337,   983,   340,   750,   198,   996,   116,   116,   786,
    1073,  -754,  -754,  -754,   967,   416,  1212,  1213,  -754,   488,
     968,   360,   114,   750,   361,   292,   298,   299,   300,   301,
     326,   330,   493,   494,  -613,   495,   595,  -621,  -775,   602,
    -594,  -612,  -775,  -594,  1198,  1168,   346,   839,  1169,  1246,
    1070,  -394,  -754,   116,   532,   628,   626,   891,  -394,   827,
    -612,  -612,   628,  -594,   633,   634,   635,   630,   480,   493,
     494,  1070,   480,   729,    82,  -288,  1155,   950,   409,   471,
     477,   410,   509,   509,  1224,   620,  1226,   440,   433,   439,
     441,   569,  1174,   750,   458,    84,  1217,   483,   783,  1277,
    -695,   483,  -695,   110,  -695,   944,   695,  1074,   951,    85,
     695,  1253,  1254,  -394,   952,  -394,  -387,   628,   802,   574,
     368,   412,   370,   822,   884,    70,  -287,   802,  -457,  -457,
     417,   948,   630,   418,   398,   458,   143,   400,    92,   529,
    -775,   421,   146,   912,  1270,   434,   430,   950,  1195,    86,
     436,   596,   508,   597,   598,   684,   524,  1120,  1038,  1041,
      93,   731,   732,   103,  1184,  1030,   564,   998,  1071,  1072,
    -754,  -754,   152,    75,   107,   944,   755,   668,   951,   114,
    1114,   953,  1151,   806,   952,   816,   999,   192,   192,  1071,
    1269,  1223,  -766,  1286,  1137,  1174,   115,   209,   454,  1244,
     621,   948,   622,  1033,   952,  1039,  1033,  1156,   451,  1157,
     116,   459,   460,  -387,   529,   510,   472,   515,   -15,  -387,
     823,   948,  1255,   696,   697,  -387,   525,   796,   697,  -287,
     475,   202,   965,  1148,  1150,   803,   804,  1016,   398,   398,
    1250,   553,   896,   532,   874,   804,   421,  1193,   529,   618,
     532,  1138,   908,   460,  1194,  1087,   511,   625,   913,   298,
     914,   298,   519,  -387,   520,   521,   523,   330,   709,   330,
     690,   108,  1129,   710,  1121,  1122,   539,   543,  1084,  -387,
     751,  1185,  1186,    -2,   682,   559,   873,   760,   111,   346,
     346,  1250,  1250,   843,  -387,  1115,   714,  -766,   575,   576,
      70,  -387,   529,  1225,   776,   260,   792,  -402,   668,   261,
     133,  -402,     1,   586,    22,    85,    24,  -387,   970,  1033,
     262,   565,    30,  1069,   119,  1110,   143,  1266,  -387,   793,
    1208,  -766,   146,   630,   750,   989,  1227,   123,  1228,  -766,
     263,   398,  -402,   398,   398,   566,    22,   196,    24,  -394,
     616,   617,     2,  -394,    30,   685,   987,    61,   988,    62,
    -210,  -394,   152,   430,   632,   813,   264,   265,   508,   508,
     700,   739,  -210,    70,  1116,   637,     3,   532,   532,   112,
     113,  1289,  -387,  -394,  1012,   676,  1291,   539,  -766,    61,
     430,    62,   543,   203,  1060,  1062,   979,   209,  -210,  -394,
    1006,   801,   204,  -210,   447,   831,   559,   980,   947,   114,
    -394,   266,   267,   268,   269,   448,  1006,   706,   205,  1092,
    1043,   206,  -709,   981,  1044,  1007,  1049,   270,   271,  1008,
    -210,   510,   510,   272,  -709,   819,   868,   515,   870,  1067,
     116,  1007,  1267,  -766,  -766,  1008,   398,  1084,  1084,   179,
     398,  -766,   727,   207,   826,  -210,   728,   235,   180,  -210,
    -709,  -545,   291,   995,  -394,  -709,  1132,   797,    22,   799,
      24,  1019,  1020,  -545,   532,  -210,    30,  -210,   947,   755,
     209,    70,  1285,  1097,  -545,   404,   288,   545,   488,   539,
    -394,   335,  -709,   405,  -394,   547,   331,   684,   404,  -545,
    -766,   833,  -394,   553,  -545,   338,   411,    22,   357,    24,
    -612,    61,   424,    62,   425,    30,   700,  -709,  1257,   957,
     833,  -709,   357,  -706,   426,   358,   856,   857,   362,   787,
     553,  -545,   854,   367,   526,  -706,   527,  -709,   207,  -709,
    -709,  -709,   515,  -709,   588,   589,   559,  1093,   559,   800,
      61,  -394,    62,   516,  1068,   518,  -545,   401,   706,   706,
    -545,  -706,  1284,  1106,  1106,   898,  -706,   901,   582,   413,
     584,   414,   281,   614,   589,   398,  -545,  -545,  -545,  -545,
     404,  -545,  -545,   419,    22,   473,    24,   720,   589,   473,
     830,  1290,    30,  -706,   627,   698,   805,   457,  1268,   630,
    1222,   904,   905,  1086,   589,  -394,  -394,   203,   532,  -266,
     204,   -28,   205,   215,   174,  1271,  1272,   490,  -706,   700,
     294,  -266,  -706,   561,   563,   176,   -28,    61,   206,    62,
     431,   432,  -394,   676,   676,   848,   850,  -394,  -706,  -706,
    -706,  -706,  -706,  1294,  -706,   177,   178,  -266,   992,   994,
    1177,  1179,  -266,   706,   489,   706,   706,   497,   872,   179,
     854,   854,  1279,  1280,  -394,   282,   555,   831,   180,   570,
     276,   114,  1163,  1164,   888,   577,   685,   579,    22,  -266,
      24,   735,   738,  1190,  1191,   277,    30,    -9,   580,  -394,
     447,   902,   283,  -394,   284,   285,   286,   591,    -5,  1141,
    1143,   448,   116,   592,  -266,   593,   174,   600,  -266,  -394,
     175,  -394,   601,   628,   603,  1106,  1106,   176,   282,  1144,
    1146,    61,   607,    62,  -266,   615,  -266,    -9,  -759,  1001,
    1004,  1004,  1011,  1011,   619,   179,  1018,   177,   178,  1027,
    -759,   888,   461,   462,   180,   283,   740,   284,   285,   286,
     623,   179,   624,   133,   639,   678,   990,   468,   470,   171,
     180,   173,   686,   688,  1252,   741,  -759,   689,   692,   693,
     711,  -759,   698,   742,   708,   712,   715,   724,   719,   488,
     758,   236,   733,  1034,  1037,  1034,  1034,   237,   752,    22,
     770,    24,   778,   173,   173,   173,   772,    30,  -759,  1085,
     773,   209,   278,  1273,  1274,  1275,  1276,  1011,   775,   282,
     784,   807,   173,   173,   781,  -693,   788,   888,   888,   789,
    1064,   794,   810,  -759,  1101,   238,   811,  -759,   282,   710,
     815,   817,    61,   455,    62,   239,   283,   820,   284,   285,
     286,   824,   825,  -759,   829,  -759,   834,   173,    70,   173,
     173,   840,   587,   544,   545,   283,   546,   284,   285,   286,
    1131,   841,   547,   240,   241,   242,   243,  1133,   244,   245,
     246,   247,   248,   249,   133,   862,   864,   865,   548,   549,
     550,   915,   882,   906,   282,   890,   741,   907,   250,   251,
    -299,   911,   252,   253,   254,   255,  -394,   964,   174,  1034,
     173,   173,   175,   173,   969,  1001,  1001,   997,  1002,   176,
      22,   283,    24,   284,   285,   286,  1015,   173,    30,   173,
     373,   373,   173,   173,   173,  1028,  1048,   399,  1042,   177,
     178,  1063,  1065,  1075,  1050,   173,  1079,   877,  1051,  1052,
    1053,  1054,   -41,   179,  1090,   174,  1094,  1055,  1091,   175,
    1095,  1109,  1242,    61,  1111,    62,   176,   570,   237,  1112,
    1113,  1117,  1119,  1128,  1175,  1135,  1136,  1158,  1085,  1159,
     999,  1181,  1160,  1183,  1205,  1205,   177,   178,  1211,  1161,
    1162,  1170,  1166,  1192,   823,   878,   133,  1189,  1196,  1187,
     179,  1011,  1214,  1215,  1216,   173,   238,  1229,  1230,   180,
     173,  1211,   173,   173,   173,  1243,   239,  1263,  1264,   173,
    1265,  1283,   278,   173,   278,  1288,  1241,  1292,   685,    80,
    1293,   342,    22,   399,    24,   173,  1058,   136,   881,   809,
      30,   399,   399,   713,   240,   122,   694,   812,   866,   244,
     245,   246,   247,   248,   249,   560,   173,   680,   701,  1221,
    1029,   137,   138,  1251,  1046,   139,   140,  1005,  1206,   250,
     251,   446,   132,   173,   145,    61,   255,    62,  1134,   821,
     717,   885,   777,  1282,   847,  1199,   903,  1200,   605,   396,
     845,   606,  1258,  1259,   515,   363,  1260,  1261,  1011,   149,
     883,   608,   324,   325,  1027,   761,    81,   627,     0,  1027,
       0,   173,   173,   924,   173,     0,   399,     0,     0,     0,
     925,     0,   926,     0,     0,     0,   278,   590,   134,   135,
       0,     0,   741,   927,     0,     0,   928,     0,   929,     0,
     742,     0,   173,     0,   399,     0,   399,   399,   173,     0,
       0,   930,     0,     0,     0,     0,    22,     0,    24,     0,
       0,   136,     0,     0,    30,     0,     0,     0,     0,     0,
       0,     0,   931,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   137,   138,   672,     0,   139,
     140,     0,   141,   142,   143,   144,     0,     0,   145,    61,
     932,    62,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   933,     0,     0,     0,   150,     0,   934,
     935,     0,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   173,     0,     0,   173,     0,     0,   399,
       0,     0,     0,   399,   173,     0,   173,     0,     0,   627,
       0,   173,     0,     0,     0,   924,     0,   155,     0,   172,
       0,     0,   925,     0,   926,     0,     0,     0,   373,     0,
     134,   135,   373,     0,   741,   927,     0,     0,   928,     0,
     929,     0,   742,     0,     0,     0,   173,   173,   762,   173,
       0,   210,   212,     0,   173,     0,     0,     0,    22,     0,
      24,   173,     0,   136,   173,     0,    30,     0,   173,     0,
       0,     0,     0,     0,   931,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   173,   137,   138,     0,
       0,   139,   140,     0,   141,   142,   143,   144,     0,     0,
     145,    61,   932,    62,     0,     0,     0,   352,     0,     0,
       0,     0,     0,     0,   147,   148,     0,     0,     0,     0,
       0,     0,     0,   173,     0,   933,     0,     0,   399,   150,
       0,   934,   935,     0,   153,   154,     0,   373,   641,     0,
     331,   642,     0,     0,     0,     0,   133,   643,     0,   644,
     645,     0,     0,     0,     0,   646,   373,   647,     0,     0,
       0,     0,     0,   648,     0,     0,     0,     0,     0,   649,
     650,     0,     0,     0,     0,   651,   173,   844,     0,   173,
       0,     0,    22,     0,    24,   389,     0,   136,     0,     0,
      30,     0,     0,   403,     0,     0,     0,     0,     0,   652,
     653,     0,     0,     0,     0,   654,     0,     0,     0,     0,
       0,   137,   138,   655,   656,   139,   140,   657,   294,     0,
       0,     0,   658,   659,   145,    61,   373,    62,   173,     0,
       0,     0,     0,     0,   173,     0,   173,     0,     0,     0,
     173,   173,     0,   173,     0,     0,     0,     0,     0,   149,
       0,   173,     0,   456,     0,   660,     0,     0,   464,     0,
     467,   212,   212,     0,   949,     0,     0,   173,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   474,     0,   476,     0,     0,     0,     0,     0,   479,
     485,     0,     0,     0,     0,     0,   173,     0,     0,     0,
       0,     0,     0,     0,   464,     0,     0,     0,     0,   399,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   373,
       0,   528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -285,   133,     0,   949,   373,     0,   399,   399,     0,
     134,   135,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   173,     0,     0,   173,     0,   581,
     352,     0,   352,     0,   464,     0,     0,     0,    22,     0,
      24,     0,     0,   136,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   173,     0,     0,     0,
     604,     0,   389,     0,   609,   609,   476,   137,   138,     0,
       0,   139,   140,   373,   141,   142,   143,   144,     0,     0,
     145,    61,   146,    62,   173,     0,     0,     0,     0,   949,
     949,     0,     0,     0,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,  -285,   149,     0,     0,     0,   150,
       0,   151,   152,     0,   153,   154,   173,   173,   173,     0,
     687,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   373,     0,     0,
       0,   173,   173,     0,   173,   173,     0,   173,   173,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,   723,     0,     0,   726,     0,     0,   389,     0,     0,
       0,   389,   476,   173,   730,     0,     0,     0,     0,   476,
       0,   173,     0,     0,     0,     0,     0,  1176,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,   373,
     373,     0,     0,     0,   759,     0,     0,   763,     0,     0,
       0,     0,   769,     0,     0,     0,     0,     0,     0,   774,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,   949,   949,   971,     0,     0,     0,  -443,     0,     0,
       0,     0,     0,     0,     0,  -443,   133,     0,   173,     0,
     173,     0,     0,     0,   134,   135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,   173,
     949,   814,    22,     0,    24,     0,   389,   136,     0,     0,
      30,     0,     0,     0,  -443,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,   138,     0,     0,   139,   140,     0,   141,   142,
     143,   144,     0,     0,   145,    61,   146,    62,     0,     0,
     173,   173,     0,     0,   842,     0,     0,   352,   147,   148,
       0,     0,   173,     0,     0,     0,     0,     0,     0,   149,
       0,     0,     0,   150,   627,   151,   152,     0,   153,   154,
     924,     0,     0,     0,     0,     0,     0,   925,     0,     0,
       0,     0,     0,     0,     0,   134,   135,     0,     0,     0,
       0,     0,     0,   928,     0,   929,   889,     0,     0,     0,
       0,     0,   893,     0,   894,     0,     0,     0,   897,   769,
       0,   769,     0,    22,     0,    24,     0,     0,   136,   910,
       0,    30,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   945,     0,     0,   954,   955,     0,     0,     0,
       0,     0,   137,   138,     0,     0,   139,   140,     0,   141,
     142,   143,   144,     0,     0,   145,    61,   146,    62,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
     148,     0,     0,     0,     0,     0,     0,   464,     0,  1142,
     149,     0,     0,  -767,   150,     0,   151,   152,     0,   153,
     154,  -767,   133,     0,     0,     0,     0,     0,     0,     0,
     134,   135,   945,     0,     0,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1047,     0,     0,   476,     0,     0,    22,     0,
      24,     0,     0,   136,     0,     0,    30,     0,     0,     0,
    -767,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1076,     0,     0,   137,   138,     0,
       0,   139,   140,     0,   141,   142,   143,   144,     0,     0,
     145,    61,   146,    62,     0,     0,     0,     0,     0,     0,
       0,     0,   476,     0,   147,   148,     0,   945,   945,     0,
       0,     0,     0,     0,     0,   149,     0,     0,     0,   150,
       0,   151,   152,     0,   153,   154,     0,     0,     0,     0,
    1102,     0,     0,     0,  1123,  1126,  1127,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,     0,     0,     0,
       0,   134,   135,     0,     0,   741,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1154,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,    24,     0,     0,   136,     0,     0,    30,     0,     0,
       0,  1165,     0,     0,     0,     0,     0,     0,     0,  1047,
       0,     0,     0,     0,     0,   945,     0,     0,   137,   138,
       0,     0,   139,   140,     0,   141,   142,   143,   144,     0,
    1188,   145,    61,   146,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   933,     0,     0,     0,
     150,  1201,   151,   152,     0,   153,   154,     0,   216,   945,
     945,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1218,     0,  1220,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,     0,     0,     0,     0,
    1245,     0,     0,     0,     0,     0,     0,     0,   945,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1262,
     302,     0,     0,     0,   303,     0,     0,     0,     0,     0,
       0,     0,     0,   304,     0,   305,     0,     0,     0,   306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
    1287,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       0,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,   114,   307,   308,   309,   310,   311,
     312,   313,   246,   247,   248,   249,   266,   267,   268,   269,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     314,   315,   316,   317,   318,   116,   319,   320,   321,   484,
       0,     0,     0,     0,     0,     0,     0,   379,     0,     0,
       0,     0,   133,     0,     0,     0,     0,     0,     0,     0,
     134,   135,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,   380,    28,    29,    30,    31,    32,    33,
     381,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,   382,   383,    53,
      54,   384,   385,    57,   141,   142,   143,   144,    58,    59,
     386,    61,   146,    62,     0,   378,     0,     0,     0,     0,
       0,     0,     0,   379,   147,   148,     0,     0,   133,     0,
       0,     0,     0,     0,     0,   387,   134,   135,     0,   388,
     211,   151,   152,     0,   153,   154,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,   380,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,   382,   383,    53,    54,   384,   385,    57,
     141,   142,   143,   144,    58,    59,   386,    61,   146,    62,
       0,   378,     0,     0,     0,     0,     0,     0,     0,   379,
     147,   148,     0,     0,   133,     0,     0,     0,     0,     0,
       0,   387,   134,   135,     0,   388,  -767,   151,   152,     0,
     153,   154,     0,     0,     0,     0,     0,     0,     0,    12,
      13,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,   380,    28,    29,    30,    31,
      32,    33,   381,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,   382,
     383,    53,    54,   384,   385,    57,   141,   142,   143,   144,
      58,    59,   386,    61,   146,    62,     0,   463,     0,     0,
       0,     0,     0,     0,     0,     0,   147,   148,     0,     0,
     133,     0,     0,     0,     0,     0,     0,   387,   134,   135,
       0,   388,     0,   151,   152,     0,   153,   154,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,   380,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,   382,   383,    53,    54,   384,
     385,    57,   141,   142,   143,   144,    58,    59,   386,    61,
     146,    62,     0,   611,     0,     0,     0,     0,     0,     0,
       0,     0,   147,   148,     0,     0,   133,     0,     0,     0,
       0,     0,     0,   149,   134,   135,     0,   150,     0,   151,
     152,     0,   153,   154,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,   380,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,   382,   383,    53,    54,   384,   385,    57,   141,   142,
     143,   144,    58,    59,   386,    61,   146,    62,     0,  1035,
       0,     0,     0,     0,     0,     0,     0,     0,   147,   148,
       0,     0,   133,     0,     0,     0,     0,     0,     0,   149,
     134,   135,     0,   150,     0,   151,   152,     0,   153,   154,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,   380,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,   382,   383,    53,
      54,   384,   385,    57,   141,   142,   143,   144,    58,    59,
     386,    61,   146,    62,     0,   463,     0,     0,     0,     0,
       0,     0,     0,     0,   147,   148,     0,     0,   133,     0,
       0,     0,     0,     0,     0,   149,   134,   135,     0,   150,
       0,   151,   152,     0,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,   469,    24,     0,     0,   136,
       0,     0,    30,     0,     0,     0,     0,     0,   133,     0,
       0,     0,     0,     0,     0,     0,   134,   135,     0,     0,
       0,     0,     0,   137,   138,     0,     0,   139,   140,     0,
     141,   142,   143,   144,     0,     0,   145,    61,   146,    62,
       0,     0,     0,     0,    22,     0,    24,     0,     0,   136,
     147,   148,    30,     0,     0,     0,     0,     0,     0,     0,
       0,   149,     0,     0,     0,   150,     0,   151,   152,     0,
     153,   154,     0,   137,   138,     0,     0,   139,   140,     0,
     141,   142,   143,   144,   583,     0,   145,    61,   146,    62,
       0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
     147,   148,     0,     0,     0,   134,   135,     0,     0,     0,
       0,   149,     0,     0,     0,   150,     0,   151,   152,     0,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,   722,    24,     0,     0,   136,     0,
       0,    30,     0,     0,     0,     0,     0,   133,     0,     0,
       0,     0,     0,     0,     0,   134,   135,     0,     0,     0,
       0,     0,   137,   138,     0,     0,   139,   140,     0,   141,
     142,   143,   144,     0,     0,   145,    61,   146,    62,     0,
       0,     0,     0,    22,     0,    24,     0,     0,   136,   147,
     148,    30,     0,     0,     0,     0,     0,     0,     0,     0,
     149,     0,     0,     0,   150,     0,   151,   152,     0,   153,
     154,     0,   137,   138,     0,     0,   139,   140,     0,   141,
     142,   143,   144,   766,     0,   145,    61,   146,    62,     0,
       0,     0,     0,     0,     0,     0,   133,     0,     0,   147,
     148,     0,     0,     0,   134,   135,     0,     0,     0,     0,
     149,     0,     0,     0,   150,     0,   151,   152,     0,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,   900,    24,     0,     0,   136,     0,     0,
      30,     0,     0,     0,     0,     0,   133,     0,     0,     0,
       0,     0,     0,     0,   134,   135,     0,     0,     0,     0,
       0,   137,   138,     0,     0,   139,   140,     0,   141,   142,
     143,   144,     0,     0,   145,    61,   146,    62,     0,     0,
       0,     0,    22,     0,    24,     0,     0,   136,   147,   148,
      30,     0,     0,     0,     0,     0,     0,     0,     0,   149,
       0,     0,     0,   150,     0,   151,   152,     0,   153,   154,
       0,   137,   138,     0,     0,   139,   140,     0,   141,   142,
     143,   144,  1096,     0,   145,    61,   146,    62,     0,     0,
       0,     0,     0,     0,     0,   133,     0,     0,   147,   148,
       0,     0,     0,   134,   135,     0,     0,     0,     0,   149,
       0,     0,     0,   150,     0,   151,   152,     0,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,  1098,    24,     0,     0,   136,     0,     0,    30,
       0,     0,     0,     0,     0,  -159,     0,     0,     0,     0,
       0,     0,     0,  -159,  -159,     0,     0,     0,     0,     0,
     137,   138,     0,     0,   139,   140,     0,   141,   142,   143,
     144,     0,     0,   145,    61,   146,    62,     0,     0,     0,
       0,  -159,     0,  -159,     0,     0,  -159,   147,   148,  -159,
       0,     0,     0,     0,     0,     0,     0,     0,   387,     0,
       0,     0,   388,     0,   151,   152,     0,   153,   154,     0,
    -159,  -159,     0,     0,  -159,  -159,     0,  -159,  -159,  -159,
    -159,  1124,     0,  -159,  -159,  -159,  -159,     0,     0,     0,
       0,     0,     0,     0,   133,     0,     0,  -159,  -159,     0,
       0,     0,   134,   135,     0,     0,     0,     0,  -159,     0,
       0,     0,  -159,     0,  -159,  -159,     0,  -159,  -159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,  1145,    24,     0,     0,   136,     0,     0,    30,     0,
       0,     0,     0,     0,   133,     0,     0,     0,     0,     0,
       0,     0,   134,   135,     0,     0,     0,     0,     0,   137,
     138,     0,     0,   139,   140,     0,   141,   142,   143,   144,
       0,     0,   145,    61,   146,    62,     0,     0,     0,     0,
      22,     0,    24,     0,     0,   136,   147,   148,    30,     0,
       0,     0,     0,     0,     0,     0,     0,   149,     0,     0,
       0,   150,     0,   151,   152,     0,   153,   154,     0,   137,
     138,     0,     0,   139,   140,     0,   141,   142,   143,   144,
    1149,     0,   145,    61,   146,    62,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,   147,   148,     0,     0,
       0,   134,   135,     0,     0,     0,     0,   149,     0,     0,
       0,   150,     0,   151,   152,     0,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
    1219,    24,     0,     0,   136,     0,     0,    30,     0,     0,
       0,     0,     0,   133,     0,     0,     0,     0,     0,     0,
       0,   134,   135,     0,     0,     0,     0,     0,   137,   138,
       0,     0,   139,   140,     0,   141,   142,   143,   144,     0,
       0,   145,    61,   146,    62,     0,     0,     0,     0,    22,
       0,    24,     0,     0,   136,   147,   148,    30,     0,     0,
       0,     0,     0,     0,     0,     0,   149,     0,     0,     0,
     150,     0,   151,   152,     0,   153,   154,     0,   137,   138,
       0,     0,   139,   140,     0,   141,   142,   143,   144,  1247,
       0,   145,    61,   146,    62,     0,     0,     0,     0,     0,
       0,     0,   133,     0,     0,   147,   148,     0,     0,     0,
     134,   135,     0,     0,     0,     0,   149,     0,     0,     0,
     150,     0,   151,   152,     0,   153,   154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   136,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   137,   138,     0,
       0,   139,   140,     0,   141,   142,   143,   144,     0,     0,
     145,    61,   146,    62,     0,     0,     0,     0,     0,     0,
       0,   133,     0,   926,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,   927,   149,     0,     0,     0,   150,
       0,   151,   152,     0,   153,   154,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,     0,     0,    58,    59,    60,
      61,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     498,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   500,     0,     0,     0,
       0,     0,     0,     0,     0,  -775,     0,     0,    12,    13,
      14,    15,    16,    17,    18,   501,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,  1178,     0,     0,     0,    58,
      59,    60,   502,  -229,    62,     0,     0,  -767,   503,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   504,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       0,     0,     0,     0,    58,    59,    60,    61,   641,    62,
     331,   642,     0,     0,     0,     0,   133,   643,     0,   644,
     645,     0,     0,     0,     0,   646,     0,   647,     0,     0,
       0,     0,  -767,   648,     0,     0,     0,     0,     0,   649,
     650,     0,     0,     0,     0,   651,     0,     0,     0,     0,
       0,     0,    22,     0,    24,     0,     0,   136,     0,     0,
      30,     0,     0,     0,     0,     0,     0,     0,     0,   652,
     653,     0,     0,     0,     0,   654,     0,     0,     0,     0,
       0,   137,   138,   655,   656,   139,   140,   657,     0,     0,
       0,     0,   658,   659,   145,    61,     0,    62,     0,     0,
       0,   133,     0,     0,     0,     0,     0,     0,     0,   134,
     135,     0,     0,     0,     0,     0,     0,     0,     0,   149,
       0,     0,     0,     0,     0,   660,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,   380,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,   382,   383,    53,    54,
     384,   385,    57,   141,   142,   143,   144,    58,    59,   386,
      61,   146,    62,     0,     0,     0,     0,     0,     0,     0,
     133,     0,     0,   147,   148,     0,     0,     0,   134,   135,
       0,     0,   741,     0,   387,   478,     0,     0,   388,     0,
     151,   152,     0,   153,   154,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,   380,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,   382,   383,    53,    54,   384,
     385,    57,   141,   142,   143,   144,    58,    59,   386,    61,
     146,    62,     0,     0,     0,     0,     0,     0,     0,   133,
       0,     0,   147,   148,     0,     0,     0,   134,   135,     0,
       0,     0,     0,   933,     0,     0,     0,   150,     0,   151,
     152,     0,   153,   154,    12,    13,    14,    15,    16,    17,
      18,     0,    19,    20,    21,    22,    23,    24,    25,    26,
     380,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,   382,   383,    53,    54,   384,   385,
      57,   141,   142,   143,   144,    58,    59,   386,    61,   146,
      62,     0,     0,     0,     0,     0,     0,     0,   133,     0,
       0,   147,   148,     0,     0,     0,   134,   135,     0,     0,
       0,     0,   149,     0,     0,     0,   150,     0,   151,   152,
       0,   153,   154,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,   380,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,   382,   383,    53,    54,   384,   385,    57,
     141,   142,   143,   144,    58,    59,   386,    61,   146,    62,
     133,     0,     0,     0,     0,     0,     0,     0,   134,   135,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   387,     0,     0,     0,   388,     0,   151,   152,     0,
     153,   154,     0,     0,     0,     0,    22,     0,    24,     0,
       0,   136,     0,     0,    30,     0,     0,     0,     0,     0,
     133,     0,     0,     0,     0,     0,     0,     0,   134,   135,
       0,     0,   741,     0,     0,   137,   138,     0,     0,   139,
     140,     0,   141,   142,   143,   144,     0,     0,   145,    61,
     146,    62,     0,     0,     0,     0,    22,     0,    24,     0,
       0,   136,   147,   148,    30,     0,     0,     0,     0,     0,
       0,     0,     0,   149,     0,     0,     0,   150,   211,   151,
     152,     0,   153,   154,     0,   137,   138,     0,     0,   139,
     140,     0,   141,   142,   143,   144,     0,     0,   145,    61,
     146,    62,   133,     0,     0,     0,     0,     0,     0,     0,
     134,   135,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   933,     0,     0,     0,   150,     0,   151,
     152,     0,   153,   154,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   136,     0,     0,    30,     0,     0,     0,
       0,     0,   133,     0,     0,     0,     0,     0,     0,     0,
     134,   135,     0,     0,     0,     0,     0,   137,   138,     0,
       0,   139,   140,     0,   141,   142,   143,   144,     0,     0,
     145,    61,   146,    62,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   136,   147,   148,    30,     0,     0,     0,
       0,     0,     0,     0,     0,   149,     0,     0,     0,   150,
       0,   151,   152,     0,   153,   154,     0,   137,   138,     0,
       0,   139,   140,     0,   141,   142,   143,   144,     0,     0,
     145,    61,   146,    62,     0,     0,     0,     0,     0,     0,
       0,   133,     0,   926,   147,   148,     0,     0,     0,   134,
     135,     0,     0,     0,   927,   387,     0,     0,     0,   388,
       0,   151,   152,     0,   153,   154,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,   380,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,   382,   383,    53,    54,
     384,   385,    57,   141,   142,   143,   144,    58,    59,   386,
      61,   146,    62,   133,     0,     0,     0,     0,     0,     0,
       0,   134,   135,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   149,     0,     0,     0,   150,     0,
     151,   152,     0,     0,     0,     0,     0,     0,     0,    22,
       0,    24,     0,     0,   136,     0,     0,    30,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   137,   138,
       0,     0,   139,   140,     0,   141,   142,   143,   144,   736,
       0,   145,    61,   146,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   499,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,   500,   149,     0,     0,     0,
     150,     0,   151,   152,  -775,     0,     0,    12,    13,    14,
      15,    16,    17,    18,   501,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,     0,     0,     0,   535,    58,    59,
      60,   502,     0,    62,  -129,     0,     0,   737,     0,  -129,
       0,     0,  -129,     0,     0,     0,  -129,     0,     0,     0,
       0,     0,     0,  -129,  -129,     0,     0,     0,     0,     0,
    -129,     0,  -129,     0,     0,    12,    13,    14,    15,    16,
      17,    18,  -129,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     0,   849,     0,     0,    58,    59,    60,    61,
    -128,    62,     0,     0,     0,  -128,     0,     0,  -128,     0,
       0,     0,  -128,     0,     0,     0,     0,     0,     0,  -128,
    -128,     0,     0,     0,     0,     0,  -128,     0,  -128,     0,
       0,    12,    13,    14,    15,    16,    17,    18,  -128,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,   562,     0,
       0,     0,    58,    59,    60,    61,     0,    62,     0,     0,
     -75,     0,     0,   -75,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -75,     0,     0,     0,     0,     0,
       0,   -75,     0,   -75,     0,     0,    12,    13,    14,    15,
      16,    17,    18,   -75,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,  1202,     0,     0,     0,    58,    59,    60,
      61,     0,    62,     0,     0,  -775,     0,     0,  -775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -775,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -775,  -775,  -775,  -775,  -775,  -775,  -775,     0,  -775,
    -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,
    -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,
    -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,
    -775,  -775,  -775,  -775,  -775,  -775,  -775,  -775,  1021,     0,
       0,     0,  -775,  -775,  -775,  -775,  -775,  -775,     0,     0,
    -225,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,   293,     0,     0,     0,    58,    59,    60,
      61,     0,    62,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,   294,   517,
       0,     0,    58,    59,    60,    61,     0,    62,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,   294,    11,     0,     0,    58,    59,
      60,    61,     0,    62,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     129,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   343,     0,     0,     0,    58,
      59,    60,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     535,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   540,     0,     0,     0,    58,
      59,    60,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     556,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   673,     0,     0,     0,    58,
      59,    60,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     702,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   798,     0,     0,     0,    58,
      59,    60,   502,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     851,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   869,     0,     0,     0,    58,
      59,    60,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     993,     0,     0,     0,    58,    59,    60,   502,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,  1061,     0,     0,     0,    58,
      59,    60,    61,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    1182,     0,     0,     0,    58,    59,    60,    61,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,     0,     0,     0,     0,    58,
      59,    60,    61,     0,    62,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     0,     0,     0,     0,    58,    59,    60,    61,
    -775,    62,     0,     0,     0,     0,   114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      12,    13,    14,    15,    16,    17,    18,   116,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,   133,     0,   926,
       0,    58,    59,    60,    61,     0,    62,     0,     0,     0,
     927,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    12,    13,    14,    15,    16,    17,    18,  -769,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,   133,
       0,   926,     0,    58,    59,    60,    61,     0,    62,     0,
       0,     0,   927,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
      18,     0,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,   499,     0,     0,     0,    58,    59,    60,    61,     0,
      62,     0,   500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
      18,   501,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,  1231,     0,     0,     0,    58,    59,    60,   502,     0,
      62,     0,  1232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,  1233,    14,    15,    16,  1234,
      18,     0,  1235,  1236,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,  1237,    45,    46,
      47,    48,    49,  1238,    51,    52,    53,    54,    55,    56,
      57,     0,     0,     0,     0,    58,    59,    60,  1239,     0,
      62,    12,    13,    14,    15,    16,    17,    18,    96,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,     0,     0,
       0,     0,    58,    59,    60,    61,     0,    62,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   294,     0,     0,     0,    58,
      59,    60,    61,     0,    62,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,     0,     0,     0,     0,    58,    59,    60,    61,
       0,    62,    12,    13,    14,    15,    16,    17,    18,     0,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,     0,
       0,     0,     0,    58,    59,    60,    61,     0,    62,    12,
      13,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,     0,     0,     0,     0,
      58,    59,    60,    61,     0,    62,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,     0,     0,    58,    59,    60,
      61,     0,    62,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       0,     0,     0,     0,    58,    59,    60,   502,     0,    62
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned char yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   119,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   159,     0,
       0,     0,     0,   161,     0,     0,   103,     0,     0,     0,
       0,     0,    41,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   163,     0,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
      43,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,     0,    75,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   125,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    31,    33,
      35,    37,     0,    39,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   153,     0,     0,
       0,   155,     0,     0,     0,   157,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
      21,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,    51,
      53,    55,    57,     0,    59,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    67,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    77,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    79,    81,     0,     0,     0,     0,    83,
       0,     0,    85,     0,     0,     0,     0,    87,     0,     0,
       0,     0,     0,     0,     0,     0,    89,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   107,
     109,     0,     0,     0,     0,   111,     0,     0,   113,     0,
       0,     0,     0,   115,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    61,     0,     0,     0,     0,     0,     0,    63,     0,
       0,     0,     0,     0,     0,     0,     0,    65,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   127,   129,     0,     0,     0,     0,
       0,     0,     0,   131,     0,   133,     0,     0,     0,     0,
     135,   137,     0,     0,     0,     0,   139,   141,     0,     0,
     143,   145,     0,     0,     0,     0,   147,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   149,     0,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     3,     0,     0,     0,     0,     5,     0,     0,     7,
       0,     0,     0,     0,     9,     0,     0,     0,     0,     0,
       0,     0,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,    93,     0,     0,     0,     0,
      95,     0,     0,    97,     0,     0,     0,     0,    99,     0,
       0,     0,     0,     0,     0,     0,     0,   101,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,    78,     0,    78,     0,    78,     0,    78,     0,    78,
       0,    78,     0,   734,     0,   734,     0,   734,     0,   712,
       0,   713,     0,   716,     0,   714,     0,   775,     0,   775,
       0,   709,     0,   775,     0,   775,     0,   775,     0,   775,
       0,   612,     0,   612,     0,   612,     0,   753,     0,   753,
       0,   753,     0,   753,     0,   753,     0,   753,     0,   753,
       0,    75,     0,    75,     0,    75,     0,   513,     0,   594,
       0,   620,     0,   620,     0,   620,     0,   767,     0,   129,
       0,   129,     0,   129,     0,   129,     0,   129,     0,   129,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   621,     0,   621,     0,   128,     0,   128,
       0,   128,     0,   128,     0,   128,     0,   128,     0,   174,
       0,   172,     0,   174,     0,   580,     0,   523,     0,   523,
       0,   523,     0,   523,     0,   523,     0,   523,     0,   523,
       0,   523,     0,   523,     0,   523,     0,   523,     0,   523,
       0,   523,     0,   753,     0,   753,     0,   753,     0,   146,
       0,   146,     0,   146,     0,   142,     0,   142,     0
};

static const short int yycheck[] =
{
       9,     9,    11,    75,   276,   277,   512,   477,   522,   422,
     151,   162,   402,   181,   544,   626,   522,   422,   922,   860,
      99,   624,   682,   193,   299,   126,   349,   203,   169,   388,
     206,   586,     1,     2,   381,   348,   349,   865,   131,   184,
     387,    10,   628,  1028,   121,  1016,   404,   322,   639,     1,
     533,   764,   765,   876,    63,   986,   543,     1,     1,   789,
     991,     1,   168,    24,    35,    74,     1,   536,    40,   387,
      79,    79,   462,    82,     1,   624,   899,   207,   707,     1,
      64,    71,    11,     1,     0,   860,   909,    59,    44,   930,
     552,    93,   996,    49,     1,   104,     1,    44,   107,   107,
     179,    79,     1,     1,   113,    77,    96,     1,    93,     1,
     100,   100,    81,    82,   669,    13,     1,   579,    74,    11,
     731,   105,     1,     1,  1109,   838,   117,   857,    13,   107,
     733,     1,  1117,   846,    63,   116,   145,   278,   279,   280,
     109,   110,   131,     1,   113,   116,  1077,   494,   100,   752,
     119,   257,    13,   259,     1,   930,   100,   100,   288,   120,
     983,   644,   332,     1,   116,     1,   118,   136,   120,   638,
      97,    98,   342,   116,   492,   493,   805,   120,     1,   131,
     356,   116,   895,   192,   733,   125,   916,   131,   131,   676,
       1,   118,   119,   120,   116,     1,  1167,  1168,   125,    98,
     122,   119,   100,   752,   122,   174,   175,   176,   177,   178,
     179,   180,   119,   120,   119,   122,     1,   122,   116,    98,
     119,   120,   120,   122,  1155,   119,   195,   119,   122,  1214,
       1,   116,     1,   131,   639,   120,   511,   828,   116,   753,
     119,   120,   120,   122,   519,   520,   521,   753,   595,   119,
     120,     1,   599,   600,   117,   116,  1079,   860,   116,   365,
     607,   119,   620,   621,  1195,     1,  1197,   346,    60,   116,
     347,   441,  1113,   822,     1,   116,  1180,   595,   116,  1264,
     116,   599,   118,   119,   120,   860,     1,    98,   860,    53,
       1,  1222,  1223,   116,   860,   118,    13,   120,     1,   444,
     273,   576,   275,    24,   818,    44,    13,     1,   119,   120,
     116,   860,   818,   119,   283,     1,    88,   286,   116,    36,
      24,   330,    94,     1,  1255,   117,   335,   930,  1151,    93,
     339,   116,   404,   118,   119,   865,   415,     1,   934,   935,
     116,   616,   617,   116,     1,   931,   439,    98,   119,   120,
     119,   120,   124,   117,   116,   930,   628,   533,   930,   100,
       1,   100,  1075,   705,   930,   724,   117,   336,   337,   119,
     120,  1194,    13,  1277,     5,  1216,   117,   386,   701,  1207,
     116,   930,   118,   932,   950,   934,   935,   118,   701,   120,
     131,   118,   119,    35,    36,   404,   369,   406,    93,   116,
     121,   950,  1225,   118,   119,    13,   415,   118,   119,   116,
     379,   380,   882,  1073,  1074,   118,   119,   121,   387,   388,
    1215,   429,   835,   828,   118,   119,   435,  1140,    36,   501,
     835,    62,   118,   119,  1147,   990,   405,   509,   116,   408,
     118,   410,   411,    51,   413,   414,   415,   416,     8,   418,
     551,   118,  1048,    13,   118,   119,   425,   426,   988,    13,
    1063,   118,   119,     0,   543,   434,   808,   643,    93,   438,
     439,  1266,  1267,    29,   116,   116,   577,   118,   447,   448,
      44,    35,    36,  1196,   660,     6,    93,    96,   664,    10,
      14,   100,    29,   462,    50,    53,    52,    51,   890,  1048,
      21,    93,    58,   973,    54,  1019,    88,     1,   116,   116,
      74,     5,    94,  1019,  1063,   905,   118,    93,   120,    13,
      41,   490,   131,   492,   493,   117,    50,   116,    52,     1,
     499,   500,    69,     5,    58,   544,   118,    93,   120,    95,
       1,    13,   124,   552,   513,   715,    67,    68,   620,   621,
     559,   623,    13,    44,  1024,   524,    93,   962,   963,   118,
     119,  1283,   116,    35,    39,   534,  1288,   536,    62,    93,
     579,    95,   541,   117,   966,   967,     1,   586,    39,    51,
      71,    13,   117,    44,    16,    96,   555,    12,   860,   100,
      62,   112,   113,   114,   115,    27,    71,   566,   117,     1,
     117,   117,     1,    28,   121,    96,   953,   128,   129,   100,
      71,   620,   621,   134,    13,   733,   802,   626,   804,     1,
     131,    96,   116,     5,   118,   100,   595,  1157,  1158,    61,
     599,    13,   595,   117,   752,    96,   599,   118,    70,   100,
      39,     1,   119,   915,   116,    44,  1059,   695,    50,   697,
      52,   926,   927,    13,  1059,   116,    58,   118,   930,   931,
     669,    44,  1273,  1010,    24,   117,   117,    50,    98,   638,
       1,   116,    71,   125,     5,    58,     8,  1207,   117,    39,
      62,   760,    13,   691,    44,    65,   125,    50,   118,    52,
     120,    93,    34,    95,    36,    58,   705,    96,  1228,   867,
     779,   100,   118,     1,    46,    98,   785,   786,     5,   678,
     718,    71,   784,    33,   416,    13,   418,   116,   117,   118,
     119,   120,   731,   122,   118,   119,   695,   999,   697,   698,
      93,    62,    95,   408,   116,   410,    96,   118,   707,   708,
     100,    39,  1272,  1015,  1016,   837,    44,   839,   458,   125,
     460,   125,   903,   118,   119,   724,   116,   117,   118,   119,
     117,   121,   122,    19,    50,   125,    52,   118,   119,   125,
      19,  1285,    58,    71,     1,    97,    98,   120,  1248,  1285,
    1193,   118,   119,   118,   119,   116,    13,   117,  1193,     1,
     117,    13,   117,   934,    16,   118,   119,   116,    96,   808,
      86,    13,   100,   438,   439,    27,    28,    93,   117,    95,
     336,   337,    39,   782,   783,   782,   783,    44,   116,   117,
     118,   119,   120,  1293,   122,    47,    48,    39,   912,   913,
    1114,  1115,    44,   802,   122,   804,   805,   118,   807,    61,
     912,   913,  1266,  1267,    71,    94,   117,    96,    70,    28,
      42,   100,  1094,  1095,   823,    53,   865,   116,    50,    71,
      52,   620,   621,  1135,  1136,    57,    58,    13,   118,    96,
      16,   840,   121,   100,   123,   124,   125,    24,     8,  1067,
    1068,    27,   131,   120,    96,   116,    16,   120,   100,   116,
      20,   118,   122,   120,   122,  1167,  1168,    27,    94,  1070,
    1071,    93,    62,    95,   116,   118,   118,    53,     1,   918,
     919,   920,   921,   922,   118,    61,   925,    47,    48,   928,
      13,   890,   118,   119,    70,   121,     7,   123,   124,   125,
      36,    61,   120,    14,   116,   119,   905,   359,   360,   115,
      70,   117,   116,   116,  1216,    26,    39,   116,   116,   116,
      13,    44,    97,    34,   117,    28,    13,   121,   120,    98,
      13,    19,   120,   932,   933,   934,   935,    25,   120,    50,
      93,    52,     5,   149,   150,   151,   117,    58,    71,   988,
     117,   990,   158,  1258,  1259,  1260,  1261,   996,   117,    94,
     117,   125,   168,   169,   120,   120,   120,   966,   967,   120,
     969,   116,    11,    96,  1013,    63,    11,   100,    94,    13,
     118,    24,    93,   118,    95,    73,   121,   118,   123,   124,
     125,    24,     7,   116,    24,   118,    33,   203,    44,   205,
     206,   120,   118,    49,    50,   121,    52,   123,   124,   125,
    1049,   117,    58,   101,   102,   103,   104,     7,   106,   107,
     108,   109,   110,   111,    14,   116,    74,    49,    74,    75,
      76,   120,   122,   118,    94,   121,    26,   118,   126,   127,
       8,   118,   130,   131,   132,   133,   116,    51,    16,  1048,
     256,   257,    20,   259,    98,  1094,  1095,   116,    40,    27,
      50,   121,    52,   123,   124,   125,   121,   273,    58,   275,
     276,   277,   278,   279,   280,    24,    46,   283,    98,    47,
      48,    24,   122,    11,   116,   291,    11,     8,   116,   116,
     116,   116,    13,    61,    52,    16,    59,   116,    13,    20,
      77,    24,  1204,    93,    13,    95,    27,    28,    25,    13,
       9,   120,   118,    98,  1113,   120,    24,   119,  1157,   117,
     117,  1120,   118,  1122,  1163,  1164,    47,    48,  1166,   118,
     118,   122,   116,    13,   121,    56,    14,   116,    11,   122,
      61,  1180,    24,    24,   120,   351,    63,   118,    13,    70,
     356,  1189,   358,   359,   360,    13,    73,   116,   120,   365,
      93,   117,   368,   369,   370,   117,  1204,   118,  1207,    69,
     118,   194,    50,   379,    52,   381,   963,    55,   812,   708,
      58,   387,   388,   572,   101,   104,   555,   714,   795,   106,
     107,   108,   109,   110,   111,   435,   402,   541,   564,  1189,
     930,    79,    80,  1216,   950,    83,    84,   920,  1164,   126,
     127,   348,   113,   419,    92,    93,   133,    95,  1063,   739,
     579,   822,   664,  1268,   779,  1157,   841,  1158,   490,   283,
     775,   490,  1231,  1232,  1273,   256,  1235,  1236,  1277,   117,
     817,   491,   179,   179,  1283,   644,    69,     1,    -1,  1288,
      -1,   457,   458,     7,   460,    -1,   462,    -1,    -1,    -1,
      14,    -1,    16,    -1,    -1,    -1,   472,   473,    22,    23,
      -1,    -1,    26,    27,    -1,    -1,    30,    -1,    32,    -1,
      34,    -1,   488,    -1,   490,    -1,   492,   493,   494,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,
      -1,    55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,   533,    -1,    83,
      84,    -1,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    95,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,   121,    -1,   123,
     124,    -1,   126,   127,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   589,    -1,    -1,   592,    -1,    -1,   595,
      -1,    -1,    -1,   599,   600,    -1,   602,    -1,    -1,     1,
      -1,   607,    -1,    -1,    -1,     7,    -1,   115,    -1,   117,
      -1,    -1,    14,    -1,    16,    -1,    -1,    -1,   624,    -1,
      22,    23,   628,    -1,    26,    27,    -1,    -1,    30,    -1,
      32,    -1,    34,    -1,    -1,    -1,   642,   643,   644,   645,
      -1,   149,   150,    -1,   650,    -1,    -1,    -1,    50,    -1,
      52,   657,    -1,    55,   660,    -1,    58,    -1,   664,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   682,    79,    80,    -1,
      -1,    83,    84,    -1,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,   106,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   719,    -1,   117,    -1,    -1,   724,   121,
      -1,   123,   124,    -1,   126,   127,    -1,   733,     6,    -1,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    -1,    17,
      18,    -1,    -1,    -1,    -1,    23,   752,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    -1,    -1,    -1,    43,   772,   773,    -1,   775,
      -1,    -1,    50,    -1,    52,   283,    -1,    55,    -1,    -1,
      58,    -1,    -1,   291,    -1,    -1,    -1,    -1,    -1,    67,
      68,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    90,    91,    92,    93,   822,    95,   824,    -1,
      -1,    -1,    -1,    -1,   830,    -1,   832,    -1,    -1,    -1,
     836,   837,    -1,   839,    -1,    -1,    -1,    -1,    -1,   117,
      -1,   847,    -1,   351,    -1,   123,    -1,    -1,   356,    -1,
     358,   359,   360,    -1,   860,    -1,    -1,   863,   864,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   379,    -1,   381,    -1,    -1,    -1,    -1,    -1,   387,
     388,    -1,    -1,    -1,    -1,    -1,   892,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,    -1,   905,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   915,
      -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    14,    -1,   930,   931,    -1,   933,   934,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   950,    -1,    -1,   953,    -1,   457,
     458,    -1,   460,    -1,   462,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   982,    -1,    -1,    -1,
     488,    -1,   490,    -1,   492,   493,   494,    79,    80,    -1,
      -1,    83,    84,   999,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,  1010,    -1,    -1,    -1,    -1,  1015,
    1016,    -1,    -1,    -1,   106,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,   117,    -1,    -1,    -1,   121,
      -1,   123,   124,    -1,   126,   127,  1042,  1043,  1044,    -1,
     548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1063,    -1,    -1,
      -1,  1067,  1068,    -1,  1070,  1071,    -1,  1073,  1074,    -1,
      -1,    -1,  1078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   589,    -1,    -1,   592,    -1,    -1,   595,    -1,    -1,
      -1,   599,   600,  1099,   602,    -1,    -1,    -1,    -1,   607,
      -1,  1107,    -1,    -1,    -1,    -1,    -1,  1113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1128,    -1,    -1,    -1,    -1,    -1,    -1,  1135,
    1136,    -1,    -1,    -1,   642,    -1,    -1,   645,    -1,    -1,
      -1,    -1,   650,    -1,    -1,    -1,    -1,    -1,    -1,   657,
      -1,    -1,    -1,  1159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1167,  1168,     1,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    13,    14,    -1,  1184,    -1,
    1186,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1208,    -1,    -1,    -1,    -1,    -1,    -1,  1215,
    1216,   719,    50,    -1,    52,    -1,   724,    55,    -1,    -1,
      58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,  1237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    95,    -1,    -1,
    1266,  1267,    -1,    -1,   772,    -1,    -1,   775,   106,   107,
      -1,    -1,  1278,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,    -1,    -1,   121,     1,   123,   124,    -1,   126,   127,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    32,   824,    -1,    -1,    -1,
      -1,    -1,   830,    -1,   832,    -1,    -1,    -1,   836,   837,
      -1,   839,    -1,    50,    -1,    52,    -1,    -1,    55,   847,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   860,    -1,    -1,   863,   864,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    95,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,
     107,    -1,    -1,    -1,    -1,    -1,    -1,   905,    -1,     1,
     117,    -1,    -1,     5,   121,    -1,   123,   124,    -1,   126,
     127,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,   930,    -1,    -1,   933,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   950,    -1,    -1,   953,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   982,    -1,    -1,    79,    80,    -1,
      -1,    83,    84,    -1,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1010,    -1,   106,   107,    -1,  1015,  1016,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,   121,
      -1,   123,   124,    -1,   126,   127,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,  1042,  1043,  1044,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,
      -1,  1099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1107,
      -1,    -1,    -1,    -1,    -1,  1113,    -1,    -1,    79,    80,
      -1,    -1,    83,    84,    -1,    86,    87,    88,    89,    -1,
    1128,    92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   106,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,
     121,  1159,   123,   124,    -1,   126,   127,    -1,    95,  1167,
    1168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1184,    -1,  1186,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,
    1208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1237,
       6,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    21,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
    1278,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,    -1,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     9,   106,   107,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    22,    23,    -1,   121,
     122,   123,   124,    -1,   126,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,
     106,   107,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    22,    23,    -1,   121,   122,   123,   124,    -1,
     126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   106,   107,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   117,    22,    23,
      -1,   121,    -1,   123,   124,    -1,   126,   127,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   106,   107,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    22,    23,    -1,   121,    -1,   123,
     124,    -1,   126,   127,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,   107,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      22,    23,    -1,   121,    -1,   123,   124,    -1,   126,   127,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   106,   107,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    22,    23,    -1,   121,
      -1,   123,   124,    -1,   126,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,     1,    52,    -1,    -1,    55,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    83,    84,    -1,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    95,
      -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,
     106,   107,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,   121,    -1,   123,   124,    -1,
     126,   127,    -1,    79,    80,    -1,    -1,    83,    84,    -1,
      86,    87,    88,    89,     1,    -1,    92,    93,    94,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,
     106,   107,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,   121,    -1,   123,   124,    -1,
     126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,     1,    52,    -1,    -1,    55,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    95,    -1,
      -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,   106,
     107,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     117,    -1,    -1,    -1,   121,    -1,   123,   124,    -1,   126,
     127,    -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,
      87,    88,    89,     1,    -1,    92,    93,    94,    95,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   106,
     107,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
     117,    -1,    -1,    -1,   121,    -1,   123,   124,    -1,   126,
     127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,     1,    52,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    95,    -1,    -1,
      -1,    -1,    50,    -1,    52,    -1,    -1,    55,   106,   107,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,    -1,    -1,   121,    -1,   123,   124,    -1,   126,   127,
      -1,    79,    80,    -1,    -1,    83,    84,    -1,    86,    87,
      88,    89,     1,    -1,    92,    93,    94,    95,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   106,   107,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   117,
      -1,    -1,    -1,   121,    -1,   123,   124,    -1,   126,   127,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,     1,    52,    -1,    -1,    55,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    83,    84,    -1,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    95,    -1,    -1,    -1,
      -1,    50,    -1,    52,    -1,    -1,    55,   106,   107,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,   121,    -1,   123,   124,    -1,   126,   127,    -1,
      79,    80,    -1,    -1,    83,    84,    -1,    86,    87,    88,
      89,     1,    -1,    92,    93,    94,    95,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,   106,   107,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,   121,    -1,   123,   124,    -1,   126,   127,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,     1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    83,    84,    -1,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    95,    -1,    -1,    -1,    -1,
      50,    -1,    52,    -1,    -1,    55,   106,   107,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
      -1,   121,    -1,   123,   124,    -1,   126,   127,    -1,    79,
      80,    -1,    -1,    83,    84,    -1,    86,    87,    88,    89,
       1,    -1,    92,    93,    94,    95,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,   106,   107,    -1,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,   117,    -1,    -1,
      -1,   121,    -1,   123,   124,    -1,   126,   127,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
       1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    83,    84,    -1,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    95,    -1,    -1,    -1,    -1,    50,
      -1,    52,    -1,    -1,    55,   106,   107,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,
     121,    -1,   123,   124,    -1,   126,   127,    -1,    79,    80,
      -1,    -1,    83,    84,    -1,    86,    87,    88,    89,     1,
      -1,    92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    -1,    -1,   106,   107,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,
     121,    -1,   123,   124,    -1,   126,   127,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    83,    84,    -1,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    -1,    16,   106,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    27,   117,    -1,    -1,    -1,   121,
      -1,   123,   124,    -1,   126,   127,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,     9,    95,    -1,    -1,    13,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,     6,    95,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    -1,    17,
      18,    -1,    -1,    -1,    -1,    23,    -1,    25,    -1,    -1,
      -1,    -1,   118,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    52,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      68,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    81,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    -1,    95,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,    -1,    -1,    -1,    -1,   123,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    -1,   106,   107,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    -1,   117,   118,    -1,    -1,   121,    -1,
     123,   124,    -1,   126,   127,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      -1,    -1,   106,   107,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,   121,    -1,   123,
     124,    -1,   126,   127,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,   106,   107,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,   117,    -1,    -1,    -1,   121,    -1,   123,   124,
      -1,   126,   127,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
     106,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,   121,    -1,   123,   124,    -1,
     126,   127,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,
      -1,    55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    -1,    -1,    79,    80,    -1,    -1,    83,
      84,    -1,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    95,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,
      -1,    55,   106,   107,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,   121,   122,   123,
     124,    -1,   126,   127,    -1,    79,    80,    -1,    -1,    83,
      84,    -1,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    95,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,   121,    -1,   123,
     124,    -1,   126,   127,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    83,    84,    -1,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,   106,   107,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,   121,
      -1,   123,   124,    -1,   126,   127,    -1,    79,    80,    -1,
      -1,    83,    84,    -1,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    -1,    16,   106,   107,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    27,   117,    -1,    -1,    -1,   121,
      -1,   123,   124,    -1,   126,   127,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,   106,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,   121,    -1,
     123,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    83,    84,    -1,    86,    87,    88,    89,     1,
      -1,    92,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,   106,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,   117,    -1,    -1,    -1,
     121,    -1,   123,   124,    36,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    -1,    -1,     1,    90,    91,
      92,    93,    -1,    95,     8,    -1,    -1,    99,    -1,    13,
      -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    36,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,     1,    -1,    -1,    90,    91,    92,    93,
       8,    95,    -1,    -1,    -1,    13,    -1,    -1,    16,    -1,
      -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      28,    -1,    -1,    -1,    -1,    -1,    34,    -1,    36,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,     1,    -1,
      -1,    -1,    90,    91,    92,    93,    -1,    95,    -1,    -1,
      13,    -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    -1,    36,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    95,    -1,    -1,    13,    -1,    -1,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,     1,    -1,
      -1,    -1,    90,    91,    92,    93,     9,    95,    -1,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,     1,
      -1,    -1,    90,    91,    92,    93,    -1,    95,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,     1,    -1,    -1,    90,    91,
      92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
       9,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,   131,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    14,    -1,    16,
      -1,    90,    91,    92,    93,    -1,    95,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    14,
      -1,    16,    -1,    90,    91,    92,    93,    -1,    95,    -1,
      -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    16,    -1,    -1,    -1,    90,    91,    92,    93,    -1,
      95,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    16,    -1,    -1,    -1,    90,    91,    92,    93,    -1,
      95,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,
      95,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    -1,    95,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    95,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      -1,    95,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    -1,    95,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    -1,    95,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    95,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    95
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,    29,    69,    93,   136,   137,   140,   147,   152,   169,
     408,     1,    39,    40,    41,    42,    43,    44,    45,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    90,    91,
      92,    93,    95,   398,   399,   401,   402,   398,     0,   143,
      44,   172,   275,   413,   398,   117,   171,   413,   171,   116,
     152,   408,   117,   138,   116,    53,    93,   170,   171,   394,
     395,   398,   116,   116,   172,   398,    46,   276,   277,   398,
     413,   179,   180,   116,   148,   144,   146,   116,   118,     1,
     119,    93,   118,   119,   100,   117,   131,   411,   189,    54,
     181,   153,   170,    93,   150,   154,   155,   172,   398,     1,
     398,   141,   277,    14,    22,    23,    55,    79,    80,    83,
      84,    86,    87,    88,    89,    92,    94,   106,   107,   117,
     121,   123,   124,   126,   127,   342,   343,   345,   347,   348,
     349,   351,   352,   353,   358,   359,   365,   378,   381,   382,
     400,   401,   342,   401,    16,    20,    27,    47,    48,    61,
      70,   139,   190,   192,   193,   199,   264,   267,   268,   269,
     182,   183,   398,   154,   149,   151,   116,     1,   125,   412,
     181,   179,   398,   117,   117,   117,   117,   117,   360,   413,
     342,   122,   342,   379,   380,   348,    95,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   354,   118,    19,    25,    63,    73,
     101,   102,   103,   104,   106,   107,   108,   109,   110,   111,
     126,   127,   130,   131,   132,   133,   383,   384,   386,   390,
       6,    10,    21,    41,    67,    68,   112,   113,   114,   115,
     128,   129,   134,   385,   387,   391,    42,    57,   401,    64,
     105,   353,    94,   121,   123,   124,   125,   410,   117,   345,
     348,   119,   398,     1,    86,   207,   208,   393,   398,   398,
     398,   398,     6,    10,    19,    21,    25,   101,   102,   103,
     104,   105,   106,   107,   126,   127,   128,   129,   130,   132,
     133,   134,   279,   389,   390,   391,   398,   411,   200,   201,
     398,     8,   297,   203,   204,   116,     1,   116,    65,   184,
     413,   412,   150,     1,   173,   174,   398,   145,   196,   194,
     358,   361,   342,   363,   364,   358,   361,   118,    98,     1,
     119,   122,     5,   343,   345,   344,   345,    33,   347,   346,
     347,   356,   357,   401,   356,   348,   348,   348,     1,     9,
      55,    62,    79,    80,    83,    84,    92,   117,   121,   342,
     366,   367,   368,   369,   371,   372,   376,   377,   398,   401,
     398,   118,   361,   342,   117,   125,   281,   413,     1,   116,
     119,   125,   281,   125,   125,   281,     1,   116,   119,    19,
     202,   413,   403,   412,    34,    36,    46,   205,   271,   274,
     413,   183,   183,    60,   117,   185,   413,   412,     1,   116,
     411,   154,   156,   197,   198,   199,   264,    16,    27,   142,
     195,   199,   203,   263,   268,   118,   342,   120,     1,   118,
     119,   118,   119,     1,   342,   358,   362,   342,   380,     1,
     380,   345,   347,   125,   342,   398,   342,   372,   118,   342,
     372,   373,   375,   377,     1,   342,   366,   376,    98,   122,
     116,   409,     1,   119,   120,   122,   362,   118,     1,    16,
      27,    46,    93,    99,   118,   282,   283,   287,   394,   407,
     413,   398,   285,   286,   411,   413,   208,     1,   208,   398,
     398,   398,   280,   398,   411,   413,   201,   201,   342,    36,
     298,   299,   304,   305,   206,     1,   211,   212,   396,   398,
       1,   209,   210,   398,    49,    50,    52,    58,    74,    75,
      76,   265,   272,   275,   278,   117,     1,   186,   187,   398,
     202,   174,     1,   174,   179,    93,   117,   175,   176,   412,
      28,   164,   165,   167,   203,   398,   398,    53,   157,   116,
     118,   342,   364,     1,   364,   362,   398,   118,   118,   119,
     401,    24,   120,   116,   409,     1,   116,   118,   119,   374,
     120,   122,    98,   122,   342,   368,   369,    62,   371,   342,
     377,     1,   377,   372,   118,   118,   398,   398,   394,   118,
       1,   116,   118,    36,   120,   394,   281,     1,   120,   284,
     303,   414,   398,   281,   281,   281,   284,   398,   300,   116,
     404,     6,     9,    15,    17,    18,    23,    25,    31,    37,
      38,    43,    67,    68,    73,    81,    82,    85,    90,    91,
     123,   297,   306,   307,   319,   322,   333,   335,   358,   388,
     392,   393,   401,     1,   221,   222,   398,   212,   119,   405,
     210,   405,   411,   350,   351,   413,   116,   342,   116,   116,
     181,   274,   116,   116,   186,     1,   118,   119,    97,   188,
     413,   194,     1,   177,   178,   397,   398,   407,   117,     8,
      13,    13,    28,   167,   181,    13,   270,   271,   274,   120,
     118,   360,     1,   342,   121,   370,   342,   375,   375,   372,
     342,   281,   281,   120,   288,   283,     1,    99,   283,   394,
       7,    26,    34,   289,   290,   291,   292,   295,   296,   356,
     365,   406,   120,   285,   355,   356,   212,   299,    13,   342,
     358,   392,   401,   342,   312,   315,     1,   320,   321,   342,
      93,   336,   117,   117,   342,   117,   358,   307,     5,   308,
     360,   120,     1,   116,   117,   226,   405,   398,   120,   120,
     341,   342,    93,   116,   116,   191,   118,   187,     1,   187,
     398,    13,     1,   118,   119,    98,   188,   125,   397,   177,
      11,    11,   189,   412,   342,   118,   366,    24,   285,   289,
     118,   288,    24,   121,    24,     7,   289,   284,   301,    24,
      19,    96,   334,   411,    33,   403,   403,     1,    11,   119,
     120,   117,   342,    29,   401,   363,   309,   334,   222,     1,
     222,     1,   227,   228,   394,     1,   411,   411,   229,   230,
     231,   229,   116,   273,    74,    49,   192,   266,   178,     1,
     178,   397,   398,   188,   118,   166,   168,     8,    56,   158,
     161,   164,   122,   370,   284,   296,   293,   294,   398,   342,
     121,   299,   310,   342,   342,   323,   298,   342,   321,   403,
       1,   321,   398,   352,   118,   119,   118,   118,   118,   403,
     342,   118,     1,   116,   118,   120,   223,    59,    77,   224,
     225,   229,   213,   275,     7,    14,    16,    27,    30,    32,
      45,    66,    94,   117,   123,   124,   232,   233,   236,   249,
     250,   252,   253,   255,   290,   342,   355,   356,   365,   401,
     406,   410,   414,   100,   342,   342,   350,   297,   302,   303,
     304,   302,   159,   162,    51,   409,     1,   116,   122,    98,
     294,     1,   326,   327,   328,   330,   331,   341,   318,     1,
      12,    28,   332,   403,    35,   316,   302,   118,   120,   362,
     398,   302,   228,     1,   228,   356,   229,   116,    98,   117,
     256,   413,    40,   257,   413,   257,    71,    96,   100,   261,
     262,   413,    39,   219,   261,   121,   121,   237,   413,   281,
     281,     1,   240,   241,   242,   243,   394,   413,    24,   233,
     355,   254,   255,   365,   398,     1,   251,   398,   254,   365,
      95,   254,    98,   117,   121,   234,   236,   342,    46,   372,
     116,   116,   116,   116,   116,   116,   163,   298,   163,   160,
     294,     1,   294,    24,   398,   122,   311,     1,   116,   409,
       1,   119,   120,     1,    98,    11,   342,   302,   313,    11,
     404,   337,   338,   339,   351,   413,   118,   360,   404,   261,
      52,    13,     1,   356,    59,    77,     1,   372,     1,   220,
     214,   413,     1,   238,   239,   249,   356,   406,   239,    24,
     284,    13,    13,     9,     1,   116,   409,   120,   230,   118,
       1,   118,   119,   342,     1,   235,   342,   342,    98,   254,
     217,   413,   298,     7,   291,   120,    24,     5,    62,   324,
     325,   328,     1,   328,   331,     1,   331,   329,   341,     1,
     341,   403,   317,   404,   342,   302,   118,   120,   119,   117,
     118,   118,   118,   256,   256,   342,   116,     1,   119,   122,
     122,   230,   245,   248,   249,   398,   401,   243,     1,   243,
     230,   398,     1,   398,     1,   118,   119,   122,   342,   116,
     356,   356,    13,   403,   403,   302,    11,   314,   404,   337,
     339,   342,     1,   258,   259,   413,   258,    49,    74,   215,
     218,   275,   239,   239,    24,    24,   120,   261,   342,     1,
     342,   218,   298,   302,   404,   403,   404,   118,   120,   118,
      13,    16,    27,    40,    44,    47,    48,    72,    78,    93,
     260,   275,   394,    13,   350,   342,   230,     1,   246,   247,
     330,   248,   356,   404,   404,   302,   340,   351,   398,   398,
     398,   398,   342,   116,   120,    93,     1,   116,   409,   120,
     404,   118,   119,   281,   281,   281,   281,   230,   216,   247,
     247,   244,   325,   117,   351,   285,   261,   342,   117,   240,
     284,   240,   118,   118,   409
};


/* Prevent warning if -Wmissing-prototypes.  */
int yyparse (void);

/* Error token number */
#define YYTERROR 1

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */


#define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)

/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# define YY_LOCATION_PRINT(File, Loc)			\
    fprintf (File, "%d.%d-%d.%d",			\
             (Loc).first_line, (Loc).first_column,	\
             (Loc).last_line,  (Loc).last_column)
#endif


#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#define YYLEX yylex ()

YYSTYPE yylval;

YYLTYPE yylloc;

int yynerrs;
int yychar;

static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)							     \
   do { YYRESULTTAG yyflag = YYE; if (yyflag != yyok) return yyflag; }	     \
   while (0)

#if YYDEBUG

#if ! defined (YYFPRINTF)
#  define YYFPRINTF fprintf
#endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  fprintf (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call expandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data. */
#define YYHEADROOM 2

#if (! defined (YYSTACKEXPANDABLE) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
	     && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))
#define YYSTACKEXPANDABLE 1
#else
#define YYSTACKEXPANDABLE 0
#endif

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef short int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;
typedef struct yyGLRStateSet yyGLRStateSet;

struct yyGLRState {
  yybool yyisState;
  yybool yyresolved;
  yyStateNum yylrState;
  yyGLRState* yypred;
  size_t yyposn;
  union {
    yySemanticOption* yyfirstVal;
    YYSTYPE yysval;
  } yysemantics;
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  yybool yyisState;
  yyRuleNum yyrule;
  yyGLRState* yystate;
  yySemanticOption* yynext;
};

union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrflag;
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  yySymbol* yytokenp;
  jmp_buf yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  int yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

static void yyinitGLRStack (yyGLRStack* yystack, size_t yysize);
static void yyexpandGLRStack (yyGLRStack* yystack);
static void yyfreeGLRStack (yyGLRStack* yystack);

static void
yyFail (yyGLRStack* yystack, const char* yyformat, ...)
{
  yystack->yyerrflag = 1;
  if (yyformat != NULL)
    {
      char yymsg[256];
      va_list yyap;
      va_start (yyap, yyformat);
      vsprintf (yymsg, yyformat, yyap);
      yyerror (yymsg);
    }
  longjmp (yystack->yyexception_buffer, 1);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  Valid until next call to
 *  tokenName. */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain. Assumes
 *  YYLOW1 < YYLOW0.  */
static void yyfillin (yyGLRStackItem *, int, int) ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  yyGLRState* s;
  int i;
  s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
      YYASSERT (s->yyresolved);
      yyvsp[i].yystate.yyresolved = yytrue;
      yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
   YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
   For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$). Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT. */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, int yyrhslen, yyGLRStackItem* yyvsp,
	      YYSTYPE* yyvalp,
	      YYLTYPE* yylocp,
	      yyGLRStack* yystack
              )
{
  yybool yynormal ATTRIBUTE_UNUSED = (yystack->yysplitPoint == NULL);
  int yylow;

# undef yyerrok
# define yyerrok (yystack->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING (yystack->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = *(yystack->yytokenp) = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)						     \
  return yyerror ("syntax error: cannot back up"),	     \
	 yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT (*yylocp, yyvsp - yyrhslen, yyrhslen);
  yystack->yyerror_range[1].yystate.yyloc = *yylocp;

  switch (yyn)
    {
        case 2:
#line 211 "parse.y"
    { error ("empty input file"); ;}
    break;

  case 3:
#line 213 "parse.y"
    {
        if (co->ignore_garbage_after_dot)
          {
            discard_input ();
            YYACCEPT;
          }
      ;}
    break;

  case 4:
#line 224 "parse.y"
    { initialize_module (TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))), 0); ;}
    break;

  case 5:
#line 226 "parse.y"
    { start_main_program (); ;}
    break;

  case 6:
#line 228 "parse.y"
    { finish_main_program (); ;}
    break;

  case 7:
#line 230 "parse.y"
    { finalize_module (0); ;}
    break;

  case 8:
#line 235 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 9:
#line 237 "parse.y"
    { start_unit_implementation (); ;}
    break;

  case 10:
#line 239 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 13:
#line 243 "parse.y"
    { ((*yyvalp).ttype) = current_module->name; finalize_module (1); ;}
    break;

  case 14:
#line 245 "parse.y"
    {
        if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype) && current_module->name != (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))
          error ("implementation of module `%s' following interface of module `%s'",
                 IDENTIFIER_NAME (current_module->name), IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 15:
#line 251 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 16:
#line 253 "parse.y"
    {
        if (co->interface_only)
          exit_compilation ();
      ;}
    break;

  case 18:
#line 259 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 4); ;}
    break;

  case 20:
#line 265 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); ;}
    break;

  case 21:
#line 267 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 22:
#line 269 "parse.y"
    { clear_forward_decls ();  /* don't complain in poplevel */ ;}
    break;

  case 23:
#line 274 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_export); start_module_interface (); ;}
    break;

  case 24:
#line 276 "parse.y"
    { create_gpi_files (); ;}
    break;

  case 25:
#line 281 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE, 3); ;}
    break;

  case 27:
#line 286 "parse.y"
    { current_module->implementation = 1; ;}
    break;

  case 28:
#line 288 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 30:
#line 293 "parse.y"
    { chk_dialect ("units without `implementation' part are", U_M_PASCAL); ;}
    break;

  case 32:
#line 299 "parse.y"
    { start_constructor (0); ;}
    break;

  case 35:
#line 303 "parse.y"
    { start_destructor (); ;}
    break;

  case 36:
#line 305 "parse.y"
    { finish_destructor (); ;}
    break;

  case 38:
#line 311 "parse.y"
    { start_constructor (0); ;}
    break;

  case 40:
#line 317 "parse.y"
    { finish_constructor (); ;}
    break;

  case 45:
#line 329 "parse.y"
    { chk_dialect_name ("to begin do", E_O_PASCAL); start_constructor (0); ;}
    break;

  case 46:
#line 331 "parse.y"
    { finish_constructor (); ;}
    break;

  case 47:
#line 336 "parse.y"
    { chk_dialect_name ("to end do", E_O_PASCAL); start_destructor (); ;}
    break;

  case 48:
#line 338 "parse.y"
    { finish_destructor (); ;}
    break;

  case 49:
#line 343 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 50:
#line 345 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 51:
#line 347 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 52:
#line 352 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 54:
#line 358 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 58:
#line 369 "parse.y"
    { yyerrok; ;}
    break;

  case 59:
#line 371 "parse.y"
    { error ("module specifications need an export part"); ;}
    break;

  case 60:
#line 373 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 61:
#line 375 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 62:
#line 380 "parse.y"
    { export_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 63:
#line 385 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 65:
#line 388 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 66:
#line 393 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_all); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 68:
#line 399 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 69:
#line 401 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 70:
#line 403 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 71:
#line 405 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 72:
#line 410 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 73:
#line 412 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 74:
#line 414 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); TREE_READONLY (((*yyvalp).ttype)) = 1; ;}
    break;

  case 75:
#line 418 "parse.y"
    { do_extra_import (); ;}
    break;

  case 81:
#line 431 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 82:
#line 436 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype) ? IMPORT_QUALIFIED : IMPORT_ISO, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 86:
#line 447 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 87:
#line 449 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 89:
#line 455 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 90:
#line 457 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 91:
#line 459 "parse.y"
    { error ("missing comma"); ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 92:
#line 461 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 93:
#line 466 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 95:
#line 472 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 96:
#line 477 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 97:
#line 479 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 100:
#line 489 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 101:
#line 491 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 102:
#line 495 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 103:
#line 497 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 104:
#line 499 "parse.y"
    { ((*yyvalp).itype) = od_label; ;}
    break;

  case 105:
#line 501 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 106:
#line 506 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 107:
#line 508 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 110:
#line 515 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 111:
#line 520 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 112:
#line 522 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 114:
#line 527 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 115:
#line 529 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 116:
#line 531 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 117:
#line 536 "parse.y"
    { ((*yyvalp).itype) = od_uses; ;}
    break;

  case 120:
#line 543 "parse.y"
    { warning ("missing comma"); yyerrok; ;}
    break;

  case 121:
#line 548 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, IMPORT_USES, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 123:
#line 554 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("file name specification with `in' is", BORLAND_DELPHI); ;}
    break;

  case 124:
#line 558 "parse.y"
    {
#ifndef EGCS97
        push_obstacks_nochange ();
        end_temporary_allocation ();
#endif
      ;}
    break;

  case 125:
#line 565 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype);
      ;}
    break;

  case 126:
#line 575 "parse.y"
    { ((*yyvalp).itype) = od_const; ;}
    break;

  case 127:
#line 577 "parse.y"
    { current_type_list = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 128:
#line 579 "parse.y"
    { declare_types (); ((*yyvalp).itype) = od_type; ;}
    break;

  case 129:
#line 581 "parse.y"
    { ((*yyvalp).itype) = od_var; ;}
    break;

  case 130:
#line 588 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 131:
#line 590 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 132:
#line 592 "parse.y"
    { error ("non-label in label_list"); ;}
    break;

  case 133:
#line 594 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 134:
#line 596 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 137:
#line 603 "parse.y"
    { chk_dialect ("non-numeric labels are", B_D_M_PASCAL); ;}
    break;

  case 141:
#line 614 "parse.y"
    { declare_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 142:
#line 617 "parse.y"
    {
        lex_const_equal = -1;
        declare_variables (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), VQ_BP_CONST, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 145:
#line 630 "parse.y"
    {
        tree t, ids = ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          TREE_PRIVATE (ids) = !!allow_function_calls (0);  /* kludge */
        /* With `begin var Foo: Integer; Foo := ...' where `Foo'
           is a built-in identifier, parser look-ahead would already get
           its special meaning before we get to declaring the variables.
           So mark the identifiers. (fjf791.pas) */
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 1;
      ;}
    break;

  case 146:
#line 643 "parse.y"
    {
        tree t, ids = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype);
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 0;
        lex_const_equal = -1;
        ((*yyvalp).ttype) = declare_variables (ids, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          allow_function_calls (TREE_PRIVATE (ids));
        yyerrok;
      ;}
    break;

  case 147:
#line 655 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; lex_const_equal = -1; ;}
    break;

  case 149:
#line 661 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 151:
#line 667 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 152:
#line 669 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 153:
#line 671 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 155:
#line 677 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 156:
#line 682 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 157:
#line 684 "parse.y"
    { ((*yyvalp).ttype) = TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 159:
#line 690 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); lex_const_equal = -1; ;}
    break;

  case 160:
#line 692 "parse.y"
    {
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype));
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        PASCAL_ABSOLUTE_CLAUSE (((*yyvalp).ttype)) = 1;
      ;}
    break;

  case 161:
#line 698 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 163:
#line 704 "parse.y"
    { yyerrok; ;}
    break;

  case 165:
#line 707 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 166:
#line 709 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 168:
#line 715 "parse.y"
    {
        lex_const_equal = -1;
        if (!EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
          {
            if (PASCAL_TYPE_UNDISCRIMINATED_SCHEMA ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
              chk_dialect ("undiscriminated schemata on the right side of a type definition are", GNU_PASCAL);
            build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
          }
      ;}
    break;

  case 169:
#line 725 "parse.y"
    {
        ((*yyvalp).itype) = immediate_size_expand;
        immediate_size_expand = 0;
        size_volatile++;
      ;}
    break;

  case 170:
#line 731 "parse.y"
    {
        build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), NULL_TREE);
        immediate_size_expand = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype);
        size_volatile--;
      ;}
    break;

  case 171:
#line 737 "parse.y"
    { build_schema_type (error_mark_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 172:
#line 739 "parse.y"
    { ((*yyvalp).ttype) = start_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 173:
#line 741 "parse.y"
    { lex_const_equal = -1; finish_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype) != NULL_TREE); yyerrok; ;}
    break;

  case 174:
#line 743 "parse.y"
    { ((*yyvalp).ttype) = start_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 175:
#line 745 "parse.y"
    {
        lex_const_equal = -1;
        finish_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype) != NULL_TREE);
        yyerrok;
      ;}
    break;

  case 176:
#line 751 "parse.y"
    {
        tree t = build_pascal_pointer_type (make_node (LANG_TYPE));
        PASCAL_TYPE_CLASS (t) = 1;
        build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), t, NULL_TREE);
        warning("ignored parent in Delphi forward class declaration");
      ;}
    break;

  case 177:
#line 758 "parse.y"
    {
        tree t = build_pascal_pointer_type (make_node (LANG_TYPE));
	PASCAL_TYPE_CLASS (t) = 1;
	build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), t, NULL_TREE); 
      ;}
    break;

  case 178:
#line 764 "parse.y"
    {
        tree t = build_pascal_pointer_type (make_node (LANG_TYPE));
        PASCAL_TYPE_CLASS (t) = 1;
        build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), t, NULL_TREE);
      ;}
    break;

  case 179:
#line 773 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 180:
#line 775 "parse.y"
    { error ("invalid schema discriminants"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 182:
#line 781 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 183:
#line 783 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 184:
#line 785 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 186:
#line 791 "parse.y"
    { ((*yyvalp).ttype) = build_discriminants ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 188:
#line 797 "parse.y"
    { type_attributes (&((*yyvalp).ttype), TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 189:
#line 802 "parse.y"
    {
#ifndef EGCS97
        push_obstacks_nochange ();
        end_temporary_allocation ();
#endif
      ;}
    break;

  case 190:
#line 809 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
      ;}
    break;

  case 192:
#line 820 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_BINDABLE); ;}
    break;

  case 194:
#line 826 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_RESTRICTED); ;}
    break;

  case 195:
#line 828 "parse.y"
    { ((*yyvalp).ttype) = build_discriminated_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 199:
#line 833 "parse.y"
    { chk_dialect ("procedural variables and types are", B_D_M_PASCAL); ;}
    break;

  case 201:
#line 836 "parse.y"
    { defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) ? pack_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 202:
#line 841 "parse.y"
    { chk_dialect ("schema/string discriminants are", E_O_M_PASCAL); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 203:
#line 843 "parse.y"
    {
        chk_dialect ("string capacity in brackets is", U_B_D_M_PASCAL);
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 0)));
      ;}
    break;

  case 204:
#line 852 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0))); ;}
    break;

  case 205:
#line 854 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)))); yyerrok; ;}
    break;

  case 206:
#line 856 "parse.y"
    { error ("missing expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 207:
#line 858 "parse.y"
    { error ("missing comma"); ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)))); yyerrok; ;}
    break;

  case 208:
#line 860 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 209:
#line 865 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_array_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 211:
#line 868 "parse.y"
    { ((*yyvalp).ttype) = build_file_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 212:
#line 870 "parse.y"
    { ((*yyvalp).ttype) = build_set_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 213:
#line 872 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 214:
#line 874 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 217:
#line 881 "parse.y"
    { ((*yyvalp).ttype) = TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 219:
#line 887 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 220:
#line 889 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 221:
#line 891 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 222:
#line 893 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 223:
#line 898 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 224:
#line 900 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 225:
#line 905 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 226:
#line 907 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 227:
#line 909 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 231:
#line 920 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 232:
#line 922 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 233:
#line 924 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 235:
#line 930 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 236:
#line 935 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 237:
#line 937 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 238:
#line 942 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 239:
#line 944 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 240:
#line 946 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 241:
#line 948 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 243:
#line 954 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 244:
#line 956 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 245:
#line 958 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 247:
#line 964 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 248:
#line 969 "parse.y"
    { chk_dialect ("type denoters (no identifiers) as variant tag type are", U_B_D_M_PASCAL); ;}
    break;

  case 251:
#line 979 "parse.y"
    { ((*yyvalp).ttype) = build_enum_type (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 252:
#line 981 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 253:
#line 986 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 254:
#line 988 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 255:
#line 990 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 256:
#line 992 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 258:
#line 998 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 259:
#line 1000 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype);
        chk_dialect ("packed subrange types are", B_D_PASCAL);
        ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
      ;}
    break;

  case 260:
#line 1009 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 261:
#line 1011 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 262:
#line 1013 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 263:
#line 1015 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type (p_build_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, TYPE_VOLATILE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 264:
#line 1020 "parse.y"
    { ((*yyvalp).ttype) = get_pointer_domain_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 265:
#line 1022 "parse.y"
    {
        chk_dialect ("pointers to routines are", GNU_PASCAL);
        gcc_assert (EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) || (TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE && TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))));
        ((*yyvalp).ttype) = TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 267:
#line 1032 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 268:
#line 1034 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 270:
#line 1040 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 271:
#line 1042 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 275:
#line 1053 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 276:
#line 1055 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 278:
#line 1061 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 279:
#line 1063 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 280:
#line 1068 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 281:
#line 1070 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 282:
#line 1072 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 283:
#line 1074 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 284:
#line 1076 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 285:
#line 1078 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 286:
#line 1080 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 287:
#line 1082 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 288:
#line 1084 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 291:
#line 1091 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 292:
#line 1093 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 293:
#line 1097 "parse.y"
    { lex_const_equal = -1; ;}
    break;

  case 294:
#line 1099 "parse.y"
    { chk_dialect ("initialization with `:=' is", VAX_PASCAL); ;}
    break;

  case 295:
#line 1101 "parse.y"
    { chk_dialect ("initialization with `=' is", BORLAND_DELPHI); ;}
    break;

  case 296:
#line 1108 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 297:
#line 1119 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 298:
#line 1121 "parse.y"
    { ((*yyvalp).ttype) = start_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 299:
#line 1123 "parse.y"
    {
        do_setjmp ();
        un_initialize_block (getdecls (), 0, 0);
      ;}
    break;

  case 300:
#line 1128 "parse.y"
    { finish_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 303:
#line 1138 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 304:
#line 1140 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 305:
#line 1142 "parse.y"
    { ((*yyvalp).ttype) = build_operator_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 306:
#line 1152 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 307:
#line 1154 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 308:
#line 1156 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 309:
#line 1158 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 312:
#line 1168 "parse.y"
    { ((*yyvalp).ttype) = chainon (chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 313:
#line 1173 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 314:
#line 1175 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 315:
#line 1177 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 316:
#line 1179 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 317:
#line 1181 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 318:
#line 1183 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 319:
#line 1185 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 320:
#line 1187 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 321:
#line 1189 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 323:
#line 1195 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 324:
#line 1197 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 325:
#line 1202 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 327:
#line 1208 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 329:
#line 1214 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 330:
#line 1216 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 331:
#line 1218 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 332:
#line 1220 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 333:
#line 1222 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 339:
#line 1238 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("operator result variables with `=' are", GNU_PASCAL); ;}
    break;

  case 340:
#line 1240 "parse.y"
    { error ("missing operator result variable"); ;}
    break;

  case 342:
#line 1246 "parse.y"
    { chk_dialect ("empty parentheses are", BORLAND_DELPHI); ((*yyvalp).ttype) = void_list_node; ;}
    break;

  case 343:
#line 1248 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 344:
#line 1250 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 345:
#line 1252 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, NULL_TREE)); ;}
    break;

  case 346:
#line 1254 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 348:
#line 1260 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 349:
#line 1262 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 351:
#line 1268 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 352:
#line 1270 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 1); ;}
    break;

  case 353:
#line 1272 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, !!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 354:
#line 1274 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2, 1); ;}
    break;

  case 355:
#line 1276 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 356:
#line 1278 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 357:
#line 1283 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 358:
#line 1285 "parse.y"
    { ((*yyvalp).ttype) = check_result_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 361:
#line 1292 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("function result variable specifications are", E_O_PASCAL); ;}
    break;

  case 363:
#line 1298 "parse.y"
    { chk_dialect ("function result variables without `=' are", GNU_PASCAL); ;}
    break;

  case 366:
#line 1308 "parse.y"
    { ((*yyvalp).ttype) = void_type_node; chk_dialect ("untyped parameters are", U_B_D_M_PASCAL); ;}
    break;

  case 367:
#line 1310 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 371:
#line 1321 "parse.y"
    { ((*yyvalp).ttype) = build_type_of ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 374:
#line 1331 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 375:
#line 1333 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        PASCAL_TREE_PACKED ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 377:
#line 1343 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 378:
#line 1345 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 380:
#line 1351 "parse.y"
    { TREE_TYPE ((((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 381:
#line 1356 "parse.y"
    { TREE_TYPE ((((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 384:
#line 1368 "parse.y"
    { yyerrok; ;}
    break;

  case 386:
#line 1374 "parse.y"
    { yyerrok; ;}
    break;

  case 389:
#line 1381 "parse.y"
    { chk_dialect ("variable declarations in the statement part are", GNU_PASCAL); pushlevel_expand (1); ;}
    break;

  case 390:
#line 1383 "parse.y"
    { un_initialize_block ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 392:
#line 1389 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 393:
#line 1391 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 395:
#line 1399 "parse.y"
    { mark_temporary_levels (); ;}
    break;

  case 396:
#line 1401 "parse.y"
    { release_temporary_levels (); ;}
    break;

  case 401:
#line 1416 "parse.y"
    { expand_call_statement ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 402:
#line 1418 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (!PASCAL_PROCEDURAL_TYPE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 403:
#line 1420 "parse.y"
    { expand_pascal_assignment ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 404:
#line 1422 "parse.y"
    { build_predef_call (p_Return, NULL_TREE); ;}
    break;

  case 405:
#line 1424 "parse.y"
    { build_predef_call (p_Return, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 406:
#line 1426 "parse.y"
    { build_predef_call (p_Exit, NULL_TREE); ;}
    break;

  case 407:
#line 1428 "parse.y"
    { build_predef_call (p_Exit, build_tree_list (NULL_TREE, void_type_node)); ;}
    break;

  case 408:
#line 1430 "parse.y"
    { build_predef_call (p_Exit, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 410:
#line 1433 "parse.y"
    { restore_identifiers ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 411:
#line 1435 "parse.y"
    { expand_end_cond (); ;}
    break;

  case 412:
#line 1437 "parse.y"
    { expand_start_else (); ;}
    break;

  case 413:
#line 1439 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `else'");
        expand_end_cond ();
      ;}
    break;

  case 414:
#line 1445 "parse.y"
    { ((*yyvalp).ttype) = pascal_expand_start_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 415:
#line 1447 "parse.y"
    {
        if (!EM (current_case_values))
          {
            tree duplicate;
            int res = pushcase (NULL_TREE, NULL, build_decl (LABEL_DECL, NULL_TREE, NULL_TREE), &duplicate);
            gcc_assert (!res);
          }
      ;}
    break;

  case 416:
#line 1456 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype) && !(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype))
          chk_dialect ("empty `case' statements are", MAC_PASCAL);
        expand_exit_something ();
        if (!EM (current_case_values))
          expand_end_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype));
        current_case_values = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype);
        yyerrok;
      ;}
    break;

  case 417:
#line 1466 "parse.y"
    { emit_nop (); expand_start_loop_continue_elsewhere (1); ;}
    break;

  case 418:
#line 1468 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_loop_continue_here (); ;}
    break;

  case 419:
#line 1470 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, build_pascal_unary_op (TRUTH_NOT_EXPR, check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 420:
#line 1472 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 421:
#line 1474 "parse.y"
    { expand_start_loop (1); ;}
    break;

  case 422:
#line 1476 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 423:
#line 1478 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 424:
#line 1480 "parse.y"
    { ((*yyvalp).ttype) = start_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 425:
#line 1482 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 426:
#line 1484 "parse.y"
    { ((*yyvalp).ttype) = start_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 427:
#line 1486 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 428:
#line 1488 "parse.y"
    { pascal_expand_goto ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 429:
#line 1493 "parse.y"
    { set_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 431:
#line 1499 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 432:
#line 1501 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 433:
#line 1503 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 434:
#line 1505 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 435:
#line 1510 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 436:
#line 1512 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 437:
#line 1517 "parse.y"
    { expand_start_cond (check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), 0); ;}
    break;

  case 438:
#line 1519 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `then'");
      ;}
    break;

  case 439:
#line 1527 "parse.y"
    {
        /* Create an implicit `otherwise' (in the rule above) to avoid warnings
           about unhandled cases. In ISO Pascal, this is a run-time error. */
        if (co->case_value_checking)
          build_predef_call (p_CaseNoMatchError, NULL_TREE);
        ((*yyvalp).itype) = 0;
      ;}
    break;

  case 440:
#line 1535 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 441:
#line 1540 "parse.y"
    { chk_dialect ("`else' in `case' statements is", B_D_M_PASCAL); ;}
    break;

  case 443:
#line 1546 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 444:
#line 1548 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 446:
#line 1554 "parse.y"
    { yyerrok; ;}
    break;

  case 447:
#line 1556 "parse.y"
    { error ("case element expected"); ;}
    break;

  case 448:
#line 1558 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 449:
#line 1560 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 450:
#line 1565 "parse.y"
    { pascal_pushcase ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 451:
#line 1567 "parse.y"
    { expand_exit_something (); ;}
    break;

  case 453:
#line 1573 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 454:
#line 1575 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 455:
#line 1577 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 457:
#line 1583 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 458:
#line 1585 "parse.y"
    { chk_dialect ("`case' ranges are", NOT_CLASSIC_PASCAL); ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 459:
#line 1587 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing `..'"); yyerrok; ;}
    break;

  case 460:
#line 1589 "parse.y"
    { error ("extra `..'"); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0)); ;}
    break;

  case 461:
#line 1594 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 462:
#line 1596 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 463:
#line 1598 "parse.y"
    { error ("missing `to' or `downto'"); ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 465:
#line 1604 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_lvalue_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 467:
#line 1610 "parse.y"
    { error ("using `=' instead of `:=' in assignment"); ;}
    break;

  case 468:
#line 1615 "parse.y"
    { build_predef_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 469:
#line 1617 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol, NULL_TREE); ;}
    break;

  case 470:
#line 1619 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 471:
#line 1621 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 472:
#line 1623 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 473:
#line 1625 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 474:
#line 1627 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 475:
#line 1629 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 476:
#line 1631 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 477:
#line 1633 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-9)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 478:
#line 1638 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 479:
#line 1640 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_volatile); ((*yyvalp).itype) = 1; ;}
    break;

  case 483:
#line 1651 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 484:
#line 1656 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 485:
#line 1661 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 486:
#line 1663 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 487:
#line 1670 "parse.y"
    {
        ((*yyvalp).ttype) = string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0);
        if (PEDANTIC (NOT_CLASSIC_PASCAL)
            && (TREE_CODE_CLASS (TREE_CODE (((*yyvalp).ttype))) != 'c'
                || TREE_CODE (((*yyvalp).ttype)) == STRING_CST
                || !PASCAL_CST_FRESH (((*yyvalp).ttype))
                || PASCAL_CST_PARENTHESES (((*yyvalp).ttype))))
          error ("ISO 7185 Pascal allows only simple constants");
      ;}
    break;

  case 488:
#line 1683 "parse.y"
    { ((*yyvalp).ttype) = fold ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 489:
#line 1685 "parse.y"
    { ((*yyvalp).ttype) = fold (parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 491:
#line 1691 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 492:
#line 1693 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 493:
#line 1695 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 494:
#line 1697 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 495:
#line 1699 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 497:
#line 1705 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 498:
#line 1707 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 499:
#line 1709 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 500:
#line 1711 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 502:
#line 1717 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 503:
#line 1719 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POW_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 504:
#line 1721 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POWER_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 505:
#line 1723 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_is); ;}
    break;

  case 506:
#line 1725 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_as); ;}
    break;

  case 507:
#line 1730 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code (build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 508:
#line 1732 "parse.y"
    { chk_dialect ("the address operator is", B_D_M_PASCAL); ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), !co->typed_address); ;}
    break;

  case 511:
#line 1736 "parse.y"
    { ((*yyvalp).ttype) = null_pointer_node; ;}
    break;

  case 513:
#line 1739 "parse.y"
    { ((*yyvalp).ttype) = build_variable_or_routine_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 519:
#line 1755 "parse.y"
    { ((*yyvalp).ttype) = combine_strings ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 520:
#line 1760 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 521:
#line 1762 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 524:
#line 1769 "parse.y"
    { ((*yyvalp).ttype) = build_caret_string_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 543:
#line 1780 "parse.y"
    {
        if (PASCAL_TYPE_UNDISCRIMINATED_STRING (((*yyvalp).ttype)))
          {
            if (!(co->pascal_dialect & B_D_M_PASCAL))
              error_or_warning (co->pascal_dialect & E_O_PASCAL, "missing string capacity -- assuming 255");
            ((*yyvalp).ttype) = string255_type_node;
          }
      ;}
    break;

  case 544:
#line 1792 "parse.y"
    {
        tree decl = lookup_name ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        ((*yyvalp).ttype) = error_mark_node;
        if (!decl)
          error ("unknown identifier `%s'", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else if (TREE_CODE (decl) != TYPE_DECL)
          error ("type name expected, `%s' given", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else
          ((*yyvalp).ttype) = TREE_TYPE (decl);
      ;}
    break;

  case 546:
#line 1807 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 547:
#line 1812 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 550:
#line 1819 "parse.y"
    { ((*yyvalp).ttype) = TYPE_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 551:
#line 1821 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NOP_EXPR); ;}
    break;

  case 552:
#line 1823 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_or_component_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 553:
#line 1825 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_pointer_reference ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 554:
#line 1827 "parse.y"
    { ((*yyvalp).ttype) = build_array_ref_or_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 555:
#line 1829 "parse.y"
    { ((*yyvalp).ttype) = build_iso_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 556:
#line 1831 "parse.y"
    { chk_dialect ("empty parentheses are", BORLAND_DELPHI | MAC_PASCAL); ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 557:
#line 1833 "parse.y"
    { allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype)); ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 558:
#line 1835 "parse.y"
    { ((*yyvalp).ttype) = build_inherited_method ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 559:
#line 1837 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_FormatString, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 560:
#line 1839 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_Assigned, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 561:
#line 1841 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), co->pascal_dialect & B_D_M_PASCAL); ;}
    break;

  case 562:
#line 1843 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 563:
#line 1845 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 564:
#line 1847 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 566:
#line 1853 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); yyerrok; ;}
    break;

  case 567:
#line 1855 "parse.y"
    {
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) == TYPE_DECL ? (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype) : build_variable_or_routine_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
        yyerrok;
      ;}
    break;

  case 568:
#line 1863 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); ;}
    break;

  case 569:
#line 1868 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 570:
#line 1870 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); yyerrok; ;}
    break;

  case 571:
#line 1872 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); ;}
    break;

  case 572:
#line 1874 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); error ("extra comma"); ;}
    break;

  case 574:
#line 1880 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 575:
#line 1882 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 576:
#line 1884 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 577:
#line 1890 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 578:
#line 1892 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 579:
#line 1894 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 580:
#line 1899 "parse.y"
    { chk_dialect ("untyped files are", U_B_D_M_PASCAL); ((*yyvalp).ttype) = untyped_file_type_node; ;}
    break;

  case 582:
#line 1905 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 583:
#line 1907 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 587:
#line 1915 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 588:
#line 1920 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 589:
#line 1922 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 590:
#line 1927 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 591:
#line 1929 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, integer_zero_node), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 592:
#line 1934 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 593:
#line 1939 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, NULL_TREE), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 594:
#line 1944 "parse.y"
    { ((*yyvalp).ttype) = maybe_schema_discriminant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 595:
#line 1946 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 596:
#line 1948 "parse.y"
    { PASCAL_BP_INITIALIZER_LIST ((((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))) = 1; ;}
    break;

  case 597:
#line 1950 "parse.y"
    { ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 598:
#line 1952 "parse.y"
    { error ("invalid component value"); ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 600:
#line 1958 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 601:
#line 1960 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing separator"); ;}
    break;

  case 603:
#line 1966 "parse.y"
    { chk_dialect ("initializers separated with `,' are", B_D_M_PASCAL); ;}
    break;

  case 604:
#line 1971 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 605:
#line 1973 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 607:
#line 1979 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 608:
#line 1981 "parse.y"
    { error ("missing index expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 609:
#line 1983 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 610:
#line 1985 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 611:
#line 1990 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 612:
#line 1992 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1), NULL_TREE); ;}
    break;

  case 613:
#line 1994 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 1), string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1)); ;}
    break;

  case 614:
#line 1999 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (NULL_TREE); ;}
    break;

  case 615:
#line 2001 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 617:
#line 2007 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 618:
#line 2009 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing comma"); yyerrok; ;}
    break;

  case 619:
#line 2011 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 620:
#line 2016 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 621:
#line 2018 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 622:
#line 2024 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 623:
#line 2025 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 624:
#line 2029 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 625:
#line 2030 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 626:
#line 2031 "parse.y"
    { ((*yyvalp).code) = TRUTH_NOT_EXPR; ;}
    break;

  case 627:
#line 2035 "parse.y"
    { ((*yyvalp).code) = NE_EXPR; ;}
    break;

  case 628:
#line 2036 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 629:
#line 2037 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 630:
#line 2038 "parse.y"
    { ((*yyvalp).code) = EQ_EXPR; ;}
    break;

  case 631:
#line 2039 "parse.y"
    { ((*yyvalp).code) = LT_EXPR; ;}
    break;

  case 632:
#line 2040 "parse.y"
    { ((*yyvalp).code) = GT_EXPR; ;}
    break;

  case 633:
#line 2041 "parse.y"
    { ((*yyvalp).code) = IN_EXPR; ;}
    break;

  case 634:
#line 2045 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 635:
#line 2046 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 636:
#line 2047 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 637:
#line 2048 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 638:
#line 2049 "parse.y"
    { ((*yyvalp).code) = TRUTH_XOR_EXPR; ;}
    break;

  case 639:
#line 2050 "parse.y"
    { ((*yyvalp).code) = SYMDIFF_EXPR; ;}
    break;

  case 640:
#line 2054 "parse.y"
    { ((*yyvalp).code) = MULT_EXPR; ;}
    break;

  case 641:
#line 2055 "parse.y"
    { ((*yyvalp).code) = RDIV_EXPR; ;}
    break;

  case 642:
#line 2056 "parse.y"
    { ((*yyvalp).code) = TRUNC_DIV_EXPR; ;}
    break;

  case 643:
#line 2057 "parse.y"
    { ((*yyvalp).code) = (co->pascal_dialect & B_D_M_PASCAL) ? TRUNC_MOD_EXPR : FLOOR_MOD_EXPR; ;}
    break;

  case 644:
#line 2058 "parse.y"
    { ((*yyvalp).code) = LSHIFT_EXPR; ;}
    break;

  case 645:
#line 2059 "parse.y"
    { ((*yyvalp).code) = RSHIFT_EXPR; ;}
    break;

  case 646:
#line 2063 "parse.y"
    { ((*yyvalp).code) = TRUTH_OR_EXPR; ;}
    break;

  case 647:
#line 2064 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`or else' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 648:
#line 2065 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; ;}
    break;

  case 649:
#line 2066 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`|' is", MAC_PASCAL); ;}
    break;

  case 650:
#line 2070 "parse.y"
    { ((*yyvalp).code) = TRUTH_AND_EXPR; ;}
    break;

  case 651:
#line 2071 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`and then' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 652:
#line 2072 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; ;}
    break;

  case 653:
#line 2073 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`&' is", MAC_PASCAL); ;}
    break;

  case 654:
#line 2078 "parse.y"
    { ((*yyvalp).itype) = IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol; ;}
    break;

  case 655:
#line 2080 "parse.y"
    { ((*yyvalp).itype) = p_and; ;}
    break;

  case 656:
#line 2081 "parse.y"
    { ((*yyvalp).itype) = p_or; ;}
    break;

  case 657:
#line 2082 "parse.y"
    { ((*yyvalp).itype) = p_not; ;}
    break;

  case 658:
#line 2083 "parse.y"
    { ((*yyvalp).itype) = p_xor; ;}
    break;

  case 659:
#line 2084 "parse.y"
    { ((*yyvalp).itype) = p_shl; ;}
    break;

  case 660:
#line 2085 "parse.y"
    { ((*yyvalp).itype) = p_shr; ;}
    break;

  case 661:
#line 2091 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 662:
#line 2092 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 663:
#line 2093 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 664:
#line 2094 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 665:
#line 2095 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMult", "*"); ;}
    break;

  case 666:
#line 2096 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RDiv", "/"); ;}
    break;

  case 667:
#line 2097 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Div"); ;}
    break;

  case 668:
#line 2098 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Mod"); ;}
    break;

  case 669:
#line 2099 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RPower", "**"); ;}
    break;

  case 670:
#line 2100 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("In"); ;}
    break;

  case 671:
#line 2101 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LT", "<"); ;}
    break;

  case 672:
#line 2102 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("EQ", "="); ;}
    break;

  case 673:
#line 2103 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GT", ">"); ;}
    break;

  case 674:
#line 2104 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("NE", "<>"); ;}
    break;

  case 675:
#line 2105 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GE", ">="); ;}
    break;

  case 676:
#line 2106 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LE", "<="); ;}
    break;

  case 677:
#line 2107 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("And"); ;}
    break;

  case 678:
#line 2108 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SAnd", "&"); ;}
    break;

  case 679:
#line 2109 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Or"); ;}
    break;

  case 680:
#line 2110 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SOr", "|"); ;}
    break;

  case 681:
#line 2111 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SymDiff", "<>"); ;}
    break;

  case 684:
#line 2117 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilPlus", "+>"); ;}
    break;

  case 685:
#line 2118 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMinus", "->"); ;}
    break;

  case 686:
#line 2119 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorPlus", "+<"); ;}
    break;

  case 687:
#line 2120 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMinus", "-<"); ;}
    break;

  case 688:
#line 2124 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMult", "*>"); ;}
    break;

  case 689:
#line 2125 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilRDiv", "/>"); ;}
    break;

  case 690:
#line 2126 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMult", "*<"); ;}
    break;

  case 691:
#line 2127 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorRDiv", "/<"); ;}
    break;

  case 694:
#line 2139 "parse.y"
    { ((*yyvalp).ttype) = numeric_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 695:
#line 2144 "parse.y"
    { ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 696:
#line 2149 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 697:
#line 2151 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 698:
#line 2153 "parse.y"
    {
        ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype));
        error ("comma missing after `%s'", IDENTIFIER_NAME (TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))));
        yyerrok;
      ;}
    break;

  case 699:
#line 2159 "parse.y"
    { error ("extra comma following identifier list"); ;}
    break;

  case 701:
#line 2165 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 702:
#line 2167 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 704:
#line 2173 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 705:
#line 2178 "parse.y"
    { warn_about_keyword_redeclaration (((*yyvalp).ttype), 1); ;}
    break;

  case 753:
#line 2233 "parse.y"
    { ((*yyvalp).ttype) = check_identifier ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 759:
#line 2246 "parse.y"
    { char c = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = make_identifier (&c, 1); ;}
    break;

  case 760:
#line 2253 "parse.y"
    { pushlevel_expand (0); ;}
    break;

  case 761:
#line 2258 "parse.y"
    { poplevel_expand (0, 1); ;}
    break;

  case 762:
#line 2263 "parse.y"
    { lex_const_equal = 0; ;}
    break;

  case 763:
#line 2268 "parse.y"
    { defining_packed_type += ((*yyvalp).itype) = !co->ignore_packed;  /* can be nested */ ;}
    break;

  case 764:
#line 2273 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_protected); ;}
    break;

  case 765:
#line 2278 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_module); ;}
    break;

  case 766:
#line 2283 "parse.y"
    { yyerrok; ;}
    break;

  case 767:
#line 2285 "parse.y"
    { yyerrok; ;}
    break;

  case 774:
#line 2302 "parse.y"
    { warning ("missing `.' at the end of program/unit/module"); ;}
    break;

  case 775:
#line 2307 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 776:
#line 2312 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;


    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
/* Line 751 of glr.c.  */
#line 7481 "parse.c"
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  /* `Use' the arguments.  */
  (void) yy0;
  (void) yy1;

  switch (yyn)
    {
      
    }
}

			      /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}

/** Number of symbols composing the right hand side of rule #RULE. */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

/** Left-hand-side symbol for rule #RULE. */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yyis_pact_ninf(yystate) \
  ((yystate) == YYPACT_NINF)

/** True iff LR state STATE has only a default reduction (regardless
 *  of token). */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yyis_pact_ninf (yypact[yystate]);
}

/** The default reduction for STATE, assuming it has one. */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yyis_table_ninf(yytable_value) \
  0

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *CONFLICTS to a pointer into yyconfl to 0-terminated list of
 *  conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
	        int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yyis_table_ninf (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yylhs)
{
  int yyr;
  yyr = yypgoto[yylhs - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yylhs - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

				/* GLRStates */

static void
yyaddDeferredAction (yyGLRStack* yystack, yyGLRState* yystate,
		     yyGLRState* rhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewItem;
  yynewItem = &yystack->yynextFree->yyoption;
  yystack->yyspaceLeft -= 1;
  yystack->yynextFree += 1;
  yynewItem->yyisState = yyfalse;
  yynewItem->yystate = rhs;
  yynewItem->yyrule = yyrule;
  yynewItem->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewItem;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

				/* GLRStacks */

/** Initialize SET to a singleton set containing an empty stack. */
static void
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  yyset->yystates[0] = NULL;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
}

/** Initialize STACK to a single empty stack, with total maximum
 *  capacity for all stacks of SIZE. */
static void
yyinitGLRStack (yyGLRStack* yystack, size_t yysize)
{
  yystack->yyerrflag = 0;
  yystack->yyerrState = 0;
  yynerrs = 0;
  yystack->yyspaceLeft = yysize;
  yystack->yynextFree = yystack->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystack->yynextFree[0]);
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;
  yyinitStateSet (&yystack->yytops);
}

#define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If STACK is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation. */
static void
yyexpandGLRStack (yyGLRStack* yystack)
{
#if YYSTACKEXPANDABLE
  yyGLRStack yynewStack;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yysize, yynewSize;
  size_t yyn;
  yysize = yystack->yynextFree - yystack->yyitems;
  if (YYMAXDEPTH <= yysize)
    yyFail (yystack, "parser stack overflow");
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yyinitGLRStack (&yynewStack, yynewSize);
  for (yyp0 = yystack->yyitems, yyp1 = yynewStack.yyitems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
	{
	  yyGLRState* yys0 = &yyp0->yystate;
	  yyGLRState* yys1 = &yyp1->yystate;
	  if (yys0->yypred != NULL)
	    yys1->yypred =
	      YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
	  if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != NULL)
	    yys1->yysemantics.yyfirstVal =
	      YYRELOC(yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
	}
      else
	{
	  yySemanticOption* yyv0 = &yyp0->yyoption;
	  yySemanticOption* yyv1 = &yyp1->yyoption;
	  if (yyv0->yystate != NULL)
	    yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
	  if (yyv0->yynext != NULL)
	    yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
	}
    }
  if (yystack->yysplitPoint != NULL)
    yystack->yysplitPoint = YYRELOC (yystack->yyitems, yynewStack.yyitems,
				 yystack->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystack->yytops.yysize; yyn += 1)
    if (yystack->yytops.yystates[yyn] != NULL)
      yystack->yytops.yystates[yyn] =
	YYRELOC (yystack->yyitems, yynewStack.yyitems,
		 yystack->yytops.yystates[yyn], yystate);
  YYFREE (yystack->yyitems);
  yystack->yyitems = yynewStack.yyitems;
  yystack->yynextFree = yynewStack.yynextFree + yysize;
  yystack->yyspaceLeft = yynewStack.yyspaceLeft - yysize;

#else

  yyFail (yystack, "parser stack overflow");
#endif
}

static void
yyfreeGLRStack (yyGLRStack* yystack)
{
  YYFREE (yystack->yyitems);
  yyfreeStateSet (&yystack->yytops);
}

/** Assuming that S is a GLRState somewhere on STACK, update the
 *  splitpoint of STACK, if needed, so that it is at least as deep as
 *  S. */
static inline void
yyupdateSplit (yyGLRStack* yystack, yyGLRState* yys)
{
  if (yystack->yysplitPoint != NULL && yystack->yysplitPoint > yys)
    yystack->yysplitPoint = yys;
}

/** Invalidate stack #K in STACK. */
static inline void
yymarkStackDeleted (yyGLRStack* yystack, int yyk)
{
  if (yystack->yytops.yystates[yyk] != NULL)
    yystack->yylastDeleted = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = NULL;
}

/** Undelete the last stack that was marked as deleted.  Can only be
    done once after a deletion, and only when all other stacks have
    been deleted. */
static void
yyundeleteLastStack (yyGLRStack* yystack)
{
  if (yystack->yylastDeleted == NULL || yystack->yytops.yysize != 0)
    return;
  yystack->yytops.yystates[0] = yystack->yylastDeleted;
  yystack->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystack->yylastDeleted = NULL;
}

static inline void
yyremoveDeletes (yyGLRStack* yystack)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystack->yytops.yysize)
    {
      if (yystack->yytops.yystates[yyi] == NULL)
	{
	  if (yyi == yyj)
	    {
	      YYDPRINTF ((stderr, "Removing dead stacks.\n"));
	    }
	  yystack->yytops.yysize -= 1;
	}
      else
	{
	  yystack->yytops.yystates[yyj] = yystack->yytops.yystates[yyi];
	  if (yyj != yyi)
	    {
	      YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
			  (unsigned long int) yyi, (unsigned long int) yyj));
	    }
	  yyj += 1;
	}
      yyi += 1;
    }
}

/** Shift to a new state on stack #K of STACK, corresponding to LR state
 * LRSTATE, at input position POSN, with (resolved) semantic value SVAL. */
static inline void
yyglrShift (yyGLRStack* yystack, int yyk, yyStateNum yylrState, size_t yyposn,
	    YYSTYPE yysval, YYLTYPE* yylocp)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yytrue;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yynewItem->yystate.yysemantics.yysval = yysval;
  yynewItem->yystate.yyloc = *yylocp;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

/** Shift stack #K of YYSTACK, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE. */
static inline void
yyglrShiftDefer (yyGLRStack* yystack, int yyk, yyStateNum yylrState,
		 size_t yyposn, yyGLRState* rhs, yyRuleNum yyrule)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yyfalse;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yynewItem->yystate.yysemantics.yyfirstVal = NULL;
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yyaddDeferredAction (yystack, &yynewItem->yystate, rhs, yyrule);
}

/** Pop the symbols consumed by reduction #RULE from the top of stack
 *  #K of STACK, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved. Set *VALP to the resulting value,
 *  and *LOCP to the computed location (if any).  Return value is as
 *  for userAction. */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystack, int yyk, yyRuleNum yyrule,
	    YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystack->yysplitPoint == NULL)
    {
      /* Standard special case: single stack. */
      yyGLRStackItem* rhs = (yyGLRStackItem*) yystack->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystack->yynextFree -= yynrhs;
      yystack->yyspaceLeft += yynrhs;
      yystack->yytops.yystates[0] = & yystack->yynextFree[-1].yystate;
      return yyuserAction (yyrule, yynrhs, rhs,
			   yyvalp, yylocp, yystack);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
	= yystack->yytops.yystates[yyk];
      for (yyi = 0; yyi < yynrhs; yyi += 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yystack->yytops.yystates[yyk] = yys;
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
			   yyvalp, yylocp, yystack);
    }
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(K, Rule)
#else
# define YY_REDUCE_PRINT(K, Rule)	\
do {					\
  if (yydebug)				\
    yy_reduce_print (K, Rule);		\
} while (0)

/*----------------------------------------------------------.
| Report that the RULE is going to be reduced on stack #K.  |
`----------------------------------------------------------*/

static inline void
yy_reduce_print (size_t yyk, yyRuleNum yyrule)
{
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu), ",
	     (unsigned long int) yyk, yyrule - 1,
	     (unsigned long int) yyrline[yyrule]);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytokenName (yyrhs[yyi]));
  YYFPRINTF (stderr, "-> %s\n", yytokenName (yyr1[yyrule]));
}
#endif

/** Pop items off stack #K of STACK according to grammar rule RULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with RULE and store its value with the
 *  newly pushed state, if FORCEEVAL or if STACK is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #K from
 *  the STACK. In this case, the (necessarily deferred) semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystack, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval)
{
  size_t yyposn = yystack->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystack->yysplitPoint == NULL)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YY_REDUCE_PRINT (yyk, yyrule);
      YYCHK (yydoAction (yystack, yyk, yyrule, &yysval, &yyloc));
      yyglrShift (yystack, yyk,
		  yyLRgotoState (yystack->yytops.yystates[yyk]->yylrState,
				 yylhsNonterm (yyrule)),
		  yyposn, yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystack->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystack->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
	   0 < yyn; yyn -= 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
		  "Reduced stack %lu by rule #%d; action deferred. Now in state %d.\n",
		  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
	if (yyi != yyk && yystack->yytops.yystates[yyi] != NULL)
	  {
	    yyGLRState* yyp, *yysplit = yystack->yysplitPoint;
	    yyp = yystack->yytops.yystates[yyi];
	    while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
	      {
		if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
		  {
		    yyaddDeferredAction (yystack, yyp, yys0, yyrule);
		    yymarkStackDeleted (yystack, yyk);
		    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
				(unsigned long int) yyk,
				(unsigned long int) yyi));
		    return yyok;
		  }
		yyp = yyp->yypred;
	      }
	  }
      yystack->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystack, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static int
yysplitStack (yyGLRStack* yystack, int yyk)
{
  if (yystack->yysplitPoint == NULL)
    {
      YYASSERT (yyk == 0);
      yystack->yysplitPoint = yystack->yytops.yystates[yyk];
    }
  if (yystack->yytops.yysize >= yystack->yytops.yycapacity)
    {
      yystack->yytops.yycapacity *= 2;
      yystack->yytops.yystates =
	(yyGLRState**) YYREALLOC (yystack->yytops.yystates,
				  (yystack->yytops.yycapacity
				   * sizeof yystack->yytops.yystates[0]));
    }
  yystack->yytops.yystates[yystack->yytops.yysize]
    = yystack->yytops.yystates[yyk];
  yystack->yytops.yysize += 1;
  return yystack->yytops.yysize-1;
}

/** True iff Y0 and Y1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols. */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
	   yyn = yyrhsLength (yyy0->yyrule);
	   yyn > 0;
	   yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
	if (yys0->yyposn != yys1->yyposn)
	  return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (Y0,Y1), (destructively) merge the
 *  alternative semantic values for the RHS-symbols of Y1 into the
 *  corresponding semantic value sets of the symbols of Y0. */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    if (yys0 == yys1)
      break;
    else if (! yys0->yyresolved && ! yys1->yyresolved)
      {
	yySemanticOption* yyz;
	for (yyz = yys0->yysemantics.yyfirstVal; yyz->yynext != NULL;
	     yyz = yyz->yynext)
	  continue;
	yyz->yynext = yys1->yysemantics.yyfirstVal;
      }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred. */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
	return 0;
      else
	return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yySemanticOption* yyoptionList,
				   yyGLRStack* yystack, YYSTYPE* yyvalp,
				   YYLTYPE* yylocp);

static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn, yyGLRStack* yystack)
{
  YYRESULTTAG yyflag;
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      yyflag = yyresolveStates (yys->yypred, yyn-1, yystack);
      if (yyflag != yyok)
	return yyflag;
      if (! yys->yyresolved)
	{
	  yyflag = yyresolveValue (yys->yysemantics.yyfirstVal, yystack,
				   &yys->yysemantics.yysval, &yys->yyloc
				  );
	  if (yyflag != yyok)
	    return yyflag;
	  yys->yyresolved = yytrue;
	}
    }
  return yyok;
}

static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystack,
	         YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs;

  yynrhs = yyrhsLength (yyopt->yyrule);
  YYCHK (yyresolveStates (yyopt->yystate, yynrhs, yystack));
  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  return yyuserAction (yyopt->yyrule, yynrhs,
		       yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
		       yyvalp, yylocp, yystack);
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == NULL)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule, (unsigned long int) (yys->yyposn + 1),
	       (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
	{
	  if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
	    YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]));
	  else
	    YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]),
		       (unsigned long int) (yystates[yyi - 1]->yyposn + 1),
		       (unsigned long int) yystates[yyi]->yyposn);
	}
      else
	yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static void
yyreportAmbiguity (yySemanticOption* yyx0, yySemanticOption* yyx1,
		   yyGLRStack* yystack)
{
  /* `Unused' warnings.  */
  (void) yyx0;
  (void) yyx1;

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif
  yyFail (yystack, "ambiguity detected");
}


/** Resolve the ambiguity represented by OPTIONLIST, perform the indicated
 *  actions, and return the result. */
static YYRESULTTAG
yyresolveValue (yySemanticOption* yyoptionList, yyGLRStack* yystack,
		YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yySemanticOption* yybest;
  yySemanticOption* yyp;
  int yymerge;

  yybest = yyoptionList;
  yymerge = 0;
  for (yyp = yyoptionList->yynext; yyp != NULL; yyp = yyp->yynext)
    {
      if (yyidenticalOptions (yybest, yyp))
	yymergeOptionSets (yybest, yyp);
      else
	switch (yypreference (yybest, yyp))
	  {
	  case 0:
	    yyreportAmbiguity (yybest, yyp, yystack);
	    break;
	  case 1:
	    yymerge = 1;
	    break;
	  case 2:
	    break;
	  case 3:
	    yybest = yyp;
	    yymerge = 0;
	    break;
	  }
    }

  if (yymerge)
    {
      int yyprec = yydprec[yybest->yyrule];
      YYCHK (yyresolveAction (yybest, yystack, yyvalp, yylocp));
      for (yyp = yybest->yynext; yyp != NULL; yyp = yyp->yynext)
	{
	  if (yyprec == yydprec[yyp->yyrule])
	    {
	      YYSTYPE yyval1;
	      YYLTYPE yydummy;
	      YYCHK (yyresolveAction (yyp, yystack, &yyval1, &yydummy));
	      yyuserMerge (yymerger[yyp->yyrule], yyvalp, &yyval1);
	    }
	}
      return yyok;
    }
  else
    return yyresolveAction (yybest, yystack, yyvalp, yylocp);
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystack)
{
  if (yystack->yysplitPoint != NULL)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystack->yytops.yystates[0];
	   yys != yystack->yysplitPoint;
	   yys = yys->yypred, yyn += 1)
	continue;
      YYCHK (yyresolveStates (yystack->yytops.yystates[0], yyn, yystack
			     ));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystack)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystack->yytops.yysize != 1 || yystack->yysplitPoint == NULL)
    return;

  for (yyp = yystack->yytops.yystates[0], yyq = yyp->yypred, yyr = NULL;
       yyp != yystack->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystack->yyspaceLeft += yystack->yynextFree - yystack->yyitems;
  yystack->yynextFree = ((yyGLRStackItem*) yystack->yysplitPoint) + 1;
  yystack->yyspaceLeft -= yystack->yynextFree - yystack->yyitems;
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;

  while (yyr != NULL)
    {
      yystack->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystack->yynextFree->yystate.yypred = & yystack->yynextFree[-1].yystate;
      yystack->yytops.yystates[0] = &yystack->yynextFree->yystate;
      yystack->yynextFree += 1;
      yystack->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystack, int yyk,
	           size_t yyposn, YYSTYPE* yylvalp, YYLTYPE* yyllocp
		  )
{
  int yyaction;
  const short int* yyconflicts;
  yyRuleNum yyrule;
  yySymbol* const yytokenp = yystack->yytokenp;

  while (yystack->yytops.yystates[yyk] != NULL)
    {
      yyStateNum yystate = yystack->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %d Entering state %d\n", yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
	{
	  yyrule = yydefaultAction (yystate);
	  if (yyrule == 0)
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      return yyok;
	    }
	  YYCHK (yyglrReduce (yystack, yyk, yyrule, yyfalse));
	}
      else
	{
	  if (*yytokenp == YYEMPTY)
	    {
	      YYDPRINTF ((stderr, "Reading a token: "));
	      yychar = YYLEX;
	      *yytokenp = YYTRANSLATE (yychar);
	      YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	    }
	  yygetLRActions (yystate, *yytokenp, &yyaction, &yyconflicts);

	  while (*yyconflicts != 0)
	    {
	      int yynewStack = yysplitStack (yystack, yyk);
	      YYDPRINTF ((stderr, "Splitting off stack %d from %d.\n",
			  yynewStack, yyk));
	      YYCHK (yyglrReduce (yystack, yynewStack,
				  *yyconflicts, yyfalse));
	      YYCHK (yyprocessOneStack (yystack, yynewStack, yyposn,
					yylvalp, yyllocp));
	      yyconflicts += 1;
	    }

	  if (yyisShiftAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "On stack %d, ", yyk));
	      YY_SYMBOL_PRINT ("shifting", *yytokenp, yylvalp, yyllocp);
	      yyglrShift (yystack, yyk, yyaction, yyposn+1,
			  *yylvalp, yyllocp);
	      YYDPRINTF ((stderr, ", now in state #%d\n",
			  yystack->yytops.yystates[yyk]->yylrState));
	      break;
	    }
	  else if (yyisErrorAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      break;
	    }
	  else
	    YYCHK (yyglrReduce (yystack, yyk, -yyaction, yyfalse));
	}
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystack,
		     YYSTYPE* yylvalp, YYLTYPE* yyllocp)
{
  /* `Unused' warnings. */
  (void) yylvalp;
  (void) yyllocp;

  if (yystack->yyerrState == 0)
    {
#if YYERROR_VERBOSE
      yySymbol* const yytokenp = yystack->yytokenp;
      int yyn;
      yyn = yypact[yystack->yytops.yystates[0]->yylrState];
      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  size_t yysize = 0;
	  const char* yyprefix;
	  char* yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += strlen (yyprefix) + strlen (yytokenName (yyx));
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
		yyprefix = " or ";
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + strlen (yytokenName (*yytokenp)));
	  yymsg = (char*) YYMALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char* yyp = yymsg;
	      sprintf (yyp, "syntax error%s%s",
		       (*yytokenp == YYEMPTY ? "" : ", unexpected "),
		       yytokenName (*yytokenp));
	      yyp += strlen (yyp);
	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			sprintf (yyp, "%s%s", yyprefix, yytokenName (yyx));
			yyp += strlen (yyp);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYFREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
      yynerrs += 1;
    }
}

/* Recover from a syntax error on YYSTACK, assuming that YYTOKENP,
   YYLVALP, and YYLLOCP point to the syntactic category, semantic
   value, and location of the look-ahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystack,
		      YYSTYPE* yylvalp,
		      YYLTYPE* yyllocp
		      )
{
  yySymbol* const yytokenp = yystack->yytokenp;
  size_t yyk;
  int yyj;

  if (yystack->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
	if (*yytokenp == YYEOF)
	  {
	    /* Now pop stack until empty and fail. */
	    while (yystack->yytops.yystates[0] != NULL)
	      {
		yyGLRState *yys = yystack->yytops.yystates[0];
		yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
		yydestruct ("Error: popping",
                            yystos[yys->yylrState],
			    &yys->yysemantics.yysval, &yys->yyloc);
		yystack->yytops.yystates[0] = yys->yypred;
		yystack->yynextFree -= 1;
		yystack->yyspaceLeft += 1;
	      }
	    yyFail (yystack, NULL);
	  }
	if (*yytokenp != YYEMPTY)
	  {
	    /* We throw away the lookahead, but the error range
	       of the shifted error token must take it into account. */
	    yyGLRState *yys = yystack->yytops.yystates[0];
	    yyGLRStackItem yyerror_range[3];
	    yyerror_range[1].yystate.yyloc = yys->yyloc;
	    yyerror_range[2].yystate.yyloc = *yyllocp;
	    YYLLOC_DEFAULT (yys->yyloc, yyerror_range, 2);
	    yydestruct ("Error: discarding",
			*yytokenp, yylvalp, yyllocp);
	  }
	YYDPRINTF ((stderr, "Reading a token: "));
	yychar = YYLEX;
	*yytokenp = YYTRANSLATE (yychar);
	YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	yyj = yypact[yystack->yytops.yystates[0]->yylrState];
	if (yyis_pact_ninf (yyj))
	  return;
	yyj += *yytokenp;
	if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != *yytokenp)
	  {
	    if (yydefact[yystack->yytops.yystates[0]->yylrState] != 0)
	      return;
	  }
	else if (yytable[yyj] != 0 && ! yyis_table_ninf (yytable[yyj]))
	  return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystack->yytops.yysize; yyk += 1)
    if (yystack->yytops.yystates[yyk] != NULL)
      break;
  if (yyk >= yystack->yytops.yysize)
    yyFail (yystack, NULL);
  for (yyk += 1; yyk < yystack->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystack, yyk);
  yyremoveDeletes (yystack);
  yycompressStack (yystack);

  /* Now pop stack until we find a state that shifts the error token. */
  yystack->yyerrState = 3;
  while (yystack->yytops.yystates[0] != NULL)
    {
      yyGLRState *yys = yystack->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yyis_pact_ninf (yyj))
	{
	  yyj += YYTERROR;
	  if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
	      && yyisShiftAction (yytable[yyj]))
	    {
	      /* Shift the error token having adjusted its location.  */
	      YYLTYPE yyerrloc;
	      yystack->yyerror_range[2].yystate.yyloc = *yyllocp;
	      YYLLOC_DEFAULT (yyerrloc, yystack->yyerror_range, 2);
	      YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
			       yylvalp, &yyerrloc);
	      yyglrShift (yystack, 0, yytable[yyj],
			  yys->yyposn, *yylvalp, &yyerrloc);
	      yys = yystack->yytops.yystates[0];
	      break;
	    }
	}
      yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
      yydestruct ("Error: popping",
		  yystos[yys->yylrState],
	          &yys->yysemantics.yysval, &yys->yyloc);
      yystack->yytops.yystates[0] = yys->yypred;
      yystack->yynextFree -= 1;
      yystack->yyspaceLeft += 1;
    }
  if (yystack->yytops.yystates[0] == NULL)
    yyFail (yystack, NULL);
}

#define YYCHK1(YYE)							     \
  do {									     \
    switch (YYE) {							     \
    default:								     \
      break;								     \
    case yyabort:							     \
      yystack.yyerrflag = 1;						     \
      goto yyDone;							     \
    case yyaccept:							     \
      yystack.yyerrflag = 0;						     \
      goto yyDone;							     \
    case yyerr:								     \
      goto yyuser_error;						     \
    }									     \
  } while (0)


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
  yySymbol yytoken;
  yyGLRStack yystack;
  size_t yyposn;


  YYSTYPE* const yylvalp = &yylval;
  YYLTYPE* const yyllocp = &yylloc;

  yyinitGLRStack (&yystack, YYINITDEPTH);
  yystack.yytokenp = &yytoken;

  YYDPRINTF ((stderr, "Starting parse\n"));

  if (setjmp (yystack.yyexception_buffer) != 0)
    goto yyDone;

  yylval = yyval_default;

#if YYLTYPE_IS_TRIVIAL
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif


  yyglrShift (&yystack, 0, 0, 0, yylval, &yylloc);
  yytoken = YYEMPTY;
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
	 specialized to deterministic operation (single stack, no
	 potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
	{
	  yyRuleNum yyrule;
	  int yyaction;
	  const short int* yyconflicts;

	  yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
	  if (yystate == YYFINAL)
	    goto yyDone;
	  if (yyisDefaultedState (yystate))
	    {
	      yyrule = yydefaultAction (yystate);
	      if (yyrule == 0)
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue));
	    }
	  else
	    {
	      if (yytoken == YYEMPTY)
		{
		  YYDPRINTF ((stderr, "Reading a token: "));
		  yychar = YYLEX;
		  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, yylvalp, yyllocp);
		}
	      yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
	      if (*yyconflicts != 0)
		break;
	      if (yyisShiftAction (yyaction))
		{
		  YY_SYMBOL_PRINT ("Shifting", yytoken, yylvalp, yyllocp);
		  if (yytoken != YYEOF)
		    yytoken = YYEMPTY;
		  yyposn += 1;
		  yyglrShift (&yystack, 0, yyaction, yyposn,
		              yylval, yyllocp);
		  if (0 < yystack.yyerrState)
		    yystack.yyerrState -= 1;
		}
	      else if (yyisErrorAction (yyaction))
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      else
		YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue));
	    }
	}

      while (yytrue)
	{
	  int yys;
	  int yyn = yystack.yytops.yysize;
	  for (yys = 0; yys < yyn; yys += 1)
	    YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn,
				       yylvalp, yyllocp));
	  yytoken = YYEMPTY;
	  yyposn += 1;
	  yyremoveDeletes (&yystack);
	  if (yystack.yytops.yysize == 0)
	    {
	      yyundeleteLastStack (&yystack);
	      if (yystack.yytops.yysize == 0)
		yyFail (&yystack, "syntax error");
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
	      yyreportSyntaxError (&yystack, yylvalp, yyllocp);
	      goto yyuser_error;
	    }
	  else if (yystack.yytops.yysize == 1)
	    {
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yycompressStack (&yystack);
	      break;
	    }
	}
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack, yylvalp, yyllocp);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }
 yyDone:
  /* On YYABORT, free the lookahead. */
  if (yystack.yyerrflag == 1 && yytoken != YYEMPTY)
    yydestruct ("Error: discarding lookahead",
                yytoken, yylvalp, yyllocp);

  yyfreeGLRStack (&yystack);
  return yystack.yyerrflag;
}

/* DEBUGGING ONLY */
#ifdef YYDEBUG
static void yypstack (yyGLRStack* yystack, int yyk) ATTRIBUTE_UNUSED;
static void yypdumpstack (yyGLRStack* yystack) ATTRIBUTE_UNUSED;

static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      fprintf (stderr, " -> ");
    }
  fprintf (stderr, "%d@%lu", yys->yylrState, (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == NULL)
    fprintf (stderr, "<null>");
  else
    yy_yypstack (yyst);
  fprintf (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystack, int yyk)
{
  yypstates (yystack->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)							     \
    ((YYX) == NULL ? -1 : (yyGLRStackItem*) (YYX) - yystack->yyitems)


static void
yypdumpstack (yyGLRStack* yystack)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystack->yyitems; yyp < yystack->yynextFree; yyp += 1)
    {
      fprintf (stderr, "%3lu. ", (unsigned long int) (yyp - yystack->yyitems));
      if (*(yybool *) yyp)
	{
	  fprintf (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
		   yyp->yystate.yyresolved, yyp->yystate.yylrState,
		   (unsigned long int) yyp->yystate.yyposn,
		   (long int) YYINDEX (yyp->yystate.yypred));
	  if (! yyp->yystate.yyresolved)
	    fprintf (stderr, ", firstVal: %ld",
		     (long int) YYINDEX (yyp->yystate.yysemantics.yyfirstVal));
	}
      else
	{
	  fprintf (stderr, "Option. rule: %d, state: %ld, next: %ld",
		   yyp->yyoption.yyrule,
		   (long int) YYINDEX (yyp->yyoption.yystate),
		   (long int) YYINDEX (yyp->yyoption.yynext));
	}
      fprintf (stderr, "\n");
    }
  fprintf (stderr, "Tops:");
  for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
    fprintf (stderr, "%lu: %ld; ", (unsigned long int) yyi,
	     (long int) YYINDEX (yystack->yytops.yystates[yyi]));
  fprintf (stderr, "\n");
}
#endif


#line 2315 "parse.y"


/* Check the order of declarations for various standards */
static int
check_decl_order (int prev, int new)
{
  int prev_decl_order = prev / 2, prev_import = prev & 1;
  if (new == od_none)
    return prev;
  if (new <= prev_decl_order && new < od_routine)
    chk_dialect ("mixed order of declaration parts is", NOT_CLASSIC_PASCAL);
  if (new == od_uses)
    {
      if (prev_import)
        chk_dialect ("multiple `uses' parts are", GNU_PASCAL);
      if (prev_decl_order > od_uses)
        chk_dialect ("`uses' after other declarations is", GNU_PASCAL);
      prev_import = 1;
    }
  return (2 * new) | prev_import;
}

static void
locations (YYLTYPE *dest, const /*YYLTYPE*/ union yyGLRStackItem *src, int n)
{
  int i;
  for (i = n; i > 0 && !YYRHSLOC (src, i).first_line; i--) ;
  if (i == 0)
    {
      input_filename = compiler_filename;
      lineno = compiler_lineno;
      column = compiler_column;
      dest->first_file = dest->last_file = NULL;
      dest->first_line = dest->last_line = dest->first_column = dest->last_column = 0;
    }
  else
    {
      input_filename = compiler_filename = dest->last_file = YYRHSLOC (src, i).last_file;
      lineno = compiler_lineno = dest->last_line = YYRHSLOC (src, i).last_line;
      column = compiler_column = dest->last_column = YYRHSLOC (src, i).last_column;
      for (i = 1; i <= n && !YYRHSLOC (src, i).first_line; i++) ;
      dest->first_file = YYRHSLOC (src, i).first_file;
      dest->first_line = YYRHSLOC (src, i).first_line;
      dest->first_column = YYRHSLOC (src, i).first_column;
      /* This does emit a few line notes too many. But putting line notes in the
         parser in the right places causes some conflicts (especially
         assignments with nontrivial expressions on their left side are
         problematic). A better solution might be possible when we don't emit
         things so early. */
      if (current_function_decl)
#ifndef GCC_3_4
        emit_line_note (dest->first_file, dest->first_line);
#else
        {
          location_t loc_aux;
          loc_aux.file = dest->first_file;
          loc_aux.line = dest->first_line;
          emit_line_note (loc_aux);
        }
#endif
    }
  dest->option_id = 0;
  for (i = 1; i <= n; i++)
    while (YYRHSLOC (src, i).option_id > compiler_options->counter)
      {
        struct options *tmp = compiler_options;
        compiler_options = tmp->next;
        free (tmp);
      }
  if (compiler_options != co)
    activate_options (compiler_options, 0);
}

/* Set the value of the 'yydebug' variable to VALUE. This is a function
   so we don't have to have YYDEBUG defined in order to build the compiler. */
void
set_yydebug (int value)
{
#if YYDEBUG != 0
  yydebug = value;
#else
  warning ("YYDEBUG not defined.");
#endif
}

#undef yyparse
int
yyparse (void)
{
  init_predef ();
  return main_yyparse ();
}

